#ifndef CIAO_SERIAL0_H
#define CIAO_SERIAL0_H

// configuration
// #define cfCIAO_SERIAL0_IMPL_HW
// #define cfCIAO_SERIAL0_IMPL_OS

#include "macros.h"


// configuration flags, should come from p::v
#ifdef cfCIAO_SERIAL0_IMPL_HW
	#define cfCIAO_SERIAL0_IMPL hw::hal::Serial0
	#define cfCIAO_SERIAL0_IMPL_HEADER "hw/hal/Serial0.h"
#else
	#define cfCIAO_SERIAL0_IMPL os::dev::std::Serial0
	#define cfCIAO_SERIAL0_IMPL_HEADER "os/dev/std/Serial0.h"
#endif

#ifndef cfCIAO_DECOUPLE
	#include cfCIAO_SERIAL0_IMPL_HEADER
#endif



namespace ciao {
namespace dev {
namespace std {


class CIAO_CLASS( Serial0, cfCIAO_SERIAL0_IMPL) {
	CIAO_CLASS_BODY( Serial0, cfCIAO_SERIAL0_IMPL );

public:
// methods defined by both, os::dev::std::Serial0 and hw::hal::Serial0
	bool send( char ch );
	
// additional methods, only defined by os::dev::std::Serial0 
#ifndef cfCIAO_SERIAL0_IMPL_HW
	bool send( const char* buf );
#endif

};

}}}	// namespace ciao::dev::std


#ifdef cfCIAO_INLINE
	#include "Serial0.inl"
#endif


#endif // CIAO_SERIAL0_H
