#ifndef HW_HAL_CANONICAL_H	
#define HW_HAL_CANONICAL_H

namespace hw { namespace hal {

class Canonical {
	static Canonical theCanonical_;	// the one-and-only instance of hw::hal::Canonical(*@\label{canonical_singleton}@*)
																	// theCanonical_ is *only* accessed by Inst()

	void init();										// [OPTIONAL] startup time initialization function. (*@\label{canonical_init}@*)
																	// only called by a corresponding _Init aspect 

  protected:		
	Canonical() {}									// constructor, must be declared protected, (*@\label{canonical_const}@*)
																	// must be defined, but may be empty. 
																	// Initalization itself is done in Init()
  public:
	static Canonical& Inst() {			// the singleton access function			(*@\label{canonical_Inst}@*)
		return theCanonical_;	
	}

	void reset();										// [OPTIONAL] user callable (re-)initialization function (*@\label{canonical_reset}@*)

	// selectors, modifiers, operations 
	void operation_A( int );

};
	
}}	// namespace hw::hal

#endif // HW_HAL_CANONICAL 