$VAR1 = {
	'vname' => 'os-core',
	'name' => 'ciao',
	'dir' => 'src',
	'comp' => [
	{
		'vname' => 'Base Actions',
		'name' => 'ciao_base',
		'comp' => [
		{
			'vname' => 'Doxygen Components',
			'name' => 'ciao_base_doyxgen',
			'comp' => [
			{
				'dir' => '',
				'file' => 'doxygen.conf'
			}
			]
		},
		{
			'vname' => 'Makefile Components',
			'name' => 'ciao_base_make',
			'dir' => 'make',
			'comp' => [
			{
				'files' => [
				'standard.mk',
				'cplinks.mk',
				'gcc.mk',
				'compile.mk',
				'archive.mk',
				'tar.mk',
				'doxygen.mk',
				'ciao.mk',
				'generate.mk'
				]
			},
			{
				'vname' => 'Generators',
				'comp' => [
				{
					'dir' => './generator',
					'srcdir' => '../tools/generator/runtime',
					'files' => [
					'_os_cfAppAttribs.h.PL',
					'app_pointcuts.h.xsl',
					'bind.ah.pl',
					'main.cpp.pl',
					'objects.h.pl',
					'SystemConfiguration.pm',
					'UCInfo.h.xsl',
					'ldciao.x.pl'
					]
				},
				{
					'dir' => './',
					'srcdir' => '../tools/generator',
					'file' => 'common.xsl'
				}
				]
			},
			{
				'dir' => '',
				'file' => 'Makefile'
			},
			{
				'generate' => 'generate_arch_makefile();',
				'file' => 'architecture.mk'
			},
			{
				'symlink' => 'gcc',
				'dir' => 'make'
			},
			{
				'dir' => 'src',
				'file' => 'Makefile'
			}
			]
		},
		{
			'vname' => 'Platform Definition Flags',
			'name' => 'ciao_base_arch',
			'comp' => [
			{
				'name' => 'ciaoARCH_xxx',
				'comp' => [
				{
					'dir' => 'src/hw',
					'generate' => 'helper_ciaoHW();',
					'file' => 'ciaoHW.h'
				}
				]
			},
			{
				'name' => 'ciaoPLATFORM_xxx',
				'comp' => [
				{
					'dir' => 'src/hw',
					'generate' => 'helper_ciaoHW();',
					'file' => 'ciaoHW.h'
				}
				]
			},
			{
				'name' => 'ciaoARCH',
				'comp' => [
				{
					'dir' => 'src/hw',
					'generate' => 'helper_ciaoHW();',
					'file' => 'ciaoHW.h'
				}
				]
			}
			]
		},
		{
			'vname' => 'Top-level Standard Include Files',
			'name' => 'ciao_base_stdinc',
			'comp' => [
			{
				'files' => [
				'ciaoConfig.h',
				'ciaoTypes.h',
				'stdinc.h',
				'sourcedoc.h'
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'Standard C Library support functions',
		'name' => 'ciao_libcsupport',
		'depends' => '&lib_libc',
		'dir' => 'libcmini',
		'files' => [
			'Makefile',
			'libc_compat.cpp',
		],
	},
	{
		'vname' => 'Minimal C Runtime Library',
		'name' => 'ciao_libcmini',
		'depends' => '&lib_libcmini',
		'dir' => 'libcmini',
		'files' => [
		'stdarg.h',
		'stddef.h',
		'stdio.h',
		'stdlib.h',
		'string.h',
		'Makefile',
		'string.c',
		'stdlib.c',
		'unistd.h',
		'vprintf.c',
		'write.c'
		]
	},
	{
		'vname' => 'Utilities',
		'name' => 'ciao_util',
		'subdir' => '/util',
		'comp' => [
		{
			'vname' => 'Standard Headers',
			'name' => 'ciao_util_stdheaders',
			'comp' => [
			{
				'files' => [
				'macros.h',
				'types.h',
				'assert.h'
				]
			}
			]
		},
		{
			'vname' => 'Architecture-specific Standard Headers',
			'name' => 'ciao_util_archheaders',
			'subdir' => '!ARCH',
			'comp' => [
			{
				'files' => [
				'compiler.h',
				'intrinsics.h',
				'types_arch.h'
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'init()-Support',
		'name' => 'ciao_init',
		'subdir' => '/os',
		'comp' => [
		{
			'vname' => 'os::init',
			'name' => 'ciao_os_init_func',
			'comp' => [
			{
				'files' => [
				'init.h',
				'init.cpp'
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'Memory Protection',
		'name' => 'ciao_memprot',
		'subdir' => '/os/mp',
		'comp' => [
		{
			'vname' => 'Common Files',
			'name' => 'ciao_memprot_common',
			'comp' => [
			{
				'files' => [
				'common_pointcuts.h'
				]
			}
			]
		},
		{
			'vname' => 'Enabled',
			'name' => 'ciao_memprot_enabled',
			'depends' => '&memprot',
			'comp' => [
			{
				'vname' => 'Common Files',
				'name' => 'ciao_memprot_enabled_common',
				'comp' => [
				{
					'files' => [
					'app_pointcuts_dummy.h',
					'pointcuts.h'
					]
				}
				]
			},
			{
				'vname' => 'MPU',
				'name' => 'ciao_memprot_MPU',
				'classname' => 'os::mp::MPU',
				'comp' => [
				{
					'files' => [
					'MPU.h',
					'MPU_Init.ah',
					'MPU.cpp'
					]
				}
				]
			},
			{
				'vname' => 'Trusted',
				'name' => 'ciao_memprot_trusted',
				'depends' => '&memprot_trusted',
				'classname' => 'os_mp_Trusted',
				'comp' => [
				{
					'files' => [
					'Trusted.ah'
					]
				}
				]
			},
			{
				'vname' => 'Protect Task Stacks',
				'name' => 'ciao_memprot_stacks',
				'depends' => '&memprot_stacks',
				'classname' => 'os_mp_Stacks',
				'comp' => [
				{
					'files' => [
					'Stacks.ah'
					]
				}
				]
			},
			{
				'vname' => 'Stack Access for Untrusted ISRs',
				'name' => 'ciao_memprot_untrusted_isrstacks',
				'depends' => '(not &memprot_stacks) and &cfOS_ISR2_SUPPORT',
				'classname' => 'os_mp_UntrustedISR_Stacks',
				'comp' => [
				{
					'files' => [
					'UntrustedISR_Stacks.ah'
					]
				}
				]
			},
			{
				'vname' => 'Execution Protection disabled',
				'name' => 'ciao_memprot_notexecution',
				'depends' => 'not &memprot_x',
				'classname' => 'os_mp_NotExecution',
				'comp' => [
				{
					'files' => [
					'NotExecution.ah'
					]
				}
				]
			},
			{
				'vname' => 'NotRead',
				'name' => 'ciao_memprot_notread',
				'depends' => 'not &memprot_r',
				'classname' => 'os_mp_NotRead',
				'comp' => [
				{
					'files' => [
					'NotRead.ah'
					]
				}
				]
			},
			{
				'vname' => 'Lower Stackbound',
				'name' => 'ciao_memprot_stack_l',
				'depends' => '&memprot_stacks or &memprot_ntf or &cfOS_ISR2_SUPPORT or &memprot_trusted',
				'classname' => 'os_mp_Context_LowerStackBound',
				'comp' => [
				{
					'files' => [
					'Context_LowerStackBound.ah',
					'LowerStackBound_ContextAccessSlices.ah',
					'LowerStackBound_ContextContainerSlice.ah'
					]
				}
				]
			},
			{
				'vname' => 'Memory Protection Context Management',
				'name' => 'ciao_memprot_context',
				'comp' => [
				{
					'vname' => 'MP-Context Resides in Task Objects',
					'name' => 'ciao_memprot_context_intask',
					'comp' => [
					{
						'vname' => 'ContextAccess_Task',
						'name' => 'ciao_memprot_context_access_task',
						'classname' => 'os::mp::ContextAccess_Task',
						'comp' => [
						{
							'files' => [
							'ContextAccess_Task.h'
							]
						}
						]
					},
					{
						'srcfile' => 'Context_Manifestation_Task.ah',
						'file' => 'Context_Manifestation.ah'
					}
					]
				},
				{
					'vname' => 'Context',
					'name' => 'ciao_memprot_Context',
					'classname' => 'os::mp::Context',
					'comp' => [
					{
						'files' => [
						'Context.h'
						]
					}
					]
				},
				{
					'vname' => 'Context_Switch',
					'name' => 'ciao_memprot_context_switch',
					'depends' => '&memprot_apps or &memprot_ntf',
					'classname' => 'os_mp_Context_Switch',
					'comp' => [
					{
						'files' => [
						'Context_Switch.ah'
						]
					}
					]
				},
				{
					'vname' => 'Context_SliceOrder (internal)',
					'name' => 'ciao_memprot_context_sliceorder',
					'classname' => 'os_mp_Context_SliceOrder',
					'comp' => [
					{
						'files' => [
						'Context_SliceOrder.ah'
						]
					}
					]
				}
				]
			},
			{
				'vname' => 'Protection of Non-Trusted Applications',
				'name' => 'ciao_memprot_apps',
				'comp' => [
				{
					'vname' => 'AppData',
					'name' => 'ciao_memprot_data',
					'depends' => '&memprot_apps',
					'classname' => 'os_mp_Data',
					'comp' => [
					{
						'files' => [
						'AppData.ah',
						'AppData_AppSlice.ah'
						]
					}
					]
				},
				{
					'vname' => 'Apps',
					'name' => 'ciao_memprot_appprot_aspect',
					'classname' => 'os_mp_Apps',
					'comp' => [
					{
						'files' => [
						'Apps.ah',
						'Apps_AppSlice.ah'
						]
					}
					]
				}
				]
			},
			{
				'vname' => 'Non-Trusted Functions',
				'name' => 'ciao_memprot_ntf',
				'depends' => '&memprot_ntf',
				'comp' => [
				{
					'vname' => 'Non-Trusted Functions',
					'name' => 'ciao_memprot_ntf_aspect',
					'classname' => 'os_mp_NonTrustedFunctions',
					'comp' => [
					{
						'files' => [
						'NonTrustedFunctions.ah',
						'NonTrustedFunctions_ContextAccessSlices.ah',
						'NonTrustedFunctions_ContextContainerSlice.ah'
						]
					}
					]
				},
				{
					'vname' => 'Manage Exported Stacks (and those only)',
					'name' => 'ciao_memprot_stack_exportonly',
					'depends' => 'not &memprot_stacks',
					'classname' => 'os_mp_Stacks_ExportOnly',
					'comp' => [
					{
						'files' => [
						'Stacks_ExportOnly.ah',
						'Stacks_ExportOnly_ContextAccessSlices.ah',
						'Stacks_ExportOnly_ContextContainerSlice.ah'
						]
					}
					]
				}
				]
			},
			{
				'vname' => 'Deferred System Services',
				'name'  => 'ciao_memprot_deferred_syscalls',
				'depends' => '&memprot_deferact or &memprot_defereve',
				'comp' => [
				{
					'vname' => 'Deferrable Checker',
					'name'  => 'ciao_memprot_deferred_activation',
					'comp' => [
					{
						'vname' => 'NonPreemptive',
						'depends' => '&kernel_nonpreemptive',
						'file' => 'DeferredActivation_TaskSlice_NonPreemptive.ah',
					},
					{
						'vname' => 'Preemptive',
						'depends' => 'not &kernel_nonpreemptive',
						'file' => 'DeferredActivation_TaskSlice_Preemptive.ah',
					},
					]
				},
				{
					'vname' => 'Deferred Task Activation',
					'name'  => 'ciao_memprot_deferred_activation',
					'depends' => '&memprot_deferact',
					'comp' => [
					{
						file => 'DeferredActivation.ah',
					},
					{
						'vname' => 'Activation Counter',
						'name'  => 'ciao_memprot_deferred_activation_counter',
						'depends' => '&kernel_multipleactivation',
						'comp' => [
						{
							file => 'DeferredActivation_AppSlice.ah',
							srcfile => 'DeferredActivation_AppSlice_ActivationCounter.ah',
						},
						],
					},
					{
						'vname' => 'Bitmap',
						'name'  => 'ciao_memprot_deferred_activation_bitmap',
						'depends' => 'not &kernel_multipleactivation',
						'comp' => [
						{
							file => 'DeferredActivation_AppSlice.ah',
							srcfile => 'DeferredActivation_AppSlice_Bitmap.ah',
						},
						],
					},
					]
				},
				{
					'vname' => 'Deferred Event Delivery',
					'name'  => 'ciao_memprot_deferred_events',
					'depends' => '&memprot_defereve',
					'comp' => [
					{
						files => [
							'DeferredEvents.ah',
							'DeferredEvents_AppSlice.ah',
						],
					}
					],
				},
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'Timing Protection',
		'name' => 'ciao_timeprot',
		'subdir' => '/os/tp',
		'comp' => [
		{
			'vname' => 'Timing Protection Enabled',
			'name' => 'ciao_timeprot_enabled',
			'depends' => '&timeprot',
			'comp' => [
			{
				'vname' => 'Timing Protection Files',
				'name' => 'ciao_timeprot_enabled_common',
				'comp' => [
				{
					'files' => [
					'TP_common_aspects.ah',
					'TP_common_definitions.h',
					'TP_common_data.h',
					'UCInfo_dummy.h',
					'TP_common_data.cpp',
					'TP_common_queue.h',
					'TP_common_queueelement.h',
					'TP_common_deadlinecause.h'
					]
				}
				]
			},
			{
				'vname' => 'Execution Time Budget for Tasks',
				'name' => 'ciao_timeprot_ETB_Task',
				'comp' => [
				{
					'files' => [
					'ETB_Task.ah'
					]
				}
				]
			},
			{
				'vname' => 'Execution Time Budget for ISR2',
				'name' => 'ciao_timeprot_ETB_ISR',
				'comp' => [
				{
					'files' => [
					'ETB_ISR.ah'
					]
				}
				]
			},
			{
				'vname' => 'Execution Time Budget: Common Slice',
				'name' => 'ciao_timeprot_ETB_Slice',
				'comp' => [
				{
					'files' => [
					'ETB_Slices.ah'
					]
				}
				]
			},
			{
				'vname' => 'Inter Arrival Rate: ISR2',
				'name' => 'ciao_timeprot_AR_ISR',
				'classname' => 'os_tp_Slices',
				'comp' => [
				{
					'files' => [
					'AR_ISR.ah'
					]
				}
				]
			},
			{
				'vname' => 'Inter Arrival Rate: Tasks',
				'name' => 'ciao_timeprot_AR_Task',
				'classname' => 'os_tp_Slices',
				'comp' => [
				{
					'files' => [
					'AR_Task.ah'
					]
				}
				]
			},
			{
				'vname' => 'Inter Arrival Rate: Common Slice',
				'name' => 'ciao_timeprot_AR_Slice',
				'comp' => [
				{
					'files' => [
					'AR_Slices.ah'
					]
				}
				]
			},
			{
				'vname' => 'Locking Time Budget: Resource Locking: Common Files',
				'name' => 'ciao_timeprot_LTB_Resource_common',
				'comp' => [
				{
					'files' => [
					'LTB_ResourceLocking_Slice.ah'
					]
				}
				]
			},
			{
				'vname' => 'Locking Time Budget: ISR Disabling: Common Files',
				'name' => 'ciao_timeprot_LTB_ISR_common',
				'comp' => [
				{
					'files' => [
					'LTB_ISRLocking_Slice.ah'
					]
				}
				]
			},
			{
				'vname' => 'Locking Time Budget: Resource Locking: Monitoring of Tasks',
				'name' => 'ciao_timeprot_LTB_Resource_Task',
				'comp' => [
				{
					'files' => [
					'LTB_Task_ResourceLocking.ah'
					]
				}
				]
			},
			{
				'vname' => 'Locking Time Budget: Resource Locking: Monitoring of ISR2',
				'name' => 'ciao_timeprot_LTB_Resouce_ISR2',
				'comp' => [
				{
					'files' => [
					'LTB_ISR_ResourceLocking.ah'
					]
				}
				]
			},
			{
				'vname' => 'Locking Time Budget: ISR Disabling: Monitoring of Tasks',
				'name' => 'ciao_timeprot_LTB_ISR_Tasks',
				'comp' => [
				{
					'files' => [
					'LTB_Task_ISRLocking.ah'
					]
				}
				]
			},
			{
				'vname' => 'Locking Time Budget: ISR Disabling: Monitoring of ISR2',
				'name' => 'ciao_timeprot_LTB_ISR_ISR2',
				'comp' => [
				{
					'files' => [
					'LTB_ISR_ISRLocking.ah'
					]
				}
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'Kernel',
		'name' => 'kernel',
		'subdir' => '/os/krn',
		'comp' => [
		{
			'vname' => 'Basic Kernel Components',
			'name' => 'kernel_basic',
			'comp' => [
			{
				'vname' => 'before_enter() / after_leave()',
				'name' => 'kernel_enterleave',
				'comp' => [
				{
					'files' => [
					'EnterLeave.h',
					'EnterLeave.cpp'
					]
				}
				]
			},
			{
				'name' => 'AdviceOrder',
				'comp' => [
				{
					'files' => [
					'AdviceOrder.ah'
					]
				}
				]
			}
			]
		},
		{
			'name' => 'Hooks',
			'comp' => [
			{
				'name' => 'ErrorHook',
				'depends' => '&kernel_errorhook',
				'comp' => [
				{
					'files' => [
					'Hooks_ErrorHook.ah',
					'Hooks_ErrorHook_Slice.ah'
					]
				}
				]
			},
			{
				'name' => 'StartupShutdownPreTaskPostTaskHook',
				'depends' => '&kernel_startupshutdownpretaskposttaskhook',
				'comp' => [
				{
					'files' => [
					'Hooks_StartupShutdownPreTaskPostTask.ah',
					'Hooks_StartupShutdownPreTaskPostTask_Slice.ah'
					]
				}
				]
			},
			{
				'name' => 'ProtectionHookDefault',
				'depends' => '&kernel_protectionhookdefault',
				'comp' => [
				{
					'files' => [
					'Hooks_ProtectionHook_Default.ah'
					]
				}
				]
			}
			]
		},
		{
			'vname' => 'OS Control',
			'name' => 'kernel_oscontrol',
			'depends' => '&kernel_oscontrol',
			'comp' => [
			{
				'name' => 'OSControl',
				'comp' => [
				{
					'files' => [
					'OSControl.h',
					'OSControl.cpp'
					]
				}
				]
			},
			{
				'name' => 'AppMode',
				'comp' => [
				{
					'files' => [
					'AppMode.h'
					]
				}
				]
			}
			]
		},
		{
			'vname' => 'System Abstractions',
			'name' => 'kernel_abstractions',
			'comp' => [
			{
				'vname' => 'Resources',
				'name' => 'kernel_resources',
				'depends' => '&kernel_resources',
				'comp' => [
				{
					'name' => 'ResourceSupport',
					'comp' => [
					{
						'files' => [
						'ResourceSupport.ah',
						'ResourceSupport_Slice.ah'
						]
					}
					]
				},
				{
					'name' => 'Resource',
					'classname' => 'Resource',
					'comp' => [
					{
						'files' => [
						'Resource.h'
						]
					}
					]
				},
				{
					'name' => 'ResourceSupport_PCP',
					'depends' => '&kernel_pcp',
					'comp' => [
					{
						'files' => [
						'ResourceSupport_PCP.ah'
						]
					}
					]
				}
				]
			},
			{
				'name' => 'kernel_events',
				'depends' => '&kernel_events',
				'comp' => [
				{
					'name' => 'EventSupport',
					'comp' => [
					{
						'files' => [
						'EventSupport.ah',
						'EventSupport_Slice.ah'
						]
					},
					{
						'depends' => '&kernel_alarms',
						'file' => 'EventSupport_Alarm.ah',
					},
					]
				}
				]
			},
			{
				'vname' => 'Tasks',
				'name' => 'kernel_tasks',
				'depends' => '&kernel_tasks',
				'comp' => [
				{
					'vname' => 'Preemptability',
					'name' => 'kernel_preemptability',
					'comp' => [
					{
						'name' => 'SchedImpl_FullPreemptive',
						'depends' => '&kernel_fullpreemptive',
						'comp' => [
						{
							'srcfile' => 'SchedImpl_FullPreemptive2.ah',
							'file' => 'SchedImpl_FullPreemptive.ah'
						}
						]
					},
					{
						'name' => 'SchedImpl_MixedPreemptive',
						'depends' => '&kernel_mixedpreemptive',
						'comp' => [
						{
							'files' => [
							'SchedImpl_MixedPreemptive_Slice.ah'
							]
						},
						{
							'srcfile' => 'SchedImpl_MixedPreemptive2.ah',
							'file' => 'SchedImpl_MixedPreemptive.ah'
						}
						]
					}
					]
				},
				{
					'vname' => 'Scheduler',
					'name' => 'kernel_scheduler',
					'comp' => [
					{
						'vname' => 'SchedStrategy',
						'name' => 'sched_strategy_const_class',
						'classname' => 'os::krn::SchedStrategy',
						'comp' => [
						{
							'files' => [
							'SchedStrategy.h',
							'Task.h',
							'SchedStrategy.cpp',
							'SchedStrategy_Static_TCBExt.ah',
							'TasklistTypes.h'
							]
						}
						]
					},
					{
						'vname' => 'SchedImpl',
						'name' => 'sched_impl_taskidle_class',
						'classname' => 'os::krn::SchedImpl',
						'comp' => [
						{
							'files' => [
							'SchedImpl.h',
							'SchedImpl.cpp',
							'SchedImpl_ASTBinding.ah'
							]
						}
						]
					}
					]
				},
				{
					'vname' => 'Support for Multiple Activation',
					'name' => 'kernel_multipleactivation',
					'depends' => '&kernel_multipleactivation',
					'comp' => [
					{
						'name' => 'SchedImpl_MultipleActivation',
						'comp' => [
						{
							'files' => [
							'SchedImpl_MultipleActivation.ah',
							'SchedImpl_MultipleActivation_Slice.ah'
							]
						}
						]
					}
					]
				}
				]
			},
			{
				'name' => 'Alarms',
				'depends' => '&kernel_alarms',
        'files' => [
          'Alarm.h',
          'Alarm.cpp',
          'AlarmSupport.ah',
          'AlarmSupport_AppMode_Slice.ah',
          'Counter.h',
          'Counter.cpp',
        ],
			},
			{
				'vname' => 'Category 2 ISRs',
				'name' => 'cfOS_ISR2_SUPPORT',
				'depends' => '&cfOS_ISR2_SUPPORT',
				'comp' => [
				{
					'name' => 'ISR',
					'comp' => [
					{
						'files' => [
						'ISR.h'
						]
					}
					]
				},
				{
					'name' => 'ISR2Support',
					'comp' => [
					{
						'files' => [
						'ISR2Support.ah',
						'ISR2Support_Slice1.ah',
						'ISR2Support_Slice2.ah',
						'ISR2Support_Slice3.ah'
						]
					}
					]
				},
				{
					'name' => 'EnterLeave_Weaving_Static',
					'depends' => '&kernel_kernellockstatic',
					'comp' => [
					{
						'files' => [
						'EnterLeave_Weaving_Static.ah'
						]
					}
					]
				}
				]
			},
			{
				'vname' => 'Category 1 ISRs',
				'name' => 'kernel_category1isrs',
				'depends' => '&kernel_category1isrs',
				'comp' => [
				{
					'name' => 'ISR1Support',
					'comp' => [
					{
						'files' => [
						'ISR1Support.ah',
						'ISR1Support_Slice1.ah',
						'ISR1Support_Slice2.ah'
						]
					}
					]
				}
				]
			},
			{
				'vname' => 'Shared Memory',
				'name' => 'kernel_sharedmemory',
				'depends' => '&kernel_sharedmemory',
				'comp' => [
				{
					'vname' => "Shared Memory Runtime Generator",
					'name'  => "kernel_sharedmemory_generator",
					'depends' => '&kernel_sharedmemory',
					'comp' => [
					{
						'dir' => './generator',
						'srcdir' => '../tools/generator/runtime',
						'file' => 'sharedmemory_objects.cpp.pl',
					}
					],
				},
				],
			},
			{
				'vname' => 'Message Ports',
				'name' => 'kernel_messageports',
				'depends' => '&kernel_messageports',
				'comp' => [
				{
					'file' => 'Messageport.h',
				},
				{
					'vname' => "Message Ports Runtime Generator",
					'name'  => "kernel_messageports_generator",
					'depends' => '&kernel_messageports',
					'comp' => [
					{
						'dir' => './generator',
						'srcdir' => '../tools/generator/runtime',
						'file' => 'messageport_objects.cpp.pl',
					}

					],
				},
				{
					'vname' => "Sender Ports with Write Access Revocation",
					'name'  => "kernel_messageports_senderwriterevocation",
					'depends' => '&kernel_messageports_senderwriterevocation',
					'comp' => [
					{
						subdir => '../mp',
						'file' => 'Messageport_RevokeWriteSender.h',
					},
					],
				},
				{
					'vname' => "Sender Ports with temporary Write Access",
					'name'  => "kernel_messageports_receiverwriteaccess",
					'depends' => '&kernel_messageports_receiverwriteaccess',
					'comp' => [
					{
						subdir => '../mp',
						'file' => 'Messageport_EnableWriteReceiver.h',
					},
					],
				},
				{
					'vname' => "Support for Temporary Memory Access Range",
					'depends' => '&kernel_messageports_receiverwriteaccess or &kernel_messageports_senderwriterevocation',
					subdir => '../mp',
					'files' => [
						'ACLs.ah',
						'Context_ACLEntry.ah',
						'ACLEntry_ContextAccessSlice.ah',
						'ACLEntry_ContextContainerSlice.ah',
					],
				}
				]
			}
			]
		},
		{
			'vname' => 'Protection',
			'name' => 'kernel_protection',
			'comp' => [
			{
				'vname' => 'Service Protection',
				'name' => 'kernel_serviceprotection',
				'depends' => '&kernel_serviceprotection',
				'comp' => [
				{
					'name' => 'ContextChecks',
					'depends' => '&contextchecks',
					'comp' => [
					{
						'files' => [
						'ContextChecks.ah',
						'ContextChecks_Pointcuts.ah'
						]
					}
					]
				},
				{
					'name' => 'InvalidObjectChecks',
					'depends' => '&invalidobjectchecks',
					'comp' => [
					{
						'files' => [
						'InvalidObjectChecks.ah',
						'InvalidObjectChecks_Pointcuts.ah'
						]
					}
					]
				},
				{
					'name' => 'MissingEndCheck',
					'depends' => '&missingendcheck',
					'comp' => [
					{
						'files' => [
						'ServiceProtection_MissingEndCheck.ah'
						]
					}
					]
				},
				{
					'name' => 'EnableWithoutDisableCheck',
					'depends' => '&enablewithoutdisablecheck',
					'comp' => [
					{
						'files' => [
						'ServiceProtection_EnableWithoutDisable.ah'
						]
					}
					]
				},
				{
					'name' => 'DisabledInterruptsCheck',
					'depends' => '&disabledinterruptscheck',
					'comp' => [
					{
						'files' => [
						'ServiceProtection_DisabledInterrupts.ah'
						]
					}
					]
				},
				{
					'name' => 'OutOfRangeValuesCheck',
					'depends' => '&outofrangevaluescheck',
					'comp' => [
					{
						'files' => [
						'ServiceProtection_OutOfRangeValues.ah'
						]
					}
					]
				},
				{
					'name' => 'MaxActivationsCheck',
					'depends' => '&max_activations_check',
					'comp' => [
					{
						'files' => [
						'ServiceProtection_MaxActivationsCheck.ah',
						'ServiceProtection_MaxActivationsCheck_Slice.ah'
						]
					}
					]
				}
				]
			},
			{
				'vname' => 'Support for OS Applications',
				'name' => 'kernel_applications',
				'depends' => '&kernel_applications',
				'comp' => [
				{
					'files' => [
					'Application.h',
					'ApplicationSupport.ah',
					'ApplicationSupport_OSObjects_Slice.ah',
					'ApplicationSupport_SchedImpl_Slice.ah',
					]
				},
				{
					dir => 'src/os/mp',
					files => [
						'UCInfo_dummy.h',
					],
				},
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'Network Stack',
		'name' => 'kernel_network_stack',
		'depends' => '&kernel_network_stack',
		'subdir' => '/os/net',
		'comp' => [
		{
			'files' => [
			'arp.cpp',
			'arptable.cpp',
			'ethernet.cpp',
			'icmp.cpp',
			'ip.cpp',
			'udp.cpp',
			'arp.h',
			'arptable.h',
			'errno.h',
			'ethernet.h',
			'icmp.h',
			'if_arp.h',
			'if_ether.h',
			'if.h',
			'if_types.h',
			'if_var.h',
			'in.h',
			'ip.h',
			'ip_icmp.h',
			'message.h',
			'netdebug.h',
			'ppp.h',
			'route.h',
			'udp.h'
			]
		},
		{
			'vname' => "Network Ports Runtime Generator",
			'name'  => "kernel_networkports_generator",
			'depends' => '&kernel_network_stack',
			'comp' => [
			{
				'dir' => './generator',
				'srcdir' => '../tools/generator/runtime',
				'file' => 'network_objects.cpp.pl',
			}
			],
		},
		]
	},
	{
		'vname' => 'Devices',
		'name' => 'ciao_dev',
		'subdir' => '/os/dev/std',
		'comp' => [
		{
			'vname' => 'Simple Serial Driver',
			'name' => 'ciao_dev_serial',
			'depends' => '&devices_serial',
			'comp' => [
			{
				'vname' => 'Serial0',
				'name' => 'ciao_dev_serial_class',
				'classname' => 'Serial0',
				'comp' => [
				{
					'files' => [
					'Serial0.h',
					'Serial0.cpp',
					'Serial0_Inst.ah',
					'Serial0_VIRQ_REC_Bind.ah',
					'Serial0_VIRQ_TBUF_Bind.ah',
					'Serial0_Init.ah'
					]
				}
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'AUTOSAR Interface',
		'name' => 'autosar_interface',
		'subdir' => '/as',
		'comp' => [
		{
			'vname' => 'AUTOSAR Headers',
			'comp' => [
			{
				'files' => [
				'autosar_macros.h',
				'autosar_types.h',
				'autosar_pointcuts.h'
				]
			}
			]
		},
		{
			'name' => 'AS',
			'comp' => [
			{
				'files' => [
				'AS.h'
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'Application Headers',
		'name' => 'application',
		'subdir' => '/app',
		'comp' => [
		{
			'vname' => 'Component Header',
			'name' => 'application_componentheader',
			'comp' => [
			{
				'files' => [
				'componentheader.h'
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'Debug',
		'name' => 'ciao_debug',
		'subdir' => '/debug',
		'comp' => [
		{
			'vname' => 'Debug Enabled',
			'name' => 'ciao_debug_enabled',
			'depends' => '&debug',
			'comp' => [
			{
				'vname' => 'Verbose ISR activation and deactivation',
				'name' => 'ciao_debug_ISR_verbosity',
				'comp' => [
				{
					'files' => [
					'ISR_verbose.ah'
					]
				}
				]
			},
			{
				'vname' => 'Timing Protection: Verbose adding of deadlines',
				'name' => 'ciao_debug_TP_addDeadline',
				'comp' => [
				{
					'files' => [
					'TP_addDeadline_verbose.ah'
					]
				}
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'OSEK compatibility Interface',
		'name' => 'osek_compat',
		'depends' => '&lib_osekcompat',
		'subdir' => '/as',
		'comp' => [
		{
			'vname' => 'Core Services',
			'comp' => [
			{
				'files' => [
				'osek_compat.h'
				]
			}
			]
		}
		]
	},
	{
		'vname' => 'Run global Constructors',
		'name' => 'run_global_constructors',
		'depends' => '&run_global_constructors',
		'dir' => 'src/util',
		'files' => [
			'constructors.h',
			'constructors.ah',
			'constructors.cpp',
		]
	},
	]
};
