$VAR1 = {
  'vname' => 'tc-triboard1796',
  'name' => 'ciao_platform',
  'dir' => 'src',
  'comp' => [
    {
      'vname' => 'Tests',
      'name' => 'ciao_platform_test',
      'dir' => 'test',
      'comp' => [
        {
          'vname' => 'Lauterbach Support',
          'name' => 'ciao_platform_test_t32',
          'depends' => '&ciao_platform_test_t32_files',
          'subdir' => '/t32',
          'comp' => [
            {
              'vname' => 'PRACTICE scripts',
              'name' => 'ciao_platform_test_t32_files',
              'comp' => [
                {
                  'files' => [
                    'debug.cmm',
                    'init.cmm',
                    'loadelf.cmm',
                    'prepareAtoB.cmm',
                    'measureAtoB.cmm'
                  ]
                }
              ]
            }
          ]
        }
      ]
    },
    {
      'vname' => 'hw',
      'name' => 'ciao_platform_hw',
      'subdir' => 'hw',
      'comp' => [
        {
          'vname' => 'hal',
          'name' => 'ciao_platform_hw_hal',
          'subdir' => 'hal',
          'comp' => [
            {
              'vname' => 'tc',
              'name' => 'ciao_platform_hw_hal_arch',
              'subdir' => '!ARCH',
              'comp' => [
                {
                  'vname' => 'TCBBasic',
                  'name' => 'hal_TCBBasic_class',
                  'classname' => 'hw::hal::TCBBasic',
                  'comp' => [
                    {
                      'files' => [
                        'TCBBasic.h',
                        'TCBBasic.cpp'
                      ]
                    },
                    {
                      'vname' => 'chain() operation, speed-optimized',
                      'name' => 'ciao_platform_hw_hal_threading_fastchain',
                      'depends' => '&hal_threading_tcbbasic_chain_fast',
                      'comp' => [
                        {
                          'files' => [
                            'TCBBasic_Chain.ah'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'CPU',
                  'name' => 'hal_CPU_class',
                  'classname' => 'hw::hal::CPU',
                  'comp' => [
                    {
                      'files' => [
                        'CPU.h',
                        'CPU.cpp'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'get/setActive() operation',
                  'name' => 'ciao_platform_hw_hal_threading_active',
                  'depends' => '&hal_threading_active',
                  'comp' => [
                    {
                      'files' => [
                        'Continuation_Active.ah'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'Continuation',
                  'name' => 'hal_Continuation_class',
                  'classname' => 'hw::hal::BasicTCB',
                  'comp' => [
                    {
                      'files' => [
                        'Continuation.h',
                        'Continuation.cpp'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'cfHAL_IRQHANDLER_ATTRIBUTES',
                  'name' => 'ciao_platform_hw_hal_irq_irqhandlerflags',
                  'comp' => [
                    {}
                  ]
                },
                {
                  'vname' => 'cfHAL_TRAPHANDLER_ATTRIBUTES',
                  'name' => 'ciao_platform_hw_hal_irq_traphandlerflags',
                  'comp' => [
                    {}
                  ]
                },
                {
                  'name' => 'hal_STMTimerBase_class',
                  'depends' => '&hal_Timer0 or &hal_Timer1 or &kernel_alarms or &timeprot',
                  'classname' => 'hw::hal::STMTimerBase',
                  'comp' => [
                    {
                      'files' => [
                        'STMTimerBase.h'
                      ]
                    }
                  ]
                },
                {
                  'name' => 'hal_SystemClockImpl_class',
                  'depends' => '&hal_SystemClock',
                  'classname' => 'hw::hal::SystemClockImpl',
                  'comp' => [
                    {
                      'files' => [
                        'SystemClockImpl.h'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'SysData::Inst() operation, using a global register',
                  'name' => 'hal_SysData_Inst_aspect',
                  'comp' => [
                    {
                      'files' => [
                        'SysData_Inst.ah',
                        'SysData_Ptr.ah'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'hw::hal::TCBUser',
                  'name' => 'hal_TCBUser_class',
                  'classname' => 'hw::hal::TCBUser',
                  'comp' => [
                    {
                      'files' => [
                        'TCBUser.h',
                        'TCBUser.cpp'
                      ]
                    },
                    {
                      'vname' => 'automatic context cleanup on termination for TCBUser',
                      'name' => 'ciao_platform_hw_hal_threading_tcbuser_cleanup',
		      'depends' => '&hal_threading_tcbuser_cleanup',
                      'comp' => [
                        {
                          'files' => [
                            'TCBUser_Cleanup.ah',
                            'TCBUser_CleanupSupport.ah'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'MPU',
                  'name' => 'hal_MPU_class',
                  'classname' => 'hw::hal::SysData',
                  'comp' => [
                    {
                      'files' => [
                        'MPU.h'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'Tricore Platform Configuration',
                  'name' => 'ciao_tc_platform_configuration',
                  'file' => 'platform.h'
                },
                {
                  'name' => 'hal_STMTimer0',
                  'depends' => '&hal_Timer0',
                  'classname' => 'hw::hal::STMTimer0',
                  'comp' => [
                    {
                      'files' => [
                        'STMTimer0.h',
                        'STMTimer0.cpp'
                      ]
                    }
                  ]
                },
                {
                  'name' => 'hal_STMTimer1',
                  'depends' => '&hal_Timer1',
                  'classname' => 'hw::hal::STMTimer1',
                  'comp' => [
                    {
                      'files' => [
                        'STMTimer1.h',
                        'STMTimer1.cpp'
                      ]
                    }
                  ]
                },
                {
                  'name' => 'KernelLock',
                  'depends' => '&hal_kernellockimplementation',
                  'comp' => [
                    {
                      'files' => [
                        'KernelLock.ah'
                      ]
                    }
                  ]
                },
                {
                  'name' => 'EnterLeave_Weaving_Dynamic',
                  'depends' => '&hal_kernellockdynamic',
                  'comp' => [
                    {
                      'files' => [
                        'EnterLeave_Weaving_Dynamic.ah'
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'Threading',
              'name' => 'ciao_platform_hw_hal_threading',
              'comp' => [
                {
                  'vname' => 'irq protection for context change operations',
                  'name' => 'ciao_platform_hw_hal_threading_protected',
                  'depends' => '&hal_threading_protected_irq',
                  'comp' => [
                    {
                      'files' => [
                        'ContinuationLock_IRQ.ah'
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'Debugging',
              'name' => 'ciao_platform_hw_hal_debugging',
              'comp' => [
                {
                  'vname' => 'DebugPort support',
                  'name' => 'ciao_platform_hw_hal_debugging_stdout',
                  'depends' => '&hal_DebugPort',
                  'comp' => [
                    {
                      'name' => 'hal_DebugPort_class',
                      'classname' => 'hw::hal::DebugPort',
                      'comp' => [
                        {
                          'files' => [
                            'DebugPort.h',
                            'DebugPort.cpp',
                            'DebugPort_Inst.ah'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'DebugPortImpl',
                      'name' => 'hal_DebugPortImpl_alias',
                      'comp' => [
                        {
                          'generate' => 'alias({classname=>"::hw::dev::ASC0",path=>"src/hw/dev/ASC.h",newname=>"DebugPortImpl",nsl=>["hw","hal"],guard=>"__pv_guard_iJ2NiUXRV__hUIrsb_i5_22UTbM9qLhes20"});',
                          'file' => 'DebugPortImpl.h'
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'ASSERT macro support',
                  'name' => 'assert_handler',
                  'comp' => [
                    {
                      'depends' => '&lib_libcmini and &hal_DebugPort',
                      'file' => 'ciao_assertion_handler_printf.cpp'
                    },
                    {
                      'depends' => 'not &lib_libcmini or not &hal_DebugPort',
                      'file' => 'ciao_assertion_handler_simple.cpp'
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'Devices',
              'name' => 'ciao_platform_hw_hal_devices',
              'comp' => [
                {
                  'vname' => 'Serial0',
                  'name' => 'hal_Serial0',
                  'depends' => '&hal_Serial0',
                  'comp' => [
                    {
                      'vname' => 'Serial0Impl',
                      'name' => 'hal_Serial0Impl_alias',
                      'comp' => [
                        {
                          'files' => [
                            'Serial0Impl.h'
                          ]
                        }
                      ]
                    },
                    {
                      'name' => 'hal_Serial0_class',
                      'classname' => 'hw::hal::Serial0',
                      'comp' => [
                        {
                          'files' => [
                            'Serial0.h'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'Timer0',
                  'name' => 'hal_Timer0',
                  'depends' => '&hal_Timer0 or &kernel_alarms',
                  'comp' => [
                    {
                      'vname' => 'Timer0Impl',
                      'name' => 'hal_Timer0Impl_alias',
                      'depends' => '&hal_Timer0 or &kernel_alarms',
                      'comp' => [
                        {
                          'file' =>'Timer0Impl.h',
                          'generate'=>'alias({classname=>"::hw::hal::STMTimer0",path=>"src/hw/hal/STMTimer0.h",newname=>"Timer0Impl",nsl=>["hw","hal"],guard=>"__pv_guard_ijOS7NnjxR6mRpl7I_ihANOSuK3p39kVQ8u"});'

                        }
                      ]
                    },
                    {
                      'name' => 'hal_Timer0_class',
                      'depends' => '&hal_Timer0 or &kernel_alarms',
                      'classname' => 'hw::hal::Timer0',
                      'comp' => [
                        {
                          'files' => [
                            'Timer0.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'SystemTimerImpl',
                      'name' => 'hal_SystemTimerImpl_alias',
                      'depends' => '&hal_Timer0 or &kernel_alarms',
                      'comp' => [
                        {
                          'file'=>'SystemTimerImpl.h',
                          'generate'=>'alias({classname=>"::hw::hal::STMTimer0",path=>"src/hw/hal/STMTimer0.h",newname=>"SystemTimerImpl",nsl=>["hw","hal"],guard=>"__pv_guard_ibcZV8dGb5AaBfGR4_iBtGzmm8fURebPhL4"});'

                        }
                      ]
                    },
                    {
                      'name' => 'hal_SystemTimer_class',
                      'depends' => '&hal_Timer0 or &kernel_alarms',
                      'classname' => 'hw::hal::SystemTimer',
                      'comp' => [
                        {
                          'files' => [
                            'SystemTimer.h'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'SystemClock',
                  'name' => 'hal_SystemClock',
                  'depends' => '&hal_SystemClock',
                  'comp' => [
                    {
                      'name' => 'hal_SystemClock_class',
                      'classname' => 'hw::hal::SystemClock',
                      'comp' => [
                        {
                          'files' => [
                            'SystemClock.h',
                            'SystemClock.cpp',
                            'SystemClock_Inst.ah'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'Out0',
                  'name' => 'hal_Out0',
                  'depends' => '&hal_Out0',
                  'subdir' => '/!ARCH/',
                  'comp' => [
                    {
                      'vname' => 'Out0Port',
                      'name' => 'hal_Out0Port_alias',
                      'comp' => [
                        {
                          'files' => [
                            'Out0Port.h'
                          ]
                        }
                      ]
                    },
                    {
                      'name' => 'hal_Out0_class',
                      'depends' => '&',
                      'classname' => 'hw::hal::Out0',
                      'comp' => [
                        {
                          'files' => [
                            'Out0.h',
                            'Out0.cpp',
                            'Out0_Init.ah'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'In0',
                  'name' => 'hal_In0',
                  'depends' => '&hal_In0',
                  'subdir' => '/!ARCH/',
                  'comp' => [
                    {
                      'name' => 'hal_In0_class',
                      'classname' => 'hw::hal::In0',
                      'comp' => [
                        {
                          'files' => [
                            'In0.h',
                            'In0.cpp',
                            'In0_Init.ah'
                          ]
                        }
                      ]
                    },
                    {
                      'name' => 'hal_In0_irq',
                      'depends' => '&hal_In0',
                      'comp' => [
                        {
                          'files' => [
                            'In0_IRQSupport.ah',
                            'In0_IRQSlice.ah'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'In1',
                  'name' => 'hal_In1',
                  'depends' => '&hal_In1',
                  'subdir' => '/!ARCH/',
                  'comp' => [
                    {
                      'name' => 'hal_In1_class',
                      'classname' => 'hw::hal::In1',
                      'comp' => [
                        {
                          'files' => [
                            'In1.h',
                            'In1.cpp',
                            'In1_Init.ah'
                          ]
                        }
                      ]
                    },
                    {
                      'name' => 'hal_In1_irq',
                      'depends' => '&hal_In1_irq',
                      'comp' => [
                        {
                          'files' => [
                            'In1_IRQSupport.ah',
                            'In1_IRQSlice.ah'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'AST0',
                  'name' => 'hal_ast0',
                  'depends' => '&hal_ast0',
                  'comp' => [
                    {
                      'vname' => 'hw::hal::AST0',
                      'name' => 'hal_ast0_class',
                      'classname' => 'hw::hal::AST0',
                      'comp' => [
                        {
                          'files' => [
                            'AST0.h',
                            'AST0.cpp',
                            'AST0_Init.ah'
                          ]
                        }
                      ]
                    },
                    {
                      'name' => 'hal_astimpl_cpu_src0',
                      'depends' => '&hal_astimpl_cpu_src0',
                      'comp' => [
                        {
                          'vname' => 'hw::hal::ASTImpl_CPU_SRC0',
                          'name' => 'hal_astimpl_cpu_src0_class',
                          'classname' => 'hw::hal::ASTImpl_CPU_SRC0',
                          'comp' => [
                            {
                              'files' => [
                                'ASTImpl_CPU_SRC0.h',
                                'ASTImpl_CPU_SRC0_IRQBinding.ah',
                                'ASTImpl_CPU_SRC0_OSBinding.ah'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'AST0Impl',
                          'name' => 'hal_AST0Impl_alias',
                          'comp' => [
                            {
                              'generate' => 'alias({classname=>"::hw::hal::ASTImpl_CPU_SRC0",path=>"src/hw/hal/ASTImpl_CPU_SRC0.h",newname=>"AST0Impl",nsl=>["hw","hal"],guard=>"__pv_guard_imUNr1JotDW5Um5gv_ij_F1o0_CsQuPLDc8"});',
                              'file' => 'AST0Impl.h'
                            }
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'AST1',
                  'name' => 'hal_ast1',
                  'depends' => '&hal_ast1',
                  'comp' => [
                    {
                      'vname' => 'hw::hal::AST1',
                      'name' => 'hal_ast1_class',
                      'classname' => 'hw::hal::AST1',
                      'comp' => [
                        {
                          'files' => [
                            'AST1.h',
                            'AST1.cpp',
                            'AST1_Init.ah'
                          ]
                        }
                      ]
                    },
                    {
                      'name' => 'hal_astimpl_cpu_src1',
                      'depends' => '&hal_astimpl_cpu_src1',
                      'comp' => [
                        {
                          'vname' => 'hw::hal::ASTImpl_CPU_SRC1',
                          'name' => 'hal_astimpl_cpu_src1_class',
                          'classname' => 'hw::hal::ASTImpl_CPU_SRC1',
                          'comp' => [
                            {
                              'files' => [
                                'ASTImpl_CPU_SRC1.h',
                                'ASTImpl_CPU_SRC1_IRQBinding.ah'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'AST0Impl',
                          'name' => 'hal_AST1Impl_alias',
                          'comp' => [
                            {
                              'files' => [
                                'AST1Impl.h'
                              ]
                            }
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'Timer1',
                  'name' => 'hal_Timer1',
                  'depends' => '&hal_Timer1 or &timeprot',
                  'comp' => [
                    {
                      'vname' => 'Timer1Impl',
                      'name' => 'hal_Timer1Impl_alias',
                      'depends' => '&hal_Timer1',
                      'comp' => [
                        {
                          'files' => [
                            'Timer1Impl.h'
                          ]
                        }
                      ]
                    },
                    {
                      'name' => 'hal_Timer1_class',
                      'depends' => '&hal_Timer1',
                      'classname' => 'hw::hal::Timer1',
                      'comp' => [
                        {
                          'files' => [
                            'Timer1.h'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'CanIf',
                  'depends' => '&hw_hal_canif',
                  'subdir' => '/can',
                  'comp' => [
                    {
                      'vname' => 'multican',
                      'subdir' => '/multican',
                      'comp' => [
                        {
                          'vname' => 'rx',
                          'subdir' => '/rx',
                          'comp' => [
                            {
                              'vname' => 'RxIndication',
                              'comp' => [
                                {
                                  'files' => [
                                    'RxIndication.ah',
                                    'RxIndication_CanIf_Slice.ah',
                                    'RxIndication_Callback.ah'
                                  ]
                                }
                              ]
                            },
                            {
                              'vname' => 'hw::hal::can::multican::RxHwObjectType',
                              'classname' => 'hw::hal::can::multican::RxHwObjectType',
                              'comp' => [
                                {
                                  'files' => [
                                    'RxHwObjectType.h',
                                    'RxHwObjectType.cpp'
                                  ]
                                }
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'tx',
                          'subdir' => '/tx',
                          'comp' => [
                            {
                              'vname' => 'confirmation',
                              'comp' => [
                                {
                                  'vname' => 'TxConfirmation',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'TxConfirmation.ah',
                                        'TxConfirmation_CanIf_Slice.ah'
                                      ]
                                    }
                                  ]
                                }
                              ]
                            },
                            {
                              'vname' => 'Tx',
                              'comp' => [
                                {
                                  'files' => [
                                    'Tx.ah'
                                  ]
                                }
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'MultipleDriverSupport',
                          'comp' => [
                            {
                              'files' => [
                                'MultipleDriverSupport.ah'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'SingleDriverSupport',
                          'comp' => [
                            {
                              'files' => [
                                'SingleDriverSupport.ah'
                              ]
                            }
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'Cfg',
                      'comp' => [
                        {
                          'files' => [
                            'Cfg.h'
                          ]
                        }
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'init()-Support',
              'name' => 'ciao_platform_hw_hal_init',
              'comp' => [
                {
                  'vname' => 'hw::hal::init',
                  'name' => 'ciao_platform_hw_hal_init_func',
                  'comp' => [
                    {
                      'files' => [
                        'init.h',
                        'init.cpp'
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'SysData support',
              'name' => 'ciao_platform_hw_hal_sysdata',
              'comp' => [
                {
                  'vname' => 'get/setActive() operation for SysData',
                  'name' => 'hal_TCBActive_SysData_aspect',
                  'depends' => '&hal_threading_active',
                  'comp' => [
                    {
                      'files' => [
                        'TCBActive_SysData.ah'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'SysData',
                  'name' => 'hal_SysData_class',
                  'classname' => 'hw::hal::SysData',
                  'comp' => [
                    {
                      'files' => [
                        'SysData.h',
                        'SysData.cpp'
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'Protection',
              'name' => 'ciao_platform_hw_hal_protection',
              'depends' => '&hal_protection',
              'comp' => [
                {
                  'vname' => 'Init Support',
                  'name' => 'ciao_platform_hw_hal_protection_init',
                  'comp' => [
                    {
                      'files' => [
                        'MPU_Init.ah'
                      ]
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          'vname' => 'init()-Support',
          'name' => 'ciao_platform_hw_init',
          'comp' => [
            {
              'vname' => 'hw::init',
              'name' => 'ciao_platform_hw_init_func',
              'comp' => [
                {
                  'files' => [
                    'init.h',
                    'init.cpp'
                  ]
                }
              ]
            }
          ]
        },
        {
          'vname' => 'tc',
          'name' => 'ciao_platform_hw_arch',
          'comp' => [
            {
              'vname' => 'TriBoard 1796 Assembler Startup Code',
              'name' => 'ciao_platform_hw_arch_boot',
              'dir' => 'lib',
              'comp' => [
                {
                  'vname' => 'Boot Files',
                  'name' => 'ciao_platform_hw_arch_boot_boot',
                  'comp' => [
                    {
                      'dir' => 'src',
                      'srcdir' => 'src/hw/',
                      'file' => 'crt0.S'
                    }
                  ]
                },
                {
                  'vname' => 'Linker Files',
                  'name' => 'ciao_platform_hw_arch_boot_linker',
                  'comp' => [
                    {
                        'vname' => 'HighTec EasyRun',
                        'name' => 'board_memory_layout_easyrun',
                        'depends' => '&board_memory_layout_easyrun',
                        'srcdir' => 'src/hw/_tc',
                        'srcfile' => 'memory_EasyRunTC1796.x',
                        'file' => 'memory.x',
                    },
                    {
                        'vname' => 'Triboard TC1796 external RAM',
                        'name' => 'board_memory_layout_triboard',
                        'depends' => '&board_memory_layout_triboard',
                        'srcdir' => 'src/hw/_tc',
                        'srcfile' => 'memory_TriboardTC1796_external_RAM.x',
                        'file' => 'memory.x',
                    },
                    {
                        'vname' => 'Triboard TC1796 internal flash, external RAM',
                        'name' => 'board_memory_layout_tc1796_intflash_extram',
                        'depends' => '&board_memory_layout_triboard_intflash_extram',
                        'srcdir' => 'src/hw/_tc',
                        'srcfile' => 'memory_TriboardTC1796_internal_Flash_external_RAM.x',
                        'file' => 'memory.x',
                    },
                    {
                        'vname' => 'TC1796 internal memory',
                        'name' => 'board_memory_layout_tc1796_internal',
                        'depends' => '&board_memory_layout_tc1796_internal',
                        'srcdir' => 'src/hw/_tc',
                        'srcfile' => 'memory_TC1796_internal.x',
                        'file' => 'memory.x',
                    },
                    {
                      'srcdir' => 'src/hw',
                      'file' => 'vectab.x'
                    }
                  ]
                },
                {
                  'vname' => '[CIAO_LINKFIRST]',
                  'name' => 'ciao_platform_hw_arch_boot_make',
                  'comp' => [
                    {
                      'dir' => 'make',
                      'generate' => 'mk_helper();',
                      'file' => 'ciao_config.mk'
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'TriBoard 1796 C++ Startup and Helper',
              'name' => 'ciao_platform_hw_arch_board',
              'comp' => [
                {
                  'vname' => 'Basic HW-Access Files',
                  'name' => 'ciao_platform_hw_arch_board_def',
                  'comp' => [
                    {
                      'files' => [
                        'triboard1796.h',
                        'triboard1796.cpp',
                        'tricore-abs-noabs-FIX.h',
                        'triboard1796_userinit.cpp',
                        'triboard1796_vectab.cpp'
                      ]
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          'vname' => 'dev/irq',
          'name' => 'ciao_platform_hw_dev',
          'subdir' => '/dev',
          'comp' => [
            {
              'vname' => 'ASC - [A]synchronous Serial Controller',
              'name' => 'ciao_platform_hw_dev_asc',
              'comp' => [
                {
                  'vname' => 'ASC0',
                  'name' => 'dev_asc0',
                  'depends' => '&dev_asc0',
                  'comp' => [
                    {
                      'vname' => 'hw::dev::ASC0',
                      'name' => 'dev_asc0_class',
                      'classname' => 'hw::dev::ASC0',
                      'comp' => [
                        {
                          'files' => [
                            'ASC.h',
                            'ASC.cpp',
                            'ASC0_Init.ah'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'hw::irq::ASC0',
                      'name' => 'dev_asc0_irq',
                      'subdir' => '/../irq',
                      'comp' => [
                        {
                          #regexp replacment example
                          'files' => 'ASC.(h|cpp)'
                          #'files' => [
                          #  'ASC.h',
                          #  'ASC.cpp'
                          #]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'ASC1',
                  'name' => 'dev_asc1',
                  'depends' => '&dev_asc1',
                  'comp' => [
                    {
                      'vname' => 'hw::dev::ASC1',
                      'name' => 'dev_asc1_class',
                      'classname' => 'hw::dev::ASC1',
                      'comp' => [
                        {
                          'files' => [
                            'ASC.h',
                            'ASC.cpp',
                            'ASC1_Init.ah'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'hw::irq::ASC1',
                      'name' => 'dev_asc1_irq',
                      'subdir' => '/../irq',
                      'comp' => [
                        {
                          'files' => [
                            'ASC.h',
                            'ASC.cpp'
                          ]
                        }
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'DebuggerVIO',
              'name' => 'dev_vio_class',
              'depends' => '&dev_vio',
              'classname' => 'hw::dev::DebuggerVIO',
              'comp' => [
                {
                  'files' => [
                    'DebuggerVIO.h',
                    'DebuggerVIO.cpp'
                  ]
                }
              ]
            },
            {
              'vname' => 'IRQCtrl',
              'name' => 'ciao_platform_hw_dev_irqctrl',
              'comp' => [
                {
                  'files' => [
                    'IRQCtrl.h'
                  ]
                }
              ]
            },
            {
              'vname' => 'AST - Asynchronous System Trap',
              'name' => 'ciao_platform_hw_dev_ast',
              'comp' => [
                {
                  'vname' => 'AST1',
                  'name' => 'dev_ast1',
                  'depends' => '&dev_ast1',
                  'comp' => [
                    {
                      'vname' => 'hw::dev::AST1',
                      'name' => 'dev_ast1_class',
                      'classname' => 'hw::dev::AST0',
                      'comp' => [
                        {
                          'files' => [
                            'AST.h',
                            'AST.cpp',
                            'AST1_Init.ah'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'hw::irq::AST1',
                      'name' => 'dev_ast1_irq',
                      'subdir' => '/../irq',
                      'comp' => [
                        {
                          'files' => [
                            'AST.h',
                            'AST.cpp'
                          ]
                        }
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'SMSC LAN91 NIC',
              'name' => 'dev_lan91',
              'depends' => '&dev_lan91',
              'comp' => [
                {
                  'vname' => 'hw::dev::LAN91',
                  'name' => 'dev_lan_class',
                  'comp' => [
                    {
                      'files' => [
                        'LAN91.h',
                        'LAN91.cpp'
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'STM - System Timer Module',
              'name' => 'dev_stm',
              'depends' => '&dev_stm',
              'comp' => [
                {
                  'vname' => 'hw::dev::STM',
                  'name' => 'dev_stm_class',
                  'comp' => [
                    {
                      'files' => [
                        'STM.h',
                        'STM.cpp',
                        'STM_Init.ah'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'hw::irq::STM',
                  'name' => 'dev_stm_irq',
                  'subdir' => '/../irq',
                  'comp' => [
                    {
                      'files' => [
                        'STM.h',
                        'STM.cpp'
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'CGU - Clock Generation Unit',
              'name' => 'dev_cgu',
              'comp' => [
                {
                  'vname' => 'hw::dev::CGU',
                  'name' => 'dev_cgu_class',
                  'comp' => [
                    {
                      'files' => [
                        'CGU.h',
                        'CGU.cpp',
                        'CGU_Init.ah'
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'IRQ - freestanding IRQ handler and general IRQ support',
              'name' => 'ciao_platform_hw_dev_arch_irq',
              'subdir' => '/../irq',
              'comp' => [
                {
                  'vname' => 'IRQBase',
                  'name' => 'ciao_platform_hw_irq_IRQBase',
                  'classname' => 'hw::hal::IRQBase',
                  'comp' => [
                    {
                      'files' => [
                        'IRQBase.h'
                      ]
                    }
                  ]
                },
                {
                  'name' => 'irq_dma_syssrc2',
                  'depends' => '&irq_dma_syssrc2',
                  'classname' => 'hw::irq::DMA_SYSSRC2',
                  'comp' => [
                    {
                      'files' => [
                        'DMA_SYSSRC2.h',
                        'DMA_SYSSRC2.cpp',
                        'DMA_SYSSRC2_Init.ah'
                      ]
                    }
                  ]
                },
                {
                  'name' => 'irq_ssc0_transmit',
                  'depends' => '&irq_ssc0_transmit',
                  'classname' => 'hw::irq::SSC0_TRANSMIT',
                  'comp' => [
                    {
                      'files' => [
                        'SSC0_TRANSMIT.h',
                        'SSC0_TRANSMIT.cpp',
                      ]
                    }
                  ]
                },
                {
                  'name' => 'irq_ssc0_error',
                  'depends' => '&irq_ssc0_error',
                  'classname' => 'hw::irq::SSC0_ERROR',
                  'comp' => [
                    {
                      'files' => [
                        'SSC0_ERROR.h',
                        'SSC0_ERROR.cpp',
                      ]
                    }
                  ]
                },
                {
                  'name' => 'irq_dma0',
                  'depends' => '&irq_dma0',
                  'classname' => 'hw::irq::DMA0',
                  'comp' => [
                    {
                      'files' => [
                        'DMA0.h',
                        'DMA0.cpp',
                      ]
                    }
                  ]
                },
                {
                  'name' => 'irq_dma_syssrc3',
                  'depends' => '&irq_dma_syssrc3',
                  'classname' => 'hw::irq::DMA_SYSSRC3',
                  'comp' => [
                    {
                      'files' => [
                        'DMA_SYSSRC3.h',
                        'DMA_SYSSRC3.cpp',
                        'DMA_SYSSRC3_Init.ah'
                      ]
                    }
                  ]
                },
                {
                  'name' => 'irq_cpu_src0',
                  'depends' => '&irq_cpu_src0',
                  'classname' => 'hw::irq::CPU_SRC0',
                  'comp' => [
                    {
                      'files' => [
                        'CPU_SRC0.h',
                        'CPU_SRC0.cpp',
                        'CPU_SRC0_Init.ah'
                      ]
                    }
                  ]
                },
                {
                  'name' => 'irq_cpu_src1',
                  'depends' => '&irq_cpu_src1',
                  'classname' => 'hw::irq::CPU_SRC1',
                  'comp' => [
                    {
                      'files' => [
                        'CPU_SRC1.h',
                        'CPU_SRC1.cpp',
                        'CPU_SRC1_Init.ah'
                      ]
                    }
                  ]
                },
                {
                  'name' => 'irq_cpu_src3',
                  'depends' => '&irq_cpu_src3',
                  'classname' => 'hw::irq::CPU_SRC3',
                  'comp' => [
                    {
                      'files' => [
                        'CPU_SRC3.h',
                        'CPU_SRC3.cpp',
                        'CPU_SRC3_Init.ah'
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'GPIO - General Purpose I/O Lines',
              'name' => 'dev_gpio',
              'comp' => [
                {
                  'vname' => 'hw::dev::P0',
                  'name' => 'dev_p0_class',
                  'depends' => '&dev_p0',
                  'classname' => 'hw::dev::P0',
                  'comp' => [
                    {
                      'files' => [
                        'P0.h',
                        'P0.cpp'
                      ]
										},
										{
											'depends' => '&dev_p0_init',
											'file' => 'P0_Init.ah',
										}
										]
									},
									{
                  'vname' => 'hw::dev::P1',
                  'name' => 'dev_p1_class',
                  'depends' => '&dev_p1',
                  'classname' => 'hw::dev::P1',
                  'comp' => [
                    {
                      'files' => [
                        'P1.h',
                        'P1.cpp',
                      ]
                    },
										{
											'depends' => '&dev_init_p1',
											'file' => 'P1_Init.ah',
										}
                  ]
                },
                {
                  'name' => 'dev_gpio_portbase_class',
                  'classname' => 'hw::dev::PortBase',
                  'comp' => [
                    {
                      'files' => [
                        'GPIO.h'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'hw::dev::P7',
                  'name' => 'dev_p7_class',
                  'depends' => '&dev_p7',
                  'classname' => 'hw::dev::P0',
                  'comp' => [
                    {
                      'files' => [
                        'P7.h',
                        'P7.cpp'
                      ]
                    },
                    {
                      'depends' => '&dev_p7_init',
                      'file' => 'P7_Init.ah'
                    }
                  ]
                },
                {
                  'vname' => 'hw::dev::P4',
                  'name' => 'dev_p4_class',
                  'depends' => '&dev_p4',
                  'classname' => 'hw::dev::P4',
                  'comp' => [
                    {
                      'files' => [
                        'P4.h',
                        'P4.cpp'
                      ]
                    },
                    {
                      'depends' => '&dev_p4_init',
                      'file' => 'P4_Init.ah'
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'PCP IRQ handling',
              'name' => 'ciao_platform_hw_irq_pcp',
              'depends' => '&irq_pcp',
              'subdir' => '/../irq',
              'comp' => [
                {
                  'vname' => 'PCP device',
                  'name' => 'ciao_platform_hw_irq_PCP_dev',
                  'classname' => 'hw::hal::PCP',
                  'comp' => [
                    {
                      'files' => [
                        'PCP.h',
                        'PCP.cpp',
                        'PCP_Init.ah',
                        'PCP_asm.inc',
                        'PCP_asm.S'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'write scheduler priority to PCP memory',
                  'name' => 'ciao_platform_hw_irq_PCP_SchedPrio',
                  'classname' => 'os_krn_schedimpl_pcpprio',
                  'comp' => [
                    {
                      'files' => [
                        'PCP_PostSchedPrio.ah'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'synchonize task activation between CPU and PCP',
                  'name' => 'ciao_platform_hw_irq_PCP_SyncTaskActivation',
                  'classname' => 'os_krn_sched_synctaskactivation',
                  'comp' => [
                    {
                      'files' => [
                        'PCP_SyncTaskActivation.ah'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'extensions to class TaskListTypesBase',
                  'name' => 'ciao_platform_hw_irq_PCP_TaskListTypesBase',
                  'classname' => 'os_krn_tasklisttypesbase_pcp',
                  'comp' => [
                    {
                      'files' => [
                        'PCP_TaskListTypesBase.ah'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'extensions to class IRQCtrl',
                  'name' => 'ciao_platform_hw_irq_PCP_IRQCtrlTOS',
                  'classname' => 'os_krn_tasklisttypesbase_pcp',
                  'comp' => [
                    {
                      'files' => [
                        'IRQCtrlTOS.ah'
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'multican',
              'name' => 'comp_hw_dev_can_tc_multican',
              'depends' => '&hw_dev_can_tc_multican',
              'subdir' => '/can',
              'comp' => [
                {
                  'vname' => 'irq',
                  'name' => 'comp_hw_dev_can_tc_multican_irq',
                  'subdir' => '/../../irq/',
                  'comp' => [
                    {
                      'vname' => 'hw::irq::CAN_SRC_BASE',
                      'classname' => 'hw::irq::CAN_SRC0',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC_BASE.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC0',
                      'classname' => 'hw::irq::CAN_SRC0',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC0.h',
                            'CAN_SRC0.cpp',
                            'CAN_SRC0_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC1',
                      'classname' => 'hw::irq::CAN_SRC1',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC1.h',
                            'CAN_SRC1.cpp',
                            'CAN_SRC1_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC2',
                      'classname' => 'hw::irq::CAN_SRC2',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC2.h',
                            'CAN_SRC2.cpp',
                            'CAN_SRC2_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC3',
                      'classname' => 'hw::irq::CAN_SRC3',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC3.h',
                            'CAN_SRC3.cpp',
                            'CAN_SRC3_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC4',
                      'classname' => 'hw::irq::CAN_SRC4',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC4.h',
                            'CAN_SRC4.cpp',
                            'CAN_SRC4_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC5',
                      'classname' => 'hw::irq::CAN_SRC5',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC5.h',
                            'CAN_SRC5.cpp',
                            'CAN_SRC5_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC6',
                      'classname' => 'hw::irq::CAN_SRC6',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC6.h',
                            'CAN_SRC6.cpp',
                            'CAN_SRC6_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC7',
                      'classname' => 'hw::irq::CAN_SRC7',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC7.h',
                            'CAN_SRC7.cpp',
                            'CAN_SRC7_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC8',
                      'classname' => 'hw::irq::CAN_SRC8',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC8.h',
                            'CAN_SRC8.cpp',
                            'CAN_SRC8_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC9',
                      'classname' => 'hw::irq::CAN_SRC9',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC9.h',
                            'CAN_SRC9.cpp',
                            'CAN_SRC9_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC10',
                      'classname' => 'hw::irq::CAN_SRC10',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC10.h',
                            'CAN_SRC10.cpp',
                            'CAN_SRC10_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC11',
                      'classname' => 'hw::irq::CAN_SRC11',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC11.h',
                            'CAN_SRC11.cpp',
                            'CAN_SRC11_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC12',
                      'classname' => 'hw::irq::CAN_SRC12',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC12.h',
                            'CAN_SRC12.cpp',
                            'CAN_SRC12_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC13',
                      'classname' => 'hw::irq::CAN_SRC13',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC13.h',
                            'CAN_SRC13.cpp',
                            'CAN_SRC13_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC14',
                      'classname' => 'hw::irq::CAN_SRC14',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC14.h',
                            'CAN_SRC14.cpp',
                            'CAN_SRC14_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CAN_SRC15',
                      'classname' => 'hw::irq::CAN_SRC15',
                      'comp' => [
                        {
                          'files' => [
                            'CAN_SRC15.h',
                            'CAN_SRC15.cpp',
                            'CAN_SRC15_Init.ah',
                            'CAN_SRC.h'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'dev',
                  'subdir' => '/multican',
                  'comp' => [
                    {
                      'vname' => 'HwObject',
                      'comp' => [
                        {
                          'vname' => 'HwObject',
                          'classname' => 'hw::dev::can::tc1796multican::HwObject',
                          'comp' => [
                            {
                              'files' => [
                                'HwObject.h',
                                'HwObject.cpp'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_HWOBJECT_DEFAULT_IDE',
                          'comp' => [
                            {
                              'files' => [
                                'HwObject_pcCfg.h'
                              ]
                            }
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'Controller',
                      'comp' => [
                        {
                          'vname' => 'Controller',
                          'classname' => 'hw::dev::can::tc1796multican::Controller',
                          'comp' => [
                            {
                              'files' => [
                                'Controller.h',
                                'Controller.cpp'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_ID_0_MAPPED_UNIT',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_ID_1_MAPPED_UNIT',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_ID_2_MAPPED_UNIT',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_ID_3_MAPPED_UNIT',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_ID_0_INTERNAL_CONNECT',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_ID_1_INTERNAL_CONNECT',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_ID_2_INTERNAL_CONNECT',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_ID_3_INTERNAL_CONNECT',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_UNIT_0_MAPPED_ID',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_UNIT_1_MAPPED_ID',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_UNIT_2_MAPPED_ID',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'cfHW_DEV_CAN_TC_MULTICAN_CONTROLLER_UNIT_3_MAPPED_ID',
                          'comp' => [
                            {
                              'files' => [
                                'ControllerMapping.h'
                              ]
                            }
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'Highest ControllerId',
                      'comp' => [
                        {
                          'vname' => 'ControllerId0',
                          'comp' => [
                            {
                              'files' => [
                                'Controller_HighestIdIs0_pcCfg.ah'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'ControllerId1',
                          'comp' => [
                            {
                              'files' => [
                                'Controller_HighestIdIs1_pcCfg.ah'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'ControllerId2',
                          'comp' => [
                            {
                              'files' => [
                                'Controller_HighestIdIs2_pcCfg.ah'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'ControllerId3',
                          'comp' => [
                            {
                              'files' => [
                                'Controller_HighestIdIs3_pcCfg.ah'
                              ]
                            }
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'IdType',
                      'name' => 'comp_hw_dev_can_tc_multican_IdType',
                      'comp' => [
                        {
                          'vname' => 'IdType_Standard',
                          'comp' => [
                            {
                              'files' => [
                                'IdType_Standard.ah'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'IdType_Mixed',
                          'comp' => [
                            {
                              'files' => [
                                'IdType_Mixed.ah'
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'IdType_Extended',
                          'comp' => [
                            {
                              'files' => [
                                'IdType_Extended.ah'
                              ]
                            }
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'rx',
                      'name' => 'comp_hw_dev_can_tc_multican_rx',
                      'subdir' => '/rx',
                      'comp' => [
                        {
                          'vname' => 'polling',
                          'name' => 'comp_hw_dev_can_tc_multican_rx_polling',
                          'comp' => [
                            {
                              'name' => 'aspect_hw_dev_can_tc_multican_RxPolling_ControllerId0_Dispatch',
                              'comp' => [
                                {
                                  'files' => [
                                    'RxPolling_ControllerId0_Dispatch.ah'
                                  ]
                                }
                              ]
                            },
                            {
                              'name' => 'aspect_hw_dev_can_tc_multican_RxPolling_ControllerId1_Dispatch',
                              'comp' => [
                                {
                                  'files' => [
                                    'RxPolling_ControllerId1_Dispatch.ah'
                                  ]
                                }
                              ]
                            },
                            {
                              'name' => 'aspect_hw_dev_can_tc_multican_RxPolling_ControllerId2_Dispatch',
                              'comp' => [
                                {
                                  'files' => [
                                    'RxPolling_ControllerId2_Dispatch.ah'
                                  ]
                                }
                              ]
                            },
                            {
                              'name' => 'aspect_hw_dev_can_tc_multican_RxPolling_ControllerId3_Dispatch',
                              'comp' => [
                                {
                                  'files' => [
                                    'RxPolling_ControllerId3_Dispatch.ah'
                                  ]
                                }
                              ]
                            },
                            {
                              'vname' => 'RxPolling',
                              'comp' => [
                                {
                                  'files' => [
                                    'RxPolling.ah',
                                    'RxPolling_CanDriverImpl_Slice.ah',
                                    'RxPolling_AS_Slice.ah'
                                  ]
                                }
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'interrupt',
                          'name' => 'comp_hw_dev_can_tc_multican_rx_interrupt',
                          'comp' => [
                            {
                              'vname' => 'Controller Id 0',
                              'comp' => [
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_RxInterrupt_ControllerId0_Dispatch',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'RxInterrupt_ControllerId0_Dispatch.ah'
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_RxInterrupt_ControllerId0_Control',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'RxInterrupt_ControllerId0_Control.ah'
                                      ]
                                    }
                                  ]
                                }
                              ]
                            },
                            {
                              'vname' => 'Controller Id 1',
                              'comp' => [
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_RxInterrupt_ControllerId1_Dispatch',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'RxInterrupt_ControllerId1_Dispatch.ah'
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_RxInterrupt_ControllerId1_Control',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'RxInterrupt_ControllerId1_Control.ah'
                                      ]
                                    }
                                  ]
                                }
                              ]
                            },
                            {
                              'vname' => 'Controller Id 2',
                              'comp' => [
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_RxInterrupt_ControllerId2_Dispatch',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'RxInterrupt_ControllerId2_Dispatch.ah'
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_RxInterrupt_ControllerId2_Control',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'RxInterrupt_ControllerId2_Control.ah'
                                      ]
                                    }
                                  ]
                                }
                              ]
                            },
                            {
                              'vname' => 'Controller Id 3',
                              'comp' => [
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_RxInterrupt_ControllerId3_Dispatch',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'RxInterrupt_ControllerId3_Dispatch.ah'
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_RxInterrupt_ControllerId3_Control',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'RxInterrupt_ControllerId3_Control.ah'
                                      ]
                                    }
                                  ]
                                }
                              ]
                            }
                          ]
                        },
                        {
                          'vname' => 'RxIndication',
                          'comp' => [
                            {
                              'files' => [
                                'RxIndication.ah',
                                'RxIndication_DriverSlice.ah',
                                'RxIndication_HwObjectSlice.ah'
                              ]
                            }
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'tx',
                      'name' => 'comp_hw_dev_can_tc_multican_tx',
                      'subdir' => '/tx',
                      'comp' => [
                        {
                          'vname' => 'confirmation',
                          'name' => 'comp_hw_dev_can_tc_multican_tx_confirmation',
                          'comp' => [
                            {
                              'vname' => 'polling',
                              'name' => 'comp_hw_dev_can_tc_multican_tx_confirmation_polling',
                              'comp' => [
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationPolling_ControllerId0_Dispatch',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'TxConfirmationPolling_ControllerId0_Dispatch.ah'
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationPolling_ControllerId1_Dispatch',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'TxConfirmationPolling_ControllerId1_Dispatch.ah'
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationPolling_ControllerId2_Dispatch',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'TxConfirmationPolling_ControllerId2_Dispatch.ah'
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationPolling_ControllerId3_Dispatch',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'TxConfirmationPolling_ControllerId3_Dispatch.ah'
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'vname' => 'TxConfirmationPolling',
                                  'comp' => [
                                    {
                                      'files' => [
                                        'TxConfirmationPolling.ah',
                                        'TxConfirmationPolling_CanDriverImpl_Slice.ah',
                                        'TxConfirmationPolling_AS_Slice.ah'
                                      ]
                                    }
                                  ]
                                }
                              ]
                            },
                            {
                              'vname' => 'interrupt',
                              'name' => 'comp_hw_dev_can_tc_multican_tx_confirmation_interrupt',
                              'comp' => [
                                {
                                  'vname' => 'Controller Id 0',
                                  'comp' => [
                                    {
                                      'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationInterrupt_ControllerId0_Dispatch',
                                      'comp' => [
                                        {
                                          'files' => [
                                            'TxConfirmationInterrupt_ControllerId0_Dispatch.ah'
                                          ]
                                        }
                                      ]
                                    },
                                    {
                                      'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationInterrupt_ControllerId0_Control',
                                      'comp' => [
                                        {
                                          'files' => [
                                            'TxConfirmationInterrupt_ControllerId0_Control.ah'
                                          ]
                                        }
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'vname' => 'Controller Id 1',
                                  'comp' => [
                                    {
                                      'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationInterrupt_ControllerId1_Dispatch',
                                      'comp' => [
                                        {
                                          'files' => [
                                            'TxConfirmationInterrupt_ControllerId1_Dispatch.ah'
                                          ]
                                        }
                                      ]
                                    },
                                    {
                                      'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationInterrupt_ControllerId1_Control',
                                      'comp' => [
                                        {
                                          'files' => [
                                            'TxConfirmationInterrupt_ControllerId1_Control.ah'
                                          ]
                                        }
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'vname' => 'Controller Id 2',
                                  'comp' => [
                                    {
                                      'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationInterrupt_ControllerId2_Dispatch',
                                      'comp' => [
                                        {
                                          'files' => [
                                            'TxConfirmationInterrupt_ControllerId2_Dispatch.ah'
                                          ]
                                        }
                                      ]
                                    },
                                    {
                                      'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationInterrupt_ControllerId2_Control',
                                      'comp' => [
                                        {
                                          'files' => [
                                            'TxConfirmationInterrupt_ControllerId2_Control.ah'
                                          ]
                                        }
                                      ]
                                    }
                                  ]
                                },
                                {
                                  'vname' => 'Controller Id 3',
                                  'comp' => [
                                    {
                                      'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationInterrupt_ControllerId3_Dispatch',
                                      'comp' => [
                                        {
                                          'files' => [
                                            'TxConfirmationInterrupt_ControllerId3_Dispatch.ah'
                                          ]
                                        }
                                      ]
                                    },
                                    {
                                      'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmationInterrupt_ControllerId3_Control',
                                      'comp' => [
                                        {
                                          'files' => [
                                            'TxConfirmationInterrupt_ControllerId3_Control.ah'
                                          ]
                                        }
                                      ]
                                    }
                                  ]
                                }
                              ]
                            },
                            {
                              'name' => 'aspect_hw_dev_can_tc_multican_TxConfirmation',
                              'comp' => [
                                {
                                  'files' => [
                                    'TxConfirmation.ah',
                                    'TxConfirmation_DriverSlice.ah',
                                    'TxConfirmation_HwObjectSlice.ah'
                                  ]
                                }
                              ]
                            }
                          ]
                        },
                        {
                          'name' => 'aspect_hw_dev_can_tc_multican_Tx',
                          'comp' => [
                            {
                              'files' => [
                                'Tx.ah',
                                'Tx_HwObjectSlice.ah',
                                'Tx_CanDriverImpl_Slice.ah'
                              ]
                            }
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'CanDriverImpl',
                      'classname' => 'hw::dev::can::tc1796multican::CanDriverImpl',
                      'comp' => [
                        {
                          'files' => [
                            'CanDriverImpl.h',
                            'CanDriverImpl.cpp'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'ClockManager',
                      'classname' => 'hw::dev::can::tc1796multican::ClockManager',
                      'comp' => [
                        {
                          'files' => [
                            'ClockManager.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'ListManager',
                      'classname' => 'hw::dev::can::tc1796multican::ListManager',
                      'comp' => [
                        {
                          'files' => [
                            'ListManager.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'PendingHwObjManager',
                      'classname' => 'hw::dev::can::tc1796multican::PendingHwObjManager',
                      'comp' => [
                        {
                          'files' => [
                            'PendingHwObjManager.h',
                            'PendingHwObjManager.cpp'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'RegTypes',
                      'comp' => [
                        {
                          'srcfile' => 'RegTypes_tc1796b.h',
                          'file' => 'RegTypes.h'
                        }
                      ]
                    },
                    {
                      'vname' => 'DevelopmentErrors',
                      'comp' => [
                        {
                          'files' => [
                            'DevelopmentErrors.ah'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'Cfg',
                      'comp' => [
                        {
                          'files' => [
                            'Cfg.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'InterruptScheme',
                      'comp' => [
                        {
                          'files' => [
                            'InterruptScheme.h'
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'Addr',
                      'comp' => [
                        {
                          'srcfile' => 'Addr_tc1796b.h',
                          'file' => 'Addr.h'
                        }
                      ]
                    },
                    {
                      'vname' => 'CanDriverImpl_Init',
                      'comp' => [
                        {
                          'files' => [
                            'CanDriverImpl_Init.ah'
                          ]
                        }
                      ]
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          'vname' => 'trap',
          'name' => 'ciao_platform_hw_trap',
          'subdir' => 'trap/!ARCH',
          'comp' => [
            {
              'vname' => 'trap6',
              'name' => 'ciao_platform_hw_trap_6',
              'comp' => [
                {
                  'vname' => 'TRAP6 (panic)',
                  'name' => 'ciao_platform_hw_trap_6_panic',
                  'depends' => '&trap_6_panic',
                  'classname' => 'hw::trap::TRAP6',
                  'comp' => [
                    {
                      'srcfile' => 'TRAP6_panic.cpp',
                      'file' => 'TRAP6.cpp'
                    },
                    {
                      'srcfile' => 'TRAP6_panic.h',
                      'file' => 'TRAP6.h'
                    }
                  ]
                },
                {
                  'vname' => 'TRAP6 (manipulate context)',
                  'name' => 'ciao_platform_hw_trap_6_panic_1',
                  'depends' => '&trap_6_ctxmanip',
                  'classname' => 'hw::trap::TRAP6',
                  'comp' => [
                    {
                      'srcfile' => 'TRAP6_ctxmanipulation.cpp',
                      'file' => 'TRAP6.cpp'
                    },
                    {
                      'srcfile' => 'TRAP6_ctxmanipulation.h',
                      'file' => 'TRAP6.h'
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'trap1',
              'name' => 'ciao_platform_hw_trap_1',
              'comp' => [
                {
                  'vname' => 'TRAP1 (call protection hook)',
                  'name' => 'ciao_platform_hw_trap_1_callhook',
                  'classname' => 'hw::trap::TRAP1',
                  'comp' => [
                    {
                      'srcfile' => 'TRAP1_callhook.cpp',
                      'file' => 'TRAP1_callhook.cpp'
                    }
                  ]
                }
              ]
            }
          ]
        }
      ]
    },
    {
      'vname' => 'os',
      'depends' => '&os_com_ascom',
      'subdir' => '/os/',
      'comp' => [
        {
          'vname' => 'com',
          'subdir' => '/com/',
          'comp' => [
            {
              'vname' => 'ascom',
              'subdir' => '/ascom/',
              'comp' => [
                {
                  'vname' => 'ArchEndianess_Little',
                  'comp' => [
                    {
                      'files' => [
                        'ArchEndianess_Little.ah'
                      ]
                    }
                  ]
                }
              ]
            }
          ]
        }
      ]
    }
  ]
};
