#!/usr/bin/perl

use warnings;
use strict;

use Data::Dumper;

use SystemConfiguration;

if(@ARGV != 3 || $ARGV[0] !~ /\.xml$/ || $ARGV[2] !~ /\.h$/) {
	print STDERR "Usage: $0 <config.xml> <os.config> <EthernetTelemetry_collector.h>\n";
	exit 1;
}

my $cfg = SystemConfiguration->new($ARGV[0], $ARGV[1]);

## Here comes the actual generation code
open (CPP, ">$ARGV[2]") || die "cannot open $ARGV[2]\n";

print CPP <<eofjs;
	PacketInMessage *msg;

	bool msgReceived = false;
	do {
		msgReceived = false;
eofjs

foreach my $msgP ($cfg->getMessagePorts()) {
	if ( $msgP->{name} =~ /Ethernet$/ ) {
		my $name = $msgP->{name};
		$name =~ s/Ethernet$//;

		print CPP <<eofjs;
		// ${name}
		msg = ${name}Ethernet_receiver.receiveMessage();
		if ( msg != 0x0 ) {
			msgReceived = true;
			appendPacket(msg);
			${name}Ethernet_receiver.releaseMessage(msg);
		}
eofjs
	}
}

print CPP <<eofjs;
	} while ( msgReceived );
eofjs

close(CPP);
