/*
 * File: AttitudeController.cpp
 *
 * Real-Time Workshop code generated for Simulink model AttitudeController.
 *
 * Model version                        : 1.397
 * Real-Time Workshop file version      : 7.4  (R2009b)  29-Jun-2009
 * Real-Time Workshop file generated on : Fri Apr 30 13:08:30 2010
 * TLC version                          : 7.4 (Jul 14 2009)
 * C/C++ source code generated on       : Fri Apr 30 13:08:30 2010
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: 32-bit Generic
 * Emulation hardware selection:
 *    Differs from embedded hardware (MATLAB Host)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "AttitudeController.h"
#include "AttitudeController_private.h"

/* Model step function */
void AttitudeControllerModelClass::step()
{
  /* local block i/o variables */
  real32_T rtb_DiscreteTimeIntegrator2;
  real32_T rtb_TrigonometricFunction4;
  real32_T rtb_Sum6_c;

  {
    int_T idx;
    real32_T numAccum;
    real32_T numAccum_0;
    real32_T rtb_Sum3_g;
    real32_T rtb_omega_n;
    real32_T rtb_FilterCoefficient;
    real32_T rtb_IntegerDelay3;
    real32_T rtb_omega;
    real32_T rtb_Divide;
    real32_T rtb_Sum6;
    real32_T rtb_EngineCap1;
    real32_T rtb_EngineCap2;
    real32_T rtb_EngineCap3;
    real32_T rtb_EngineCap4;
    real32_T rtb_omega_mot_h;
    real32_T rtb_Polynomial4;
    real32_T rtb_omega_mot_p;
    real32_T rtb_omega_mot_g;
    real32_T rtb_Sum1_l;
    real32_T rtb_Gain5_a;
    real32_T rtb_Sum4;
    real32_T omega_mot;
    real32_T omega_mot_h;
    real32_T rtb_TmpSignalConversionAtGain4Inport1_idx;
    real32_T rtb_TmpSignalConversionAtGain4Inport1_idx_0;
    real32_T rtb_TmpSignalConversionAtGain4Inport1_i_idx;
    real32_T rtb_TmpSignalConversionAtGain4Inport1_i_idx_0;
    real_T tmp;

    /* Sum: '<Root>/Sum3' incorporates:
     *  Gain: '<Root>/Gain2'
     *  Inport: '<Root>/SetYaw'
     *  Inport: '<Root>/Z_GyroIN'
     *  Sum: '<Root>/Sum1'
     */
    rtb_Sum3_g = AttitudeController_U.SetYaw - ((-AttitudeController_U.Z_GyroIN)
      + 0.0F);

    /* DiscreteIntegrator: '<S3>/Filter' */
    rtb_DiscreteTimeIntegrator2 = AttitudeController_DWork.Filter_DSTATE;

    /* Gain: '<S3>/Filter Coefficient' incorporates:
     *  Gain: '<S3>/Derivative Gain'
     *  Sum: '<S3>/SumD'
     */
    rtb_FilterCoefficient = (0.0F * rtb_Sum3_g - rtb_DiscreteTimeIntegrator2) *
      100.0F;

    /* Gain: '<S4>/Motor//Rotor// CONST1' incorporates:
     *  DiscreteIntegrator: '<S3>/Integrator'
     *  Gain: '<S3>/Proportional Gain'
     *  Sum: '<S3>/Sum'
     */
    rtb_DiscreteTimeIntegrator2 = ((9.0F * rtb_Sum3_g +
      AttitudeController_DWork.Integrator_DSTATE) + rtb_FilterCoefficient) *
      1.666666603E+001F;

    /* Saturate: '<S4>/Saturation' */
    rtb_DiscreteTimeIntegrator2 = rt_SATURATE(rtb_DiscreteTimeIntegrator2,
      -60.0F, 60.0F);

    /* DiscreteIntegrator: '<S10>/Discrete-Time Integrator' */
    rtb_omega_n = AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE;

    /* DiscreteIntegrator: '<S10>/Discrete-Time Integrator1' */
    AttitudeController_Y.ApproxPitchAngle =
      AttitudeController_DWork.DiscreteTimeIntegrator1_DSTATE;

    /* SignalConversion: '<S2>/TmpSignal ConversionAtGain4Inport1' */
    rtb_TmpSignalConversionAtGain4Inport1_idx =
      AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE;
    rtb_TmpSignalConversionAtGain4Inport1_idx_0 =
      AttitudeController_Y.ApproxPitchAngle;

    /* S-Function (sfix_udelay): '<S6>/Integer Delay3' */
    rtb_IntegerDelay3 = AttitudeController_DWork.IntegerDelay3_X[0];

    /* DiscreteIntegrator: '<S7>/Discrete-Time Integrator' */
    rtb_omega = AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_p;

    /* DiscreteIntegrator: '<S7>/Discrete-Time Integrator1' */
    AttitudeController_Y.ApproxRollAngle =
      AttitudeController_DWork.DiscreteTimeIntegrator1_DSTATE_f;

    /* SignalConversion: '<S1>/TmpSignal ConversionAtGain4Inport1' */
    rtb_TmpSignalConversionAtGain4Inport1_i_idx =
      AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_p;
    rtb_TmpSignalConversionAtGain4Inport1_i_idx_0 =
      AttitudeController_Y.ApproxRollAngle;

    /* Product: '<S5>/Divide' incorporates:
     *  Gain: '<S5>/korrektur'
     *  Gain: '<S5>/korrektur1'
     *  Gain: '<S5>/umrechnung'
     *  Inport: '<Root>/SetThrottle'
     *  Product: '<S1>/Product2'
     *  Product: '<S2>/Product2'
     *  Product: '<S5>/Divide1'
     *  Trigonometry: '<S5>/Trigonometric Function1'
     *  Trigonometry: '<S5>/Trigonometric Function2'
     */
    rtb_Divide = 1.072968766E-001F * AttitudeController_U.SetThrottle /
      (real32_T)cos(AttitudeController_Y.ApproxPitchAngle *
                    AttitudeController_DWork.IntegerDelay3_X[0] *
                    6.999999881E-001F) / (real32_T)cos
      (AttitudeController_Y.ApproxRollAngle *
       AttitudeController_DWork.IntegerDelay3_X[0] * 6.999999881E-001F);

    /* Polyval: '<S4>/Polynomial3' */
    rtb_Sum6 = ((4.119052552E-003F * rtb_Divide + -3.114550710E-001F) *
                rtb_Divide + 1.282051277E+001F) * rtb_Divide;

    /* DiscreteTransferFcn: '<S1>/VorfilterY' incorporates:
     *  Inport: '<Root>/SetRoll'
     */
    AttitudeController_DWork.VorfilterY_tmp = (((AttitudeController_U.SetRoll -
      -3.574389458E+000F * AttitudeController_DWork.VorfilterY_DSTATE[0]) -
      4.791097164E+000F * AttitudeController_DWork.VorfilterY_DSTATE[1]) -
      -2.854207993E+000F * AttitudeController_DWork.VorfilterY_DSTATE[2]) -
      6.376281381E-001F * AttitudeController_DWork.VorfilterY_DSTATE[3];
    rtb_TrigonometricFunction4 = (((1.072875977E+000F *
      AttitudeController_DWork.VorfilterY_tmp + -3.403770208E+000F *
      AttitudeController_DWork.VorfilterY_DSTATE[0]) + 3.988372326E+000F *
      AttitudeController_DWork.VorfilterY_DSTATE[1]) + -2.037089825E+000F *
      AttitudeController_DWork.VorfilterY_DSTATE[2]) + 3.805812597E-001F *
      AttitudeController_DWork.VorfilterY_DSTATE[3];

    /* S-Function (sfix_udelay): '<S7>/Integer Delay' */
    omega_mot = AttitudeController_DWork.IntegerDelay_X[0];

    /* DiscreteTransferFcn: '<S7>/Discrete Transfer Fcn' */
    numAccum = 9.130400419E-002F *
      AttitudeController_DWork.DiscreteTransferFcn_DSTATE;

    /* DiscreteTransferFcn: '<S7>/Discrete Transfer Fcn1' */
    rtb_Sum6_c = 5.934303403E-001F *
      AttitudeController_DWork.DiscreteTransferFcn1_DSTATE;

    /* Gain: '<S1>/Gain1' incorporates:
     *  Product: '<S1>/Product1'
     */
    rtb_Sum6_c = ((AttitudeController_DWork.IntegerDelay3_X[0] *
                   AttitudeController_DWork.IntegerDelay_X[0] *
                   4.589999914E-001F + AttitudeController_DWork.IntegerDelay3_X
                   [0] * numAccum * 2.924700022E+000F) +
                  AttitudeController_DWork.IntegerDelay3_X[0] * rtb_Sum6_c *
                  1.265300035E+000F) + AttitudeController_DWork.IntegerDelay3_X
      [0] * AttitudeController_Y.ApproxRollAngle * 7.404200077E+000F;

    /* Sum: '<S1>/Sum' */
    rtb_Divide = rtb_TrigonometricFunction4 - rtb_Sum6_c;

    /* DiscreteIntegrator: '<S1>/Discrete-Time Integrator' */
    rtb_Sum6_c = AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_pr;

    /* Sum: '<S1>/Sum1' */
    rtb_Sum6_c += rtb_Divide;

    /* Gain: '<S4>/Motor//Rotor// CONST' incorporates:
     *  Saturate: '<S1>/Saturation'
     */
    rtb_Sum6_c = 4.397537231E+001F * rt_SATURATE(rtb_Sum6_c, -1.478099942E+000F,
      1.478099942E+000F);

    /* Sum: '<S4>/Sum7' incorporates:
     *  Sum: '<S4>/Sum'
     */
    rtb_TrigonometricFunction4 = (rtb_Sum6 + rtb_Sum6_c) -
      rtb_DiscreteTimeIntegrator2;

    /* Quantizer: '<S4>/Quantizer' */
    {
      real32_T yre;
      yre = 1.0F * (real32_T)floor((real32_T)fabs((rtb_TrigonometricFunction4/
        (1.0F))) + 0.5F);
      rtb_TrigonometricFunction4 = ((rtb_TrigonometricFunction4 >= 0.0F) ? yre :
        -yre);
    }

    /* Saturate: '<S4>/EngineCap1' */
    rtb_EngineCap1 = rt_SATURATE(rtb_TrigonometricFunction4, 10.0F, 210.0F);

    /* Outport: '<Root>/th1out' incorporates:
     *  DataTypeConversion: '<Root>/Type Conv3'
     */
    tmp = fmod(floor((real_T)rtb_EngineCap1), 256.0);
    AttitudeController_Y.th1out = tmp < 0.0 ? (uint8_T)(int8_T)(-((int8_T)
      (uint8_T)(-tmp))) : (uint8_T)tmp;

    /* DiscreteTransferFcn: '<S2>/VorfilterX' incorporates:
     *  Inport: '<Root>/SetPitch'
     */
    AttitudeController_DWork.VorfilterX_tmp = (((AttitudeController_U.SetPitch -
      -3.574389458E+000F * AttitudeController_DWork.VorfilterX_DSTATE[0]) -
      4.791097164E+000F * AttitudeController_DWork.VorfilterX_DSTATE[1]) -
      -2.854207993E+000F * AttitudeController_DWork.VorfilterX_DSTATE[2]) -
      6.376281381E-001F * AttitudeController_DWork.VorfilterX_DSTATE[3];
    rtb_TrigonometricFunction4 = (((1.072875977E+000F *
      AttitudeController_DWork.VorfilterX_tmp + -3.403770208E+000F *
      AttitudeController_DWork.VorfilterX_DSTATE[0]) + 3.988372326E+000F *
      AttitudeController_DWork.VorfilterX_DSTATE[1]) + -2.037089825E+000F *
      AttitudeController_DWork.VorfilterX_DSTATE[2]) + 3.805812597E-001F *
      AttitudeController_DWork.VorfilterX_DSTATE[3];

    /* S-Function (sfix_udelay): '<S10>/Integer Delay' */
    omega_mot_h = AttitudeController_DWork.IntegerDelay_X_c[0];

    /* DiscreteTransferFcn: '<S10>/Discrete Transfer Fcn' */
    numAccum_0 = 9.130400419E-002F *
      AttitudeController_DWork.DiscreteTransferFcn_DSTATE_p;

    /* Sum: '<S2>/Sum1' incorporates:
     *  DiscreteIntegrator: '<S2>/Discrete-Time Integrator'
     *  DiscreteTransferFcn: '<S10>/Discrete Transfer Fcn1'
     *  Gain: '<S2>/Gain1'
     *  Product: '<S2>/Product1'
     *  Sum: '<S2>/Sum'
     */
    rtb_Sum4 = (rtb_TrigonometricFunction4 - (((rtb_IntegerDelay3 *
      AttitudeController_DWork.IntegerDelay_X_c[0] * 4.589999914E-001F +
      rtb_IntegerDelay3 * numAccum_0 * 2.924700022E+000F) + 5.934303403E-001F *
      AttitudeController_DWork.DiscreteTransferFcn1_DSTATE_k * rtb_IntegerDelay3
      * 1.265300035E+000F) + rtb_IntegerDelay3 *
      AttitudeController_Y.ApproxPitchAngle * 7.404200077E+000F)) +
      AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_e;

    /* Gain: '<S4>/Motor//Rotor// CONST2' incorporates:
     *  Saturate: '<S2>/Saturation'
     */
    rtb_Sum4 = 4.397537231E+001F * rt_SATURATE(rtb_Sum4, -1.478099942E+000F,
      1.478099942E+000F);

    /* Sum: '<S4>/Sum4' incorporates:
     *  Sum: '<S4>/Sum1'
     */
    rtb_TrigonometricFunction4 = (rtb_Sum6 + rtb_Sum4) +
      rtb_DiscreteTimeIntegrator2;

    /* Quantizer: '<S4>/Quantizer1' */
    {
      real32_T yre;
      yre = 1.0F * (real32_T)floor((real32_T)fabs((rtb_TrigonometricFunction4/
        (1.0F))) + 0.5F);
      rtb_TrigonometricFunction4 = ((rtb_TrigonometricFunction4 >= 0.0F) ? yre :
        -yre);
    }

    /* Saturate: '<S4>/EngineCap2' */
    rtb_EngineCap2 = rt_SATURATE(rtb_TrigonometricFunction4, 10.0F, 210.0F);

    /* Outport: '<Root>/th2out' incorporates:
     *  DataTypeConversion: '<Root>/Type Conv2'
     */
    tmp = fmod(floor((real_T)rtb_EngineCap2), 256.0);
    AttitudeController_Y.th2out = tmp < 0.0 ? (uint8_T)(int8_T)(-((int8_T)
      (uint8_T)(-tmp))) : (uint8_T)tmp;

    /* Sum: '<S4>/Sum6' incorporates:
     *  Sum: '<S4>/Sum2'
     */
    rtb_Sum6_c = (rtb_Sum6 - rtb_Sum6_c) - rtb_DiscreteTimeIntegrator2;

    /* Quantizer: '<S4>/Quantizer2' */
    {
      real32_T yre;
      yre = 1.0F * (real32_T)floor((real32_T)fabs((rtb_Sum6_c/(1.0F))) + 0.5F);
      rtb_Sum6_c = ((rtb_Sum6_c >= 0.0F) ? yre : -yre);
    }

    /* Saturate: '<S4>/EngineCap3' */
    rtb_EngineCap3 = rt_SATURATE(rtb_Sum6_c, 10.0F, 210.0F);

    /* Outport: '<Root>/th3out' incorporates:
     *  DataTypeConversion: '<Root>/Type Conv1'
     */
    tmp = fmod(floor((real_T)rtb_EngineCap3), 256.0);
    AttitudeController_Y.th3out = tmp < 0.0 ? (uint8_T)(int8_T)(-((int8_T)
      (uint8_T)(-tmp))) : (uint8_T)tmp;

    /* Sum: '<S4>/Sum5' incorporates:
     *  Sum: '<S4>/Sum3'
     */
    rtb_DiscreteTimeIntegrator2 += rtb_Sum6 - rtb_Sum4;

    /* Quantizer: '<S4>/Quantizer3' */
    {
      real32_T yre;
      yre = 1.0F * (real32_T)floor((real32_T)fabs((rtb_DiscreteTimeIntegrator2/
        (1.0F))) + 0.5F);
      rtb_DiscreteTimeIntegrator2 = ((rtb_DiscreteTimeIntegrator2 >= 0.0F) ? yre
        : -yre);
    }

    /* Saturate: '<S4>/EngineCap4' */
    rtb_EngineCap4 = rt_SATURATE(rtb_DiscreteTimeIntegrator2, 10.0F, 210.0F);

    /* Outport: '<Root>/th4out' incorporates:
     *  DataTypeConversion: '<Root>/Type Conv'
     */
    tmp = fmod(floor((real_T)rtb_EngineCap4), 256.0);
    AttitudeController_Y.th4out = tmp < 0.0 ? (uint8_T)(int8_T)(-((int8_T)
      (uint8_T)(-tmp))) : (uint8_T)tmp;

    /* Saturate: '<S10>/Saturation' */
    rtb_Sum4 = rt_SATURATE(0.0F, -1.200000048E+000F, 1.200000048E+000F);

    /* Outport: '<Root>/ObsX_x1' */
    AttitudeController_Y.ObsX_x1 = rtb_Sum4;

    /* DiscreteIntegrator: '<S10>/Discrete-Time Integrator4' */
    rtb_Sum6_c = AttitudeController_DWork.DiscreteTimeIntegrator4_DSTATE;

    /* Outport: '<Root>/ObsX_x2' */
    AttitudeController_Y.ObsX_x2 = rtb_Sum6_c;

    /* Outport: '<Root>/ObsX_x3' */
    AttitudeController_Y.ObsX_x3 = rtb_omega_n;

    /* Saturate: '<S7>/Saturation' */
    rtb_TrigonometricFunction4 = rt_SATURATE(0.0F, -1.200000048E+000F,
      1.200000048E+000F);

    /* Outport: '<Root>/ObsY_x1' */
    AttitudeController_Y.ObsY_x1 = rtb_TrigonometricFunction4;

    /* Outport: '<Root>/ObsY_x2' incorporates:
     *  DiscreteIntegrator: '<S7>/Discrete-Time Integrator3'
     */
    AttitudeController_Y.ObsY_x2 =
      AttitudeController_DWork.DiscreteTimeIntegrator3_DSTATE;

    /* Outport: '<Root>/ObsY_x3' */
    AttitudeController_Y.ObsY_x3 = rtb_omega;

    /* DiscreteTransferFcn: '<S10>/Discrete Transfer Fcn2' */
    rtb_DiscreteTimeIntegrator2 = 5.934303403E-001F *
      AttitudeController_DWork.DiscreteTransferFcn2_DSTATE;

    /* Outport: '<Root>/Approx_Jpitch' */
    AttitudeController_Y.Approx_Jpitch = rtb_DiscreteTimeIntegrator2;

    /* DiscreteTransferFcn: '<S7>/Discrete Transfer Fcn2' */
    rtb_DiscreteTimeIntegrator2 = 5.934303403E-001F *
      AttitudeController_DWork.DiscreteTransferFcn2_DSTATE_i;

    /* Outport: '<Root>/Approx_Jroll' */
    AttitudeController_Y.Approx_Jroll = rtb_DiscreteTimeIntegrator2;

    /* Outport: '<Root>/compare' */
    AttitudeController_Y.compare = rtb_IntegerDelay3;

    /* DiscreteIntegrator: '<S10>/Discrete-Time Integrator2' */
    rtb_DiscreteTimeIntegrator2 =
      AttitudeController_DWork.DiscreteTimeIntegrator2_DSTATE;

    /* Outport: '<Root>/ObsX_x5' */
    AttitudeController_Y.ObsX_x5 = rtb_DiscreteTimeIntegrator2;

    /* Trigonometry: '<S10>/Trigonometric Function4' */
    rtb_Sum4 = (real32_T)asin(rt_SATURATE(rtb_Sum4, -1.0F, 1.0F));

    /* Sum: '<S10>/Sum2' incorporates:
     *  S-Function (sfix_udelay): '<S10>/Integer Delay3'
     */
    rtb_omega_mot_h = rtb_Sum4 - AttitudeController_DWork.IntegerDelay3_X_c[0];

    /* Switch: '<S10>/Switch1' incorporates:
     *  Gain: '<S10>/Gain5'
     *  Gain: '<S10>/Gain8'
     */
    rtb_Polynomial4 = 4.000000060E-001F * rtb_omega_mot_h;

    /* Outport: '<Root>/ObsX_x6' */
    AttitudeController_Y.ObsX_x6 = rtb_Polynomial4;

    /* Outport: '<Root>/ObsX_x7' */
    AttitudeController_Y.ObsX_x7 = rtb_Sum4;

    /* Outport: '<Root>/ObsY_x5' incorporates:
     *  DiscreteIntegrator: '<S7>/Discrete-Time Integrator2'
     */
    AttitudeController_Y.ObsY_x5 =
      AttitudeController_DWork.DiscreteTimeIntegrator2_DSTATE_j;

    /* Trigonometry: '<S7>/Trigonometric Function4' */
    rtb_TrigonometricFunction4 = (real32_T)asin(rt_SATURATE
      (rtb_TrigonometricFunction4, -1.0F, 1.0F));

    /* Sum: '<S7>/Sum2' incorporates:
     *  S-Function (sfix_udelay): '<S7>/Integer Delay3'
     */
    rtb_omega_mot_p = rtb_TrigonometricFunction4 -
      AttitudeController_DWork.IntegerDelay3_X_l[0];

    /* Switch: '<S7>/Switch1' incorporates:
     *  Gain: '<S7>/Gain1'
     *  Gain: '<S7>/Gain6'
     */
    rtb_omega_mot_g = 4.000000060E-001F * rtb_omega_mot_p;

    /* Outport: '<Root>/ObsY_x6' */
    AttitudeController_Y.ObsY_x6 = rtb_omega_mot_g;

    /* Outport: '<Root>/ObsY_x7' */
    AttitudeController_Y.ObsY_x7 = rtb_TrigonometricFunction4;

    /* Sum: '<S7>/Sum6' incorporates:
     *  DiscreteIntegrator: '<S7>/Discrete-Time Integrator3'
     *  Inport: '<Root>/X_GyroAccIN'
     */
    rtb_Sum6 = AttitudeController_U.X_GyroAccIN[0] -
      AttitudeController_DWork.DiscreteTimeIntegrator3_DSTATE;

    /* Sum: '<S7>/Sum1' */
    rtb_Sum1_l = rtb_Sum6 - rtb_omega;

    /* Gain: '<S7>/Gain4' */
    rtb_Divide = -0.25F * rtb_omega_mot_p;

    /* Gain: '<S7>/Gain5' */
    rtb_Gain5_a = -0.25F * rtb_omega_mot_p;

    /* Sum: '<S7>/Sum4' */
    rtb_Sum4 = rtb_Sum6 + rtb_omega_mot_g;

    /* Polyval: '<S6>/Polynomial2' */
    rtb_omega_mot_g = ((2.289771999E-007F * rtb_EngineCap3 + 2.791137740E-005F) *
                       rtb_EngineCap3 + 1.950000040E-002F) * rtb_EngineCap3;

    /* Polyval: '<S6>/Polynomial3' */
    rtb_omega_mot_p = ((2.289771999E-007F * rtb_EngineCap1 + 2.791137740E-005F) *
                       rtb_EngineCap1 + 1.950000040E-002F) * rtb_EngineCap1;

    /* Sum: '<S7>/Sum5' incorporates:
     *  DiscreteIntegrator: '<S7>/Discrete-Time Integrator2'
     *  Gain: '<S6>/Gain4'
     *  Product: '<S6>/Product'
     *  Sum: '<S6>/Sum3'
     */
    AttitudeController_B.Sum5 = (rtb_omega_mot_p - rtb_omega_mot_g) *
      3.000000119E-001F * rtb_IntegerDelay3 +
      AttitudeController_DWork.DiscreteTimeIntegrator2_DSTATE_j;

    /* Switch: '<S7>/Switch' */
    if (rtb_IntegerDelay3 > 0.0F) {
      rtb_Gain5_a = rtb_Divide;
    }

    /* Sum: '<S10>/Sum6' incorporates:
     *  Inport: '<Root>/Y_GyroAccIN'
     */
    rtb_Sum6_c = AttitudeController_U.Y_GyroAccIN[0] - rtb_Sum6_c;

    /* Sum: '<S10>/Sum1' */
    rtb_omega = rtb_Sum6_c - rtb_omega_n;

    /* Gain: '<S10>/Gain6' */
    rtb_Divide = -0.25F * rtb_omega_mot_h;

    /* Gain: '<S10>/Gain7' */
    rtb_EngineCap1 = -0.25F * rtb_omega_mot_h;

    /* Sum: '<S10>/Sum4' */
    rtb_EngineCap3 = rtb_Sum6_c + rtb_Polynomial4;

    /* Polyval: '<S6>/Polynomial4' */
    rtb_Polynomial4 = ((2.289771999E-007F * rtb_EngineCap4 + 2.791137740E-005F) *
                       rtb_EngineCap4 + 1.950000040E-002F) * rtb_EngineCap4;

    /* Polyval: '<S6>/Polynomial1' */
    rtb_omega_mot_h = ((2.289771999E-007F * rtb_EngineCap2 + 2.791137740E-005F) *
                       rtb_EngineCap2 + 1.950000040E-002F) * rtb_EngineCap2;

    /* Sum: '<S10>/Sum5' incorporates:
     *  Gain: '<S6>/Gain6'
     *  Product: '<S6>/Product1'
     *  Sum: '<S6>/Sum12'
     */
    AttitudeController_B.Sum5_i = (rtb_omega_mot_h - rtb_Polynomial4) *
      3.000000119E-001F * rtb_IntegerDelay3 + rtb_DiscreteTimeIntegrator2;

    /* Switch: '<S10>/Switch' */
    if (rtb_IntegerDelay3 > 0.0F) {
      rtb_EngineCap1 = rtb_Divide;
    }

    /* DataTypeConversion: '<S6>/Type Conv3' incorporates:
     *  Gain: '<S6>/Gain2'
     *  Inport: '<Root>/takeOffValue'
     *  RelationalOperator: '<S6>/Relational Operator'
     *  Sum: '<S6>/Sum2'
     */
    AttitudeController_B.TypeConv3 = (real32_T)(((rtb_Polynomial4 +
      rtb_omega_mot_g) + rtb_omega_mot_h) + rtb_omega_mot_p >= 1.373400021E+001F
      * AttitudeController_U.takeOffValue);

    /* Update for DiscreteIntegrator: '<S3>/Integrator' incorporates:
     *  Gain: '<S3>/Integral Gain'
     */
    AttitudeController_DWork.Integrator_DSTATE = 6.000000238E-001F * rtb_Sum3_g *
      8.999999613E-003F + AttitudeController_DWork.Integrator_DSTATE;

    /* Update for DiscreteIntegrator: '<S3>/Filter' */
    AttitudeController_DWork.Filter_DSTATE = 8.999999613E-003F *
      rtb_FilterCoefficient + AttitudeController_DWork.Filter_DSTATE;

    /* Update for DiscreteIntegrator: '<S10>/Discrete-Time Integrator' incorporates:
     *  Gain: '<S10>/Gain2'
     *  Gain: '<S10>/Gain3'
     *  Sum: '<S10>/Sum3'
     */
    AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE = (25.0F * rtb_omega
      + 3.636363602E+001F * numAccum_0) * 8.999999613E-003F +
      AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE;

    /* Update for DiscreteIntegrator: '<S10>/Discrete-Time Integrator1' */
    AttitudeController_DWork.DiscreteTimeIntegrator1_DSTATE = 8.999999613E-003F *
      rtb_EngineCap3 + AttitudeController_DWork.DiscreteTimeIntegrator1_DSTATE;

    /* Update for S-Function (sfix_udelay): '<S6>/Integer Delay3' */
    for (idx = 0; idx < 41; idx++) {
      AttitudeController_DWork.IntegerDelay3_X[idx] =
        AttitudeController_DWork.IntegerDelay3_X[idx + 1];
    }

    AttitudeController_DWork.IntegerDelay3_X[41] =
      AttitudeController_B.TypeConv3;

    /* Update for DiscreteIntegrator: '<S7>/Discrete-Time Integrator' incorporates:
     *  Gain: '<S7>/Gain2'
     *  Gain: '<S7>/Gain3'
     *  Sum: '<S7>/Sum3'
     */
    AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_p = (25.0F *
      rtb_Sum1_l + 3.636363602E+001F * numAccum) * 8.999999613E-003F +
      AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_p;

    /* Update for DiscreteIntegrator: '<S7>/Discrete-Time Integrator1' */
    AttitudeController_DWork.DiscreteTimeIntegrator1_DSTATE_f =
      8.999999613E-003F * rtb_Sum4 +
      AttitudeController_DWork.DiscreteTimeIntegrator1_DSTATE_f;

    /* Update for DiscreteTransferFcn: '<S1>/VorfilterY' */
    AttitudeController_DWork.VorfilterY_DSTATE[3] =
      AttitudeController_DWork.VorfilterY_DSTATE[2];
    AttitudeController_DWork.VorfilterY_DSTATE[2] =
      AttitudeController_DWork.VorfilterY_DSTATE[1];
    AttitudeController_DWork.VorfilterY_DSTATE[1] =
      AttitudeController_DWork.VorfilterY_DSTATE[0];
    AttitudeController_DWork.VorfilterY_DSTATE[0] =
      AttitudeController_DWork.VorfilterY_tmp;

    /* Update for S-Function (sfix_udelay): '<S7>/Integer Delay' */
    AttitudeController_DWork.IntegerDelay_X[0] =
      AttitudeController_DWork.IntegerDelay_X[1];
    AttitudeController_DWork.IntegerDelay_X[1] = AttitudeController_B.Sum5;

    /* Update for DiscreteTransferFcn: '<S7>/Discrete Transfer Fcn' */
    AttitudeController_DWork.DiscreteTransferFcn_DSTATE = omega_mot -
      -9.086959958E-001F * AttitudeController_DWork.DiscreteTransferFcn_DSTATE;

    /* Update for DiscreteTransferFcn: '<S7>/Discrete Transfer Fcn1' incorporates:
     *  Update for Inport: '<Root>/X_GyroAccIN'
     */
    AttitudeController_DWork.DiscreteTransferFcn1_DSTATE =
      AttitudeController_U.X_GyroAccIN[0] - -4.065696597E-001F *
      AttitudeController_DWork.DiscreteTransferFcn1_DSTATE;

    /* Update for DiscreteIntegrator: '<S1>/Discrete-Time Integrator' incorporates:
     *  Gain: '<S1>/Gain2'
     *  Gain: '<S1>/Gain4'
     *  Product: '<S1>/Product'
     *  Sum: '<S1>/Sum7'
     *  Update for Inport: '<Root>/SetRoll'
     */
    AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_pr =
      (AttitudeController_U.SetRoll - (0.0F *
        rtb_TmpSignalConversionAtGain4Inport1_i_idx +
        rtb_TmpSignalConversionAtGain4Inport1_i_idx_0)) * rtb_IntegerDelay3 *
      0.5F * 8.999999613E-003F +
      AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_pr;

    /* Update for DiscreteTransferFcn: '<S2>/VorfilterX' */
    AttitudeController_DWork.VorfilterX_DSTATE[3] =
      AttitudeController_DWork.VorfilterX_DSTATE[2];
    AttitudeController_DWork.VorfilterX_DSTATE[2] =
      AttitudeController_DWork.VorfilterX_DSTATE[1];
    AttitudeController_DWork.VorfilterX_DSTATE[1] =
      AttitudeController_DWork.VorfilterX_DSTATE[0];
    AttitudeController_DWork.VorfilterX_DSTATE[0] =
      AttitudeController_DWork.VorfilterX_tmp;

    /* Update for S-Function (sfix_udelay): '<S10>/Integer Delay' */
    AttitudeController_DWork.IntegerDelay_X_c[0] =
      AttitudeController_DWork.IntegerDelay_X_c[1];
    AttitudeController_DWork.IntegerDelay_X_c[1] = AttitudeController_B.Sum5_i;

    /* Update for DiscreteTransferFcn: '<S10>/Discrete Transfer Fcn' */
    AttitudeController_DWork.DiscreteTransferFcn_DSTATE_p = omega_mot_h -
      -9.086959958E-001F * AttitudeController_DWork.DiscreteTransferFcn_DSTATE_p;

    /* Update for DiscreteTransferFcn: '<S10>/Discrete Transfer Fcn1' incorporates:
     *  Update for Inport: '<Root>/Y_GyroAccIN'
     */
    AttitudeController_DWork.DiscreteTransferFcn1_DSTATE_k =
      AttitudeController_U.Y_GyroAccIN[0] - -4.065696597E-001F *
      AttitudeController_DWork.DiscreteTransferFcn1_DSTATE_k;

    /* Update for DiscreteIntegrator: '<S2>/Discrete-Time Integrator' incorporates:
     *  Gain: '<S2>/Gain2'
     *  Gain: '<S2>/Gain4'
     *  Product: '<S2>/Product'
     *  Sum: '<S2>/Sum7'
     *  Update for Inport: '<Root>/SetPitch'
     */
    AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_e =
      (AttitudeController_U.SetPitch - (0.0F *
        rtb_TmpSignalConversionAtGain4Inport1_idx +
        rtb_TmpSignalConversionAtGain4Inport1_idx_0)) * rtb_IntegerDelay3 * 0.5F
      * 8.999999613E-003F +
      AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_e;

    /* Update for DiscreteIntegrator: '<S10>/Discrete-Time Integrator4' */
    AttitudeController_DWork.DiscreteTimeIntegrator4_DSTATE = 8.999999613E-003F *
      rtb_EngineCap1 + AttitudeController_DWork.DiscreteTimeIntegrator4_DSTATE;

    /* Update for DiscreteIntegrator: '<S7>/Discrete-Time Integrator3' */
    AttitudeController_DWork.DiscreteTimeIntegrator3_DSTATE = 8.999999613E-003F *
      rtb_Gain5_a + AttitudeController_DWork.DiscreteTimeIntegrator3_DSTATE;

    /* Update for DiscreteTransferFcn: '<S10>/Discrete Transfer Fcn2' incorporates:
     *  Update for Inport: '<Root>/Y_GyroAccIN'
     */
    AttitudeController_DWork.DiscreteTransferFcn2_DSTATE =
      AttitudeController_U.Y_GyroAccIN[1] - -4.065696597E-001F *
      AttitudeController_DWork.DiscreteTransferFcn2_DSTATE;

    /* Update for DiscreteTransferFcn: '<S7>/Discrete Transfer Fcn2' incorporates:
     *  Update for Inport: '<Root>/X_GyroAccIN'
     */
    AttitudeController_DWork.DiscreteTransferFcn2_DSTATE_i =
      AttitudeController_U.X_GyroAccIN[1] - -4.065696597E-001F *
      AttitudeController_DWork.DiscreteTransferFcn2_DSTATE_i;

    /* Update for DiscreteIntegrator: '<S10>/Discrete-Time Integrator2' */
    AttitudeController_DWork.DiscreteTimeIntegrator2_DSTATE = 1.080000028E-002F *
      rtb_omega + AttitudeController_DWork.DiscreteTimeIntegrator2_DSTATE;

    /* Update for S-Function (sfix_udelay): '<S10>/Integer Delay3' */
    for (idx = 0; idx < 41; idx++) {
      AttitudeController_DWork.IntegerDelay3_X_c[idx] =
        AttitudeController_DWork.IntegerDelay3_X_c[idx + 1];
    }

    AttitudeController_DWork.IntegerDelay3_X_c[41] =
      AttitudeController_Y.ApproxPitchAngle;

    /* Update for DiscreteIntegrator: '<S7>/Discrete-Time Integrator2' */
    AttitudeController_DWork.DiscreteTimeIntegrator2_DSTATE_j =
      1.080000028E-002F * rtb_Sum1_l +
      AttitudeController_DWork.DiscreteTimeIntegrator2_DSTATE_j;

    /* Update for S-Function (sfix_udelay): '<S7>/Integer Delay3' */
    for (idx = 0; idx < 41; idx++) {
      AttitudeController_DWork.IntegerDelay3_X_l[idx] =
        AttitudeController_DWork.IntegerDelay3_X_l[idx + 1];
    }

    AttitudeController_DWork.IntegerDelay3_X_l[41] =
      AttitudeController_Y.ApproxRollAngle;
  }
}

/* Model initialize function */
void AttitudeControllerModelClass::initialize()
{
  /* Registration code */

  /* block I/O */
  {
    AttitudeController_B.Sum5 = 0.0F;
    AttitudeController_B.Sum5_i = 0.0F;
    AttitudeController_B.TypeConv3 = 0.0F;
  }

  /* states (dwork) */
  AttitudeController_DWork.Integrator_DSTATE = 0.0F;
  AttitudeController_DWork.Filter_DSTATE = 0.0F;
  AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE = 0.0F;
  AttitudeController_DWork.DiscreteTimeIntegrator1_DSTATE = 0.0F;

  {
    int_T i;
    for (i = 0; i < 42; i++) {
      AttitudeController_DWork.IntegerDelay3_X[i] = 0.0F;
    }
  }

  AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_p = 0.0F;
  AttitudeController_DWork.DiscreteTimeIntegrator1_DSTATE_f = 0.0F;
  AttitudeController_DWork.VorfilterY_DSTATE[0] = 0.0F;
  AttitudeController_DWork.VorfilterY_DSTATE[1] = 0.0F;
  AttitudeController_DWork.VorfilterY_DSTATE[2] = 0.0F;
  AttitudeController_DWork.VorfilterY_DSTATE[3] = 0.0F;
  AttitudeController_DWork.IntegerDelay_X[0] = 0.0F;
  AttitudeController_DWork.IntegerDelay_X[1] = 0.0F;
  AttitudeController_DWork.DiscreteTransferFcn_DSTATE = 0.0F;
  AttitudeController_DWork.DiscreteTransferFcn1_DSTATE = 0.0F;
  AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_pr = 0.0F;
  AttitudeController_DWork.VorfilterX_DSTATE[0] = 0.0F;
  AttitudeController_DWork.VorfilterX_DSTATE[1] = 0.0F;
  AttitudeController_DWork.VorfilterX_DSTATE[2] = 0.0F;
  AttitudeController_DWork.VorfilterX_DSTATE[3] = 0.0F;
  AttitudeController_DWork.IntegerDelay_X_c[0] = 0.0F;
  AttitudeController_DWork.IntegerDelay_X_c[1] = 0.0F;
  AttitudeController_DWork.DiscreteTransferFcn_DSTATE_p = 0.0F;
  AttitudeController_DWork.DiscreteTransferFcn1_DSTATE_k = 0.0F;
  AttitudeController_DWork.DiscreteTimeIntegrator_DSTATE_e = 0.0F;
  AttitudeController_DWork.DiscreteTimeIntegrator4_DSTATE = 0.0F;
  AttitudeController_DWork.DiscreteTimeIntegrator3_DSTATE = 0.0F;
  AttitudeController_DWork.DiscreteTransferFcn2_DSTATE = 0.0F;
  AttitudeController_DWork.DiscreteTransferFcn2_DSTATE_i = 0.0F;
  AttitudeController_DWork.DiscreteTimeIntegrator2_DSTATE = 0.0F;

  {
    int_T i;
    for (i = 0; i < 42; i++) {
      AttitudeController_DWork.IntegerDelay3_X_c[i] = 0.0F;
    }
  }

  AttitudeController_DWork.DiscreteTimeIntegrator2_DSTATE_j = 0.0F;

  {
    int_T i;
    for (i = 0; i < 42; i++) {
      AttitudeController_DWork.IntegerDelay3_X_l[i] = 0.0F;
    }
  }

  AttitudeController_DWork.VorfilterY_tmp = 0.0F;
  AttitudeController_DWork.VorfilterX_tmp = 0.0F;

  /* external inputs */
  AttitudeController_U.SetPitch = 0.0F;
  AttitudeController_U.SetRoll = 0.0F;
  AttitudeController_U.SetThrottle = 0.0F;
  AttitudeController_U.Y_GyroAccIN[0] = 0.0F;
  AttitudeController_U.Y_GyroAccIN[1] = 0.0F;
  AttitudeController_U.X_GyroAccIN[0] = 0.0F;
  AttitudeController_U.X_GyroAccIN[1] = 0.0F;
  AttitudeController_U.SetYaw = 0.0F;
  AttitudeController_U.Z_GyroIN = 0.0F;
  AttitudeController_U.takeOffValue = 0.0F;
  AttitudeController_U.compass = 0.0F;

  /* external outputs */
  (void) memset((void *)&AttitudeController_Y, 0,
                sizeof(ExternalOutputs_AttitudeController));
  AttitudeController_Y.ObsX_x1 = 0.0F;
  AttitudeController_Y.ObsX_x2 = 0.0F;
  AttitudeController_Y.ObsX_x3 = 0.0F;
  AttitudeController_Y.ApproxPitchAngle = 0.0F;
  AttitudeController_Y.ObsY_x1 = 0.0F;
  AttitudeController_Y.ObsY_x2 = 0.0F;
  AttitudeController_Y.ObsY_x3 = 0.0F;
  AttitudeController_Y.ApproxRollAngle = 0.0F;
  AttitudeController_Y.Approx_Jpitch = 0.0F;
  AttitudeController_Y.Approx_Jroll = 0.0F;
  AttitudeController_Y.compare = 0.0F;
  AttitudeController_Y.ObsX_x5 = 0.0F;
  AttitudeController_Y.ObsX_x6 = 0.0F;
  AttitudeController_Y.ObsX_x7 = 0.0F;
  AttitudeController_Y.ObsY_x5 = 0.0F;
  AttitudeController_Y.ObsY_x6 = 0.0F;
  AttitudeController_Y.ObsY_x7 = 0.0F;

  {
    int32_T i;

    /* InitializeConditions for S-Function (sfix_udelay): '<S7>/Integer Delay' */
    AttitudeController_DWork.IntegerDelay_X[0] = 0.0F;

    /* InitializeConditions for S-Function (sfix_udelay): '<S10>/Integer Delay' */
    AttitudeController_DWork.IntegerDelay_X_c[0] = 0.0F;

    /* InitializeConditions for S-Function (sfix_udelay): '<S7>/Integer Delay' */
    AttitudeController_DWork.IntegerDelay_X[1] = 0.0F;

    /* InitializeConditions for S-Function (sfix_udelay): '<S10>/Integer Delay' */
    AttitudeController_DWork.IntegerDelay_X_c[1] = 0.0F;
    for (i = 0; i < 42; i++) {
      /* InitializeConditions for S-Function (sfix_udelay): '<S6>/Integer Delay3' */
      AttitudeController_DWork.IntegerDelay3_X[i] = 0.0F;

      /* InitializeConditions for S-Function (sfix_udelay): '<S10>/Integer Delay3' */
      AttitudeController_DWork.IntegerDelay3_X_c[i] = 0.0F;

      /* InitializeConditions for S-Function (sfix_udelay): '<S7>/Integer Delay3' */
      AttitudeController_DWork.IntegerDelay3_X_l[i] = 0.0F;
    }
  }
}

/* Constructor */
AttitudeControllerModelClass::AttitudeControllerModelClass()
{
}

/* Root-level input access methods */

/* Root inport: '<Root>/SetPitch' set method */
void AttitudeControllerModelClass::setSetPitch(real32_T localArgInput)
{
  AttitudeController_U.SetPitch = localArgInput;
}

/* Root inport: '<Root>/SetRoll' set method */
void AttitudeControllerModelClass::setSetRoll(real32_T localArgInput)
{
  AttitudeController_U.SetRoll = localArgInput;
}

/* Root inport: '<Root>/SetThrottle' set method */
void AttitudeControllerModelClass::setSetThrottle(real32_T localArgInput)
{
  AttitudeController_U.SetThrottle = localArgInput;
}

/* Root inport: '<Root>/Y_GyroAccIN' set method */
void AttitudeControllerModelClass::setY_GyroAccIN(real32_T localArgInput[2])
{
  AttitudeController_U.Y_GyroAccIN[0] = localArgInput[0];
  AttitudeController_U.Y_GyroAccIN[1] = localArgInput[1];
}

/* Root inport: '<Root>/X_GyroAccIN' set method */
void AttitudeControllerModelClass::setX_GyroAccIN(real32_T localArgInput[2])
{
  AttitudeController_U.X_GyroAccIN[0] = localArgInput[0];
  AttitudeController_U.X_GyroAccIN[1] = localArgInput[1];
}

/* Root inport: '<Root>/SetYaw' set method */
void AttitudeControllerModelClass::setSetYaw(real32_T localArgInput)
{
  AttitudeController_U.SetYaw = localArgInput;
}

/* Root inport: '<Root>/Z_GyroIN' set method */
void AttitudeControllerModelClass::setZ_GyroIN(real32_T localArgInput)
{
  AttitudeController_U.Z_GyroIN = localArgInput;
}

/* Root inport: '<Root>/takeOffValue' set method */
void AttitudeControllerModelClass::settakeOffValue(real32_T localArgInput)
{
  AttitudeController_U.takeOffValue = localArgInput;
}

/* Root inport: '<Root>/compass' set method */
void AttitudeControllerModelClass::setcompass(real32_T localArgInput)
{
  AttitudeController_U.compass = localArgInput;
}

/* Root-level output access methods */

/* Root outport: '<Root>/th1out' get method */
uint8_T AttitudeControllerModelClass::getth1out() const
{
  return AttitudeController_Y.th1out;
}

/* Root outport: '<Root>/th2out' get method */
uint8_T AttitudeControllerModelClass::getth2out() const
{
  return AttitudeController_Y.th2out;
}

/* Root outport: '<Root>/th3out' get method */
uint8_T AttitudeControllerModelClass::getth3out() const
{
  return AttitudeController_Y.th3out;
}

/* Root outport: '<Root>/th4out' get method */
uint8_T AttitudeControllerModelClass::getth4out() const
{
  return AttitudeController_Y.th4out;
}

/* Root outport: '<Root>/ObsX_x1' get method */
real32_T AttitudeControllerModelClass::getObsX_x1() const
{
  return AttitudeController_Y.ObsX_x1;
}

/* Root outport: '<Root>/ObsX_x2' get method */
real32_T AttitudeControllerModelClass::getObsX_x2() const
{
  return AttitudeController_Y.ObsX_x2;
}

/* Root outport: '<Root>/ObsX_x3' get method */
real32_T AttitudeControllerModelClass::getObsX_x3() const
{
  return AttitudeController_Y.ObsX_x3;
}

/* Root outport: '<Root>/ApproxPitchAngle' get method */
real32_T AttitudeControllerModelClass::getApproxPitchAngle() const
{
  return AttitudeController_Y.ApproxPitchAngle;
}

/* Root outport: '<Root>/ObsY_x1' get method */
real32_T AttitudeControllerModelClass::getObsY_x1() const
{
  return AttitudeController_Y.ObsY_x1;
}

/* Root outport: '<Root>/ObsY_x2' get method */
real32_T AttitudeControllerModelClass::getObsY_x2() const
{
  return AttitudeController_Y.ObsY_x2;
}

/* Root outport: '<Root>/ObsY_x3' get method */
real32_T AttitudeControllerModelClass::getObsY_x3() const
{
  return AttitudeController_Y.ObsY_x3;
}

/* Root outport: '<Root>/ApproxRollAngle' get method */
real32_T AttitudeControllerModelClass::getApproxRollAngle() const
{
  return AttitudeController_Y.ApproxRollAngle;
}

/* Root outport: '<Root>/Approx_Jpitch' get method */
real32_T AttitudeControllerModelClass::getApprox_Jpitch() const
{
  return AttitudeController_Y.Approx_Jpitch;
}

/* Root outport: '<Root>/Approx_Jroll' get method */
real32_T AttitudeControllerModelClass::getApprox_Jroll() const
{
  return AttitudeController_Y.Approx_Jroll;
}

/* Root outport: '<Root>/compare' get method */
real32_T AttitudeControllerModelClass::getcompare() const
{
  return AttitudeController_Y.compare;
}

/* Root outport: '<Root>/ObsX_x5' get method */
real32_T AttitudeControllerModelClass::getObsX_x5() const
{
  return AttitudeController_Y.ObsX_x5;
}

/* Root outport: '<Root>/ObsX_x6' get method */
real32_T AttitudeControllerModelClass::getObsX_x6() const
{
  return AttitudeController_Y.ObsX_x6;
}

/* Root outport: '<Root>/ObsX_x7' get method */
real32_T AttitudeControllerModelClass::getObsX_x7() const
{
  return AttitudeController_Y.ObsX_x7;
}

/* Root outport: '<Root>/ObsY_x5' get method */
real32_T AttitudeControllerModelClass::getObsY_x5() const
{
  return AttitudeController_Y.ObsY_x5;
}

/* Root outport: '<Root>/ObsY_x6' get method */
real32_T AttitudeControllerModelClass::getObsY_x6() const
{
  return AttitudeController_Y.ObsY_x6;
}

/* Root outport: '<Root>/ObsY_x7' get method */
real32_T AttitudeControllerModelClass::getObsY_x7() const
{
  return AttitudeController_Y.ObsY_x7;
}

/*
 * File trailer for Real-Time Workshop generated code.
 *
 * [EOF]
 */
