#include "testdata.h"
#include "appcode.h"
#include "ac/AttitudeController.h"
#include "as/AS.h"
#include "hw/dev/STM.h"
#include "stdio.h"

struct ACResult {
	short front;
	short rear;
	short left;
	short right;
};

struct ACResult outData[NUM_INPUTSETS];
unsigned int times[NUM_INPUTSETS];

void control(AttitudeControllerModelClass controller) {
	unsigned int start,end;

	for(int i=0; i< NUM_INPUTSETS; i++) {
		float *id = inputdata[i];

		controller.setSetPitch( id[Pitch] * (-1) );
		controller.setSetRoll(  id[Roll] * (-1)  );
		controller.setSetYaw( id[Yaw] );

		controller.settakeOffValue (0.9f);

		float throttle = id[Throttle] * 1000.0f / 3921.0f; // 0-1000 in 0-255
		controller.setSetThrottle(throttle);

		controller.setZ_GyroIN(id[AngularSpeed_Z]);

		float controllerinput[2];
		controllerinput[0] = id[AngularSpeed_X];
		controllerinput[1] = id[Acceleration_Y];
		controller.setX_GyroAccIN(controllerinput);

		controllerinput[0] = id[AngularSpeed_Y];
		controllerinput[1] = id[Acceleration_X];
		controller.setY_GyroAccIN(controllerinput);

//		controller.setcompass(0.0f); // ignore
		start = STM_TIM0.reg;
		controller.step();
		end = STM_TIM0.reg;
		times[i] = end - start;

		outData[i].left  = controller.getth1out();
		outData[i].front = controller.getth2out();
		outData[i].right = controller.getth3out();
		outData[i].rear  = controller.getth4out();
	}
}

void AttitudeControlComponent::functionTaskAttitudeControlTask() {
	AttitudeControllerModelClass controller;
	controller.initialize();

	control(controller);

	unsigned int min=~1, max=0, avg=0;
	int minrun=-1, maxrun=-1;

	for(int i=50; i<NUM_INPUTSETS; i++) {
		avg += times[i];
		if(min > times[i]) {
			min = times[i];
			minrun = i;
		}
		if(max < times[i]) {
			max = times[i];
			maxrun = i;
		}

		printf("%d\r\n", times[i]);
	}

	avg /= NUM_INPUTSETS;

	printf("Minimum: %d, run %d\r\n", min, minrun);
	printf("Maximum: %d, run %d\r\n", max, maxrun);
	printf("Average: %d\r\n", avg);

	AS::TerminateTask();
}

void PreTaskHook() { }
void StartupHook() { }

