#include "testdata.h"
#include "ac/AttitudeController.h"
#include "stdio.h"

struct ACResult {
	short front;
	short rear;
	short left;
	short right;
};

struct ACResult outData[NUM_INPUTSETS];

void control(AttitudeControllerModelClass controller) {
	unsigned int start,end;

	for(int i=0; i< NUM_INPUTSETS; i++) {
		float *id = inputdata[i];

		controller.setSetPitch( id[Pitch] * (-1) );
		controller.setSetRoll(  id[Roll] * (-1)  );
		controller.setSetYaw( id[Yaw] );

		controller.settakeOffValue (0.9f);

		float throttle = id[Throttle] * 1000.0f / 3921.0f; // 0-1000 in 0-255
		controller.setSetThrottle(throttle);

		controller.setZ_GyroIN(id[AngularSpeed_Z]);

		float controllerinput[2];
		controllerinput[0] = id[AngularSpeed_X];
		controllerinput[1] = id[Acceleration_Y];
		controller.setX_GyroAccIN(controllerinput);

		controllerinput[0] = id[AngularSpeed_Y];
		controllerinput[1] = id[Acceleration_X];
		controller.setY_GyroAccIN(controllerinput);

//		controller.setcompass(0.0f); // ignore
		controller.step();

		outData[i].left  = controller.getth1out();
		outData[i].front = controller.getth2out();
		outData[i].right = controller.getth3out();
		outData[i].rear  = controller.getth4out();
	}
}

int main() {
	AttitudeControllerModelClass controller;
	controller.initialize();

	control(controller);

	for(int i=0; i<NUM_INPUTSETS; i++) {
		printf("%d, %d, %d, %d\n", outData[i].left, outData[i].rear, outData[i].right, outData[i].front );
	}

	return 0;
}


