#
# MODULE: aspects
#
# weave aspects within the hole source tree

# Home directory of Ascpect C++ Compiler
AC_DIR=/proj/i4ciao/tools/aspectc++



# AspectC++ Compiler Environment Variable
#export PUMA_CONFIG:= $(AC_DIR)/puma.config

# AspectC++ Compiler
AC= $(AC_DIR)/ac++

# Source Directory for files generated by AspectC++ Compiler
GEN_AC_SRC_DIR := gen/aspectc++

# store path to original sources
ORIG_SRC_DIR := $(SRC_DIR)
SRC_DIR := $(GEN_AC_SRC_DIR)

# find sources
ORIG_SRC := $(shell find $(ORIG_SRC_DIR) -follow -name '*.cpp' )
SRC := $(patsubst $(ORIG_SRC_DIR)/%,$(SRC_DIR)/%, $(ORIG_SRC))
SRC := $(SRC_DIR)/ac_gen.cpp $(SRC)

#add all
MODULES_ALL += aspects

# add clean
MODULES_CLEAN += aspects

#AspectC++ project repository file
#AC_PR := $(GEN_AC_SRC_DIR)/ciao.acp
# use new repository
export ACNEWREPO:=$(AC_PR)

# flags for AspectC++
#ACFLAGS := -r $(AC_PR) -e cpp  # don't use old repository
ACFLAGS := -e cpp  
# verbose output for AspectC++ 
#ACFLAGS += -v9

# add Source/Target Directories to ACFLAGS
ACFLAGS += -p $(ORIG_SRC_DIR) -d $(GEN_AC_SRC_DIR) 

# 'clean' target for 'aspects' MODULE
clean_aspects:
	rm -rf $(GEN_AC_SRC_DIR)
	
# 'all' target for 'aspects' MODULE
all_aspects: $(SRC_DIR)/ac_gen.cpp

# weave whole src directory
$(SRC_DIR)/ac_gen.cpp: $(shell find $(ORIG_SRC_DIR) -type f)
	@echo "(AC)      $(ORIG_SRC_DIR)"
	$(AC) -I $(ORIG_SRC_DIR) $(ACFLAGS) 

# rule that ensures that all files in SRC_DIR are depended of ac_gen.cpp
$(SRC_DIR)/%.cpp: | $(ORIG_SRC_DIR)/%.cpp $(SRC_DIR)/ac_gen.cpp
	@echo -n 

.PRECIOUS: $(SRC_DIR)/%.cpp
