# C++ Compiler

# avr specific C++ flags

# currently it works only for the ATMEGA103 model!
CXXFLAGS += -mmcu=atmega103 -ffunction-sections
ASFLAGS  += -mmcu=atmega103
LDFLAGS  += --gc-sections

# binutils for AVR
OBJCOPY := $(CXX_PATH)/avr-objcopy
LD      := $(CXX_PATH)/avr-ld
SIZE    := $(CXX_PATH)/avr-size
AR      := $(CXX_PATH)/avr-ar
AS      := $(CXX_PATH)/avr-g++

# dummy AVR programmer
DUMMY := $(CIAO_DIR)/../../../tools/AVR-Dummy/dummy

# how to link an AVR application: nothing special because of avr-libc
%.avr : %.o $(APP_OBJS)
	@echo "(LINK)    $@"
	@$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $< $(APP_OBJS) -L$(dir $(LIB_FILE)) -lciao

# how to make the binary for flashing with the 'dummy' tool
%.bin : %.avr
	@echo "(BIN)     $@"
	@$(OBJCOPY) -O binary $< $@

# how to flash a binary with 'dummy'
%.flash : %.bin
	@echo "(FLASH)   $< -> AVR"
	@$(DUMMY) w i < $<
