// $Id: autosar_types.h 1332 2011-01-21 11:46:46Z chb $
// Created: 2007-06-04 siwahofe

#ifndef __AUTOSAR_TYPES_H__
#define __AUTOSAR_TYPES_H__

#include "ciaoConfig.h"

// data type to represent number of tasks plus INVALID_TASK
typedef os::krn::TaskType TaskType;
typedef TaskType& TaskRefType;
const TaskType INVALID_TASK = os::krn::INVALID_TASK;

#include "os/krn/ISR.h"
// data type to represent number of ISRs (category 2) plus INVALID_ISR
typedef os::krn::ISR::Id ISRType;
const ISRType INVALID_ISR = os::krn::ISR::INVALID;

// data type to represent number of application modes (minimum one)
typedef os::krn::AppModeType AppModeType;
const AppModeType OSDEFAULTAPPMODE = os::krn::OSDEFAULTAPPMODE;

#if cfOS_NUMBER_OF_OSAPPLICATIONS > 0
// data type to represent number of OS applications plus INVALID_OSAPPLICATION
typedef os::krn::ApplicationType ApplicationType;
const ApplicationType INVALID_OSAPPLICATION = os::krn::INVALID_OSAPPLICATION;
#endif // cfOS_NUMBER_OF_OSAPPLICATIONS

typedef os::krn::TaskStateType TaskStateType;
typedef TaskStateType& TaskStateRefType;

// StatusType which also integrates values of Std_ReturnType
enum StatusType {
	E_OK						= 0,
	E_NOT_OK					= 1,
	E_OS_ACCESS					= 2,
	E_OS_CALLEVEL				= 3,
	E_OS_ID						= 4,
	E_OS_LIMIT					= 5,
	E_OS_NOFUNC					= 6,
	E_OS_RESOURCE				= 7,
	E_OS_STATE					= 8,
	E_OS_VALUE					= 9,
	E_OS_SERVICEID				= 10,
	E_OS_RATE					= 11,
	E_OS_ILLEGAL_ADDRESS		= 12,
	E_OS_MISSINGEND				= 13,
	E_OS_DISABLEDINT			= 14,
	E_OS_STACKFAULT				= 15,
	E_OS_PROTECTION_MEMORY		= 16,
	E_OS_PROTECTION_TIME		= 17,
	E_OS_PROTECTION_LOCKED		= 18,
	E_OS_PROTECTION_EXCEPTION	= 19,
	E_OS_PROTECTION_RATE		= 20,
	COM_SERVICE_NOT_AVAILABLE   = 0x80,
	COM_TIMEOUT					= 0x81

};

#ifdef cfOS_NUMBER_OF_RESOURCES
#include "os/krn/Resource.h"
// data type to represent number of resources plus RES_SCHEDULER
typedef os::krn::Resource::Id ResourceType;
const ResourceType RES_SCHEDULER = os::krn::Resource::SCHEDULER;
#endif // cfOS_NUMBER_OF_RESOURCES

#if cfOS_MAX_NUMBER_OF_EVENTS_PER_TASK > 0
// data type to represent number of events per task
typedef os::krn::EventMaskType EventMaskType;
typedef EventMaskType& EventMaskRefType;
#endif // cfOS_MAX_NUMBER_OF_EVENTS_PER_TASK

/*
enum {
	OSServiceId_ActivateTask	= 0,
	OSServiceId_TerminateTask	= 1,
	OSServiceId_ChainTask		= 2,
	OSServiceId_Schedule		= 3,
	OSServiceId_GetTaskID		= 4,
	OSServiceId_GetTaskState	= 5,
	OSServiceId_GetResource		= 6,
	OSServiceId_ReleaseResource	= 7,
	OSServiceId_SetEvent		= 8,
	OSServiceId_ClearEvent		= 9,
	OSServiceId_GetEvent		= 10,
	OSServiceId_WaitEvent		= 11
} OSServiceIdType;
*/

#if cfOS_NUMBER_OF_ALARMS > 0
// data type to represent number of alarms
#include "os/krn/Alarm.h"
typedef os::krn::Alarm::Id AlarmType;
typedef os::krn::Alarm::Ticks TickType;
typedef TickType& TickRefType;
typedef os::krn::Counter AlarmBaseType;
typedef AlarmBaseType& AlarmBaseRefType;
#endif // cfOS_NUMBER_OF_ALARMS

/*
enum ProtectionReturnType {
	PRO_KILLTASKISR			= 0,
	PRO_KILLAPPL			= 1,
	PRO_KILLAPPL_RESTART	= 2,
	PRO_SHUTDOWN			= 3
};
*/

#endif // __AUTOSAR_TYPES_H__
