// $Id: osek_compat.h 995 2009-08-11 14:26:31Z mike $
#ifndef __OSEK_COMPAT_H__
#define __OSEK_COMPAT_H__

#include "autosar_types.h"
#include "as/AS.h"

// task services
inline StatusType CIAO_INLINE ActivateTask(TaskType taskid) {
	return AS::ActivateTask(taskid);
}
inline StatusType CIAO_INLINE TerminateTask() {
	return AS::TerminateTask();
}

inline StatusType CIAO_INLINE ChainTask (TaskType taskid) {
	return AS::ChainTask(taskid);
}

inline StatusType CIAO_INLINE Schedule () {
	return AS::Schedule();
}

inline StatusType CIAO_INLINE GetTaskID (TaskType *taskid) {
	return AS::GetTaskID(*taskid);
}

inline StatusType CIAO_INLINE GetTaskState (TaskType taskid, TaskStateType *state) {
	return AS::GetTaskState(taskid,*state);
}

#ifdef cfOS_ISR1_SUPPORT
// ISR category 1 services
inline void CIAO_INLINE DisableAllInterrupts () {
	AS::DisableAllInterrupts();
}

inline void CIAO_INLINE EnableAllInterrupts () {
	AS::EnableAllInterrupts();
}

inline void CIAO_INLINE SuspendAllInterrupts () {
	AS::SuspendAllInterrupts();
}

inline void CIAO_INLINE ResumeAllInterrupts () {
	AS::ResumeAllInterrupts();
}
#endif

#ifdef cfOS_ISR2_SUPPORT
// ISR category 2 services
inline void CIAO_INLINE SuspendOSInterrupts () {
	AS::SuspendOSInterrupts();
}
inline void CIAO_INLINE ResumeOSInterrupts () {
	AS::ResumeOSInterrupts();
}
#endif

#ifdef cfOS_NUMBER_OF_RESOURCES
// resource services
inline StatusType CIAO_INLINE GetResource (ResourceType resid) {
	return AS::GetResource(resid);
}

inline StatusType CIAO_INLINE ReleaseResource (ResourceType resid) {
	return AS::ReleaseResource(resid);
}
#endif

#if cfOS_MAX_NUMBER_OF_EVENTS_PER_TASK > 0
// event services
inline StatusType CIAO_INLINE SetEvent (TaskType taskid, EventMaskType mask) {
	return AS::SetEvent(taskid,mask);
}

inline StatusType CIAO_INLINE ClearEvent (EventMaskType mask) {
	return AS::ClearEvent(mask);
}

inline StatusType CIAO_INLINE GetEvent (TaskType taskid, EventMaskType *mask) {
	return AS::GetEvent(taskid,*mask);
}

inline StatusType CIAO_INLINE WaitEvent (EventMaskType mask) {
	return AS::WaitEvent(mask);
}
#endif

#ifdef cfOS_NUMBER_OF_ALARMS
// alarm services
inline StatusType CIAO_INLINE GetAlarmBase (AlarmType alarmid, AlarmBaseType *info) {
	return AS::GetAlarmBase(alarmid,*info);
}

inline StatusType CIAO_INLINE GetAlarm (AlarmType alarmid, TickType *ticks) {
	return AS::GetAlarm(alarmid,*ticks);
}

inline StatusType CIAO_INLINE SetRelAlarm (AlarmType alarmid, TickType increment, TickType cycle) {
	return AS::SetRelAlarm(alarmid,increment,cycle);
}

inline StatusType CIAO_INLINE SetAbsAlarm (AlarmType alarmid, TickType start, TickType cycle) {
	return AS::SetAbsAlarm(alarmid,start,cycle);
}

inline StatusType CIAO_INLINE CancelAlarm (AlarmType alarmid) {
	return AS::CancelAlarm(alarmid);
}
#endif

// OS services
inline void CIAO_INLINE StartOS (AppModeType appmode) {
	AS::StartOS(appmode);
}

inline void CIAO_INLINE ShutdownOS (StatusType error) __attribute__((noreturn));
inline void CIAO_INLINE ShutdownOS (StatusType error) {
	AS::ShutdownOS(error);
}

inline AppModeType CIAO_INLINE GetActiveApplicationMode () {
	return AS::GetActiveApplicationMode();
}

#endif // __OSEK_COMPAT_H__

