// $Id: Sched.h 995 2009-08-11 14:26:31Z mike $
// Created:   27.06.2006 lohmann

#ifndef __CIAO_KRN_SCHED_H__
#define __CIAO_KRN_SCHED_H__

#include "util/macros.h"

// Implementation is always based on os::krn::Sched
#define cfCIAO_KRN_SCHED_IMPL os::krn::Sched
#define cfCIAO_KRN_SCHED_IMPL_HEADER "os/krn/Sched.h"

#ifndef cfCIAO_DECOUPLE
# include cfCIAO_KRN_SCHED_IMPL_HEADER
#endif

namespace ciao { namespace krn {


class CIAO_CLASS( Sched,  cfCIAO_KRN_SCHED_IMPL ) {
	CIAO_CLASS_BODY( Sched, cfCIAO_KRN_SCHED_IMPL );
  public:

	// TODO: HACK! What should we do if the implementing type contains 
	// subelements such as typdefs, enums and so on that are used in the interface?
	// In the decoupling case the Id type is not available - and we have no clue
	// what it should be. int works only with the current implementation :-/
#ifdef cfCIAO_DECOUPLE
	typedef int Id;
#endif	

	// whom: terminated -> ready
	void activate( Id whom );
	
	// me: running -> waiting
	void block();
	
	// whom: waiting -> ready
	void awake( Id whom );
	
	// me: running -> terminated
	void exit();
	
	// voluntarily give CPU to next task with same priority
	void reschedule();
	
	// get own task id
	Id getRunning() const;
};

}} // namespace ciao::krn

#ifdef cfCIAO_INLINE
# include "Sched.inl"
#endif
 
#endif // __CIAO_KRN_SCHED_H__
