/*
 * memory.x -- The default memory description
 *
 * Copyright (C) 2005 HighTec EDV-Systeme GmbH.
 *
 */
/* __TC1796__ __TC13__ with Core TC1.3 */
__TRICORE_DERIVATE_MEMORY_MAP__ = 0x1796;
/* the external RAM description */
__EXT_CODE_RAM_BEGIN = 0x81000000;
__EXT_CODE_RAM_SIZE = 320K ;
__EXT_DATA_RAM_BEGIN = 0x81050000; /* XXX */
__EXT_DATA_RAM_SIZE = 704K;
__RAM_END = __EXT_DATA_RAM_BEGIN + __EXT_DATA_RAM_SIZE;
/* internal FLASH description */
__INT_CODE_FLASH_BEGIN = 0xa0000000;
__INT_CODE_FLASH_SIZE = 2M;
__INT_DATA_FLASH_BEGIN = 0xafe00000;
__INT_DATA_FLASH_SIZE = 128K;
/* the internal ram description */
__INT_CODE_RAM_BEGIN = 0xd4000000;
__INT_CODE_RAM_SIZE = 48K;
__INT_DATA_RAM_BEGIN = 0xd0000000;
__INT_DATA_RAM_SIZE = 56K;
__INT_SRAM_BEGIN   = 0xc0000000;
__INT_SRAM_SIZE    = 64K;
/* the pcp memory description */
__PCP_CODE_RAM_BEGIN = 0xf0060000;
__PCP_CODE_RAM_SIZE = 32K;
__PCP_DATA_RAM_BEGIN = 0xf0050000;
__PCP_DATA_RAM_SIZE = 16K;

PxTricSystemRamBegin = 0x80000000;
PxTricSystemRamEnd   = 0xe0000000;

/* define the area available for dynanmic loading of applications */
__LOADER_MEMORY_BASE = 0x810c0000; /* XXX */
__LOADER_MEMORY_SIZE = 128k;

MEMORY
{
  ext_cram (rx!p): org = 0x81000000, len = 320K
  ext_dram (w!xp): org = 0x81050000, len = 196K /* XXX */
  ext_sysram (w!x): org = 0x81080000, len = 256K /* XXX */
  ext_load_memory (w!x): org = 0x810c0000,len = 256K /* XXX */
  int_cflash (rx!p): org = 0xa0000000, len = 2M
  int_dflash (w!xp): org = 0xafe00000, len = 128K
  int_sram (w!xp):  org = 0xc0000000, len = 64K
  int_cram (rx!p): org = 0xd4000000, len = 48K
  int_dram (w!xp): org = 0xd0000000, len = 56K
  pcp_data (wp!x): org = 0xf0050000, len = 16K
  pcp_text (rpx): org = 0xf0060000, len = 32K
}

__EXT_RAM_BASE = 0x81000000; /* XXX */
__EXT_RAM_END = __EXT_RAM_BASE + 1M;
__EXT_RAM_BASE_CACHED = 0x81000000;
__EXT_RAM_END_CACHED = __EXT_RAM_BASE_CACHED + 1M;

/* the symbol __TRICORE_DERIVATE_NAME__ will be defined in the crt0.S and is
 * tested here to confirm that this memory map and the startup file will
 * fit together
*/
_. = ASSERT ((__TRICORE_DERIVATE_MEMORY_MAP__ == __TRICORE_DERIVATE_NAME__), "Using wrong Memory Map. This Map is for TC1796");
