// $Id: triboard1796_userinit.cpp 995 2009-08-11 14:26:31Z mike $
// Created:   30.05.2006 lohmann

/**
 * @file triboard1796_userinit.cpp
 * @brief defines the __main() function, which calls hw::init(), hw::hal::init() and so on
 */
 

#include "hw/triboard1796.h"
#include "hw/init.h"
#include "hw/hal/init.h"
#include "os/init.h"

//! tricore-gcc always generates a call to __main() as first statement in main(),
//! so __main() has to be defined. It is supposed to call global constructors.
extern "C" void __main() {

	// hw::init() is called with ENDINIT protection disabled
	hw::_tc::unlock_wdtcon();
	hw::init();
	hw::_tc::lock_wdtcon();
	
	// hw::hal::init() comes next
	hw::hal::init();

	// TODO: it may be necessary to bring the kernel up before initializing drivers
	// (could also be done by order advice)
	os::init();
}

