// $Id: tricore-abs-noabs-FIX.h 1211 2010-07-16 13:05:25Z sijesche $
// Created:   Mar 10, 2006 lohmann

/**
 * \file tricore-abs-noabs-FIX.h
 * \brief CiAO-Version of the Hightec register definition macros. Must be included before any other Hightec TriCore includes.
 * 
 * This file differs from the original HighTec version with respect to:
 * - It fixes a bug that lead to undefined linker symbols
 * - It defines the register symbols in the namespace hw::_tc
 *   and assumes also that all TriCore-specific types are available in this namespace
 */


#ifndef _HAVE_TRICORE_SFR_ABSNOABS_
#define _HAVE_TRICORE_SFR_ABSNOABS_


/* BUGFIX: DL 10-03-2006 */
#define STRINGIFY(x) #x

#define SFR_NOABS(name,type,addr)         \
   __asm__ (".global       " #name );     \
   __asm__ (".set  " #name "," STRINGIFY(addr) );   \
   __asm__ (".type " #name ",@object");   \
   extern "C" type name

/*
 * Original version:
#define SFR_NOABS(name,type,addr)         \
   __asm__ (".global       " #name );     \
   __asm__ (".set  " #name "," #addr );   \
   __asm__ (".type " #name ",@object");   \
   extern type name
*/

#define SFR_ABS(name,type,addr)         \
   SFR_NOABS(name,type,addr)              \
   __attribute__ ((absdata))

#endif /* _HAVE_TRICORE_SFR_ABSNOABS_ */
