/*
 * GDT.h
 *
 *  Created on: Feb 23, 2010
 *      Author: bossel00
 */

#ifndef GDT_H_
#define GDT_H_

#include "stdinc.h"

namespace hw {

struct Descriptor {

	union {
		struct {
			UInt16 segment_limit0;
			UInt16 base0;
			UInt8  base1;
			UInt8  flags;
			UInt8  segment_limit1;
			UInt8  base2;
		} __attribute__((packed));

		UInt64 value;
	} __attribute__((packed));

} __attribute__((packed));

struct GlobalDescriptorTable {
	UInt16 limit;
	Descriptor*  base;
} __attribute__((packed));

extern GlobalDescriptorTable gdt;

class GDT {
	static const int ENTRIES;
	static int last_entry;
	static Descriptor descriptors[];
	GlobalDescriptorTable gdt;

	static GDT inst_;

public:
	static GDT& Inst() { return inst_; }

	void        init();

	int         getDescriptor();              // returns new global descriptor index or -1 if no free descriptors available
	Descriptor* getDescriptor(int index);     // returns global descriptor
	Descriptor& operator[](int index);        // returns global descriptor
};

}

#endif /* GDT_H_ */
