// $Id: DebuggerVIO.cpp 1309 2010-11-17 20:33:43Z mike $
// $Header:$

#include "DebuggerVIO.h"

#ifdef cfDEV_VIO_BUFFERSIZE
	static char vio_buffer[cfDEV_VIO_BUFFERSIZE];
	static char *buffer_ptr = vio_buffer;
#endif

extern "C" void __virtio_dummy_hnd(){
	asm volatile ("                 \n\
	    .ascii \"_vio\"             \n\
	    .globl ___virtio_hnd        \n\
	    .type ___virtio_hnd,@function       \n\
	    .globl ___virtio            \n\
	    .type ___virtio,@function   \n\
	___virtio_hnd:                  \n\
	___virtio:                      \n\
	    .code16                     \n\
	    debug                       \n\
	    mov %d2,%d11                \n\
	  ");
}

namespace hw { namespace dev {
	
// private implementations..
// taken from trigcc 
int CIAO_NOINLINE DebuggerVIO::read (int desc, void *buf, size_t len) {
  asm volatile ("               \n\
    mov %d12,4          \n\
    j ___virtio			\n\
  ");
  return 0; // never reached, ignore the gcc warning
}

int CIAO_NOINLINE DebuggerVIO::write( int desc, void *buf, size_t len) {
  asm volatile ("       \n\
    mov %d12,5          \n\
    j ___virtio			\n\
  ");
  return 0; // never reached, ignore the gcc warning
}


void DebuggerVIO::putc_( UInt8 c ) {
#ifndef cfDEV_VIO_BUFFERSIZE
	write(0, &c, sizeof c);
#else
    *buffer_ptr++ = static_cast<char>(c);
    if ( (c == '\n') || (buffer_ptr - vio_buffer) == cfDEV_VIO_BUFFERSIZE) {
		write(0, vio_buffer, buffer_ptr - vio_buffer);
		buffer_ptr = vio_buffer; 
    }
#endif
}

UInt8 DebuggerVIO::getc_() {
	UInt8 ret;
	read(0, &ret, sizeof ret);
	return ret;
	
}

}}

