#include "PIT.h"

hw::dev::PIT hw::dev::PIT::thePIT_;

void hw::dev::PIT::setIntervalTicks(UInt16 cnt) {
	control_byte val;
	val.counter = 0; // Zähler 0
	val.rw = 3; // nieder- und höherwertiges Byte beschreiben
	val.mode = 2; // Modus 2
	val.format = 0; // 16-Bit Zähler

	control_.outb(val);

	counter_[0].outb(cnt & 0xff);
	counter_[0].outb(cnt >> 8);
}

void hw::dev::PIT::setInterval(int us) {
	// Grenzwerte abfangen
	if (us > 54918) {
		us = 54918;
	} else if (us < 1) {
		us = 1;
	}

	us_per_tick = us;

	//unsigned short cnt = static_cast<unsigned short> (static_cast<double> (us) * takt / 1000000);
	//unsigned short cnt = static_cast<unsigned int> (us) * takt / 1000000U;
	UInt16 cnt = static_cast<UInt16> (us) * 1000U / 838U;

	setIntervalTicks(cnt);
}

void hw::dev::PIT::set_speaker(unsigned short freq)
{
  control_byte cnt;
  cnt.counter = 2;  // Zähler 2 (PC-Lautsprecher)
  cnt.rw = 3;       // nieder- und höherwertiges Byte beschreiben
  cnt.mode = 3;     // Modus 3  (Rechteck-Generator, 50% Duty-Cycle)
  cnt.format = 0;   // 16-Bit Zähler

  IOPort ctrl_speaker(0x61);
  unsigned char speaker_ctrl = ctrl_speaker.inb();

  ctrl_speaker.outb( speaker_ctrl | (1 << 1) | (1 << 0) );        // Speaker auf PIT1, Zähler 2

  // TODO: Frequenz richtig berechnen
  unsigned short val = 11933180U / freq;

  control_.outb(cnt);

  counter_[2].outb(val & 0xff);
  counter_[2].outb(val >> 8);
}

void hw::dev::PIT::speaker_off()
{
  IOPort ctrl_speaker(0x61);
  unsigned char speaker_ctrl = ctrl_speaker.inb();

  ctrl_speaker.outb( speaker_ctrl & ~(1 << 1) );        // Speaker aus
}
