
#include "RTC.h"

#include "IOPort.h"

namespace {
inline int BCD_to_binary(int bcd) {
	return (bcd >> 4) * 10 + (bcd & 0xF);
}
}

namespace hw {
namespace dev {

// TODO: Namen konfigurierbar machen? ;-)
const char* RTC::Time::WEEKDAYS[] = { "Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag" };
const char* RTC::Time::MONTHS[]   = { "Januar", "Februar", "Maerz", "April", "Mai", "Juni",
                                      "Juli", "August", "September", "Oktober", "November", "Dezember" };

RTC::Time RTC::getCurrentTime() {
	Time current;

	IOPort index(CMOS_INDEX);
	IOPort data(CMOS_DATA);

	index.outb(0x4);
	current.hour_ = BCD_to_binary(data.inb());

	index.outb(0x2);
	current.minute_ = BCD_to_binary(data.inb());

	index.outb(0x0);
	current.second_ = BCD_to_binary(data.inb());


	index.outb(0x6);
	current.weekday_ = BCD_to_binary(data.inb());

	index.outb(0x7);
	current.day_ = BCD_to_binary(data.inb());

	index.outb(0x8);
	current.month_ = BCD_to_binary(data.inb());

	index.outb(0x32);
	current.year_ = BCD_to_binary(data.inb()) * 100;

	index.outb(0x9);
	current.year_ += BCD_to_binary(data.inb());

	return current;
}

}
}
