/** \author Christian Meier
 *  \version $Id: ComStack_Types_internal.h 960 2009-03-25 21:45:04Z sichmeie $
 *
 *  This file defines some commonly used types of the Communication Stack.
 *  This is an internal fragment part of ComStack_Types.h.
 */

#ifndef HW_DEV_CAN_COMSTACK_TYPES_INTERNAL_H
#define HW_DEV_CAN_COMSTACK_TYPES_INTERNAL_H

#include "stddef.h"

#include "ciaoConfig.h"
#include "util/types.h"
#include "as/autosar_types.h"

#include "hw/dev/can/IdType.h"

namespace hw {
  namespace dev {
    namespace can {
		// Check whether the following type should have
		// specific numeric values
      enum DevelopmentErrorType {
    	  CAN_E_TRANSITION 			= 1,
    	  CAN_E_PARAM_POINTER		= 2,
    	  CAN_E_UNINIT				= 3,
    	  CAN_E_PARAM_CONTROLLER	= 4,
    	  CAN_E_PARAM_DLC			= 5,
    	  CAN_E_PARAM_HANDLE		= 6
      };

      enum DirectionType {
        TRANSMIT = 0,
        RECEIVE = 1
      };

      enum ReturnType {
        CAN_OK      = 0x00,
        CAN_NOT_OK  = 0x01,
        CAN_BUSY    = 0x02
      };

      enum StateTransitionType {
        CAN_T_START,
        CAN_T_STOP,
        CAN_T_SLEEP,
        CAN_T_WAKEUP
      };

		  struct PduType {
		    UInt8 * Sdu_;
		    IdType Id_;
		    os::com::PduIdType SwPduHandle_;
		    UInt8 Length_;
		  };

    };
  };
}; /* namespace hw::dev::can */

#endif
