/** \author Christian Meier
 *  \version $Id: RegTypes_tc1796b.h 995 2009-08-11 14:26:31Z mike $
 */

#ifndef HW_DEV_CAN_MULTICAN_REG_TYPES_TC1796B_H
#define HW_DEV_CAN_MULTICAN_REG_TYPES_TC1796B_H

namespace hw { namespace dev { namespace can { namespace multican {

// We include this inside the namespace
#include <tc1796b/multican/sharetypes.h>
#include <tc1796b/multican/types.h>
#include <tc1796b/multican/sharemasks.h>

// MOCTR and MOSTAT definitions are mixed in comparison
// to manual so we define our own version

typedef union { /* 32 bits */
   struct {
      unsigned int RXPND:1;             /*  = [0..0] = 0x00000001 */
      unsigned int TXPND:1;             /*  = [1..1] = 0x00000002 */
      unsigned int RXUPD:1;             /*  = [2..2] = 0x00000004 */
      unsigned int NEWDAT:1;            /*  = [3..3] = 0x00000008 */
      unsigned int MSGLST:1;            /*  = [4..4] = 0x00000010 */
      unsigned int MSGVAL:1;            /*  = [5..5] = 0x00000020 */
      unsigned int RTSEL:1;             /*  = [6..6] = 0x00000040 */
      unsigned int RXEN:1;              /*  = [7..7] = 0x00000080 */
      unsigned int TXRQ:1;              /*  = [8..8] = 0x00000100 */
      unsigned int TXEN0:1;             /*  = [9..9] = 0x00000200 */
      unsigned int TXEN1:1;             /*  = [10..10] = 0x00000400 */
      unsigned int DIR:1;               /*  = [11..11] = 0x00000800 */
      unsigned int LIST:4;              /*  = [12..15] = 0x0000f000 */
      unsigned int PPREV:8;             /*  = [16..31] = 0x00ff0000 */
      unsigned int PNEXT:8;             /*  = [16..31] = 0xff000000 */
   } bits;
   unsigned long reg;
} __attribute__((aligned(4))) CAN_MOSTATm_t_nonv;

typedef volatile CAN_MOSTATm_t_nonv CAN_MOSTATm_t;

typedef union { /* 32 bits */
   struct {
      unsigned int RESRXPND:1;             /*  = [0..0] = 0x00000001 */
      unsigned int RESTXPND:1;             /*  = [1..1] = 0x00000002 */
      unsigned int RESRXUPD:1;             /*  = [2..2] = 0x00000004 */
      unsigned int RESNEWDAT:1;            /*  = [3..3] = 0x00000008 */
      unsigned int RESMSGLST:1;            /*  = [4..4] = 0x00000010 */
      unsigned int RESMSGVAL:1;            /*  = [5..5] = 0x00000020 */
      unsigned int RESRTSEL:1;             /*  = [6..6] = 0x00000040 */
      unsigned int RESRXEN:1;              /*  = [7..7] = 0x00000080 */
      unsigned int RESTXRQ:1;              /*  = [8..8] = 0x00000100 */
      unsigned int RESTXEN0:1;             /*  = [9..9] = 0x00000200 */
      unsigned int RESTXEN1:1;             /*  = [10..10] = 0x00000400 */
      unsigned int RESDIR:1;               /*  = [11..11] = 0x00000800 */
      unsigned int bit12:1;                /*  = [12..15] = 0x00001000 */
      unsigned int bit13:1;                /*  = [12..15] = 0x00002000 */
      unsigned int bit14:1;                /*  = [12..15] = 0x00004000 */
      unsigned int bit15:1;                /*  = [12..15] = 0x00008000 */
      unsigned int SETRXPND:1;             /*  = [0..0] = 0x00010000 */
      unsigned int SETTXPND:1;             /*  = [1..1] = 0x00020000 */
      unsigned int SETRXUPD:1;             /*  = [2..2] = 0x00040000 */
      unsigned int SETNEWDAT:1;            /*  = [3..3] = 0x00080000 */
      unsigned int SETMSGLST:1;            /*  = [4..4] = 0x00100000 */
      unsigned int SETMSGVAL:1;            /*  = [5..5] = 0x00200000 */
      unsigned int SETRTSEL:1;             /*  = [6..6] = 0x00400000 */
      unsigned int SETRXEN:1;              /*  = [7..7] = 0x00800000 */
      unsigned int SETTXRQ:1;              /*  = [8..8] = 0x01000000 */
      unsigned int SETTXEN0:1;             /*  = [9..9] = 0x02000000 */
      unsigned int SETTXEN1:1;             /*  = [10..10] = 0x04000000 */
      unsigned int SETDIR:1;               /*  = [11..11] = 0x08000000 */
      unsigned int bit28:1;                /*  = [12..15] = 0x10000000 */
      unsigned int bit29:1;                /*  = [12..15] = 0x20000000 */
      unsigned int bit30:1;                /*  = [12..15] = 0x40000000 */
      unsigned int bit31:1;                /*  = [12..15] = 0x80000000 */
   } bits;
   unsigned long reg;
} __attribute__((aligned(4))) CAN_MOCTRm_new_t_nonv;

typedef volatile CAN_MOCTRm_new_t_nonv CAN_MOCTRm_new_t;

}}}} // namespace hw::dev::can::multican

#endif /* HW_DEV_CAN_MULTICAN_REG_TYPES_TC1796B_H */
