// $Id: ASTImpl_CPU_SRC0.h 995 2009-08-11 14:26:31Z mike $
// Created:   25.03.2006 lohmann

#ifndef __HW_HAL_ASTIMPL_CPUSRC0_H__
#define __HW_HAL_ASTIMPL_CPUSRC0_H__

#include "stdinc.h"
#include "hw/irq/CPU_SRC0.h"
#include "CPU.h"

namespace hw { namespace hal {


class ASTImpl_CPU_SRC0 : protected hw::irq::CPU_SRC0 {

 public:
 	typedef hw::irq::CPU_SRC0 Super;
 	
	//! Trigger the AST to the CPU
	static void trigger() {
		Super::set();
	}
	static void enable() {
		Super::enable();
	}
	static void disable() {
		Super::disable();
	}
	
	static void beginDelay() {
		// TODO: This does not work if CPU_SRC0 uses an IRQL > 1 and other ASTs are used
		STATIC_ASSERT( Super::VECTOR == 1, AST0_implementation_requires_IRQL_1 );
		hw::hal::CPU::setIRQL( Super::VECTOR );
	}
	
	//! Ends a delay period started by beginDelay(), invokes pending AST execution.
	static void endDelay() {
		hw::hal::CPU::CPU::setIRQL( 0 );
	}
};

}} // namespace hw::hal

#endif // __HW_HAL_ASTIMPL_CPUSRC0_H__
