// $Id: Continuation.cpp 995 2009-08-11 14:26:31Z mike $

// dispatcher code must always be inlined
// CXXFLAGS_EXTRA=-finline -finline-functions

#include "Continuation.h"

namespace hw { namespace hal {

void CIAO_NOINLINE Continuation::internal_saveAndSwitchto( Continuation* to ) {
	before_CPURelease( to );
	//Continuation_switch(&context_, &to->context_);

	// task switch
	hw::GDT::Inst()[TASK_GATE].base0 = to->gdt_index * 8;
	asm volatile(
			"jmp %0, $0"
			:
			: "i"(TASK_GATE * 8)
			);
}

void CIAO_NOINLINE Continuation::internal_saveAndStart( void* tos, StartFunc starter, Continuation* to ) {
	before_CPURelease( to );

	// TODO: Code-Duplikation vermeiden
	// go (ohne load)

    void** ptos = (void**) tos;

    *(--ptos) = to;
    //*(--ptos) = (void*) 0xdeadbeef;

    // Kickoff
    *(--ptos) = (void*) starter;
    to->context_.esp = ptos;

	// TODO: ACHTUNG: Wenn diese Stacks genutzt werden, könnte der App-Stack überschrieben werden!!!
	to->context_.esp0 = ptos;
	to->context_.esp1 = ptos;
	to->context_.esp2 = ptos;

	to->context_.eip = (void*) starter;

	// task switch to start function
	hw::GDT::Inst()[TASK_GATE].base0 = to->gdt_index * 8;

	asm volatile(
			"jmp %0, $0"
			:
			: "i"(TASK_GATE * 8)
			);

	// task will continue here after getting back CPU
}

void Continuation::start_impl( Continuation* obj, void* tos, StartFunc starter, Continuation* to ) {
	obj->before_LastCPURelease( to );
	to->go( tos, starter );
}

void Continuation::saveAndStart_impl( void* tos, StartFunc starter, Continuation* to ) {
	internal_saveAndStart( tos, starter, to );
	after_CPUReceive();
}

void Continuation::switchto_impl( Continuation* obj, Continuation* to ) {
	obj->before_LastCPURelease( to );

	// initiate task switch
	hw::GDT::Inst()[TASK_GATE].base0 = to->gdt_index * 8;
	asm volatile(
			"jmp %0, $0"
			:
			: "i"(TASK_GATE * 8)
			);
}

void Continuation::saveAndSwitchto_impl( Continuation* to ){
	internal_saveAndSwitchto( to );
	after_CPUReceive();
}

}} 	// namespace hw::hal
