/*
 * SystemTimerImpl.cpp
 *
 *  Created on: Jun 22, 2010
 *      Author: bossel00
 */

#include "SystemTimerImpl.h"
#include "hw/hal/CPU.h"
#include "ciaoConfig.h"
#include "os/krn/Counter.h"

namespace hw {
namespace hal {

SystemTimerImpl SystemTimerImpl::impl_;

bool SystemTimerImpl::Handler() {
	if (running_) {
		++timer_;

		if (timer_ % period_ == 0) {
			if (single_) {
				running_ = false;
			}
      	shot_ = true;
		}
	}
  return shot_;
}

void SystemTimerImpl::doAction(){
  if(shot_){
    shot_ = false;
    {
      hw::hal::CPU::setAST(true); //see: "os/krn/SchedImpl_FullPreemptive.ah"
	  for(os::krn::Counter::Id cid = 0; cid < cfOS_NUMBER_OF_COUNTERS; cid++) {
        os::krn::Counter::Inst(cid).advanceCounter();
	  }
      hw::hal::CPU::setAST(false); //see: "os/krn/SchedImpl_FullPreemptive.ah"
    }
  }

}

}
}
