#ifndef HW_HAL_CAN_CANIF_H
#define HW_HAL_CAN_CANIF_H

#include "os/com/ComStack_Types.h"

#include "Controller.h"
#include "ConfigType.h"

namespace hw { namespace hal { namespace can {

extern ConfigType const DefaultConfig;

class CanIf {
protected:
	static CanIf theCanIf_;

	inline
	CanIf() {}

public:
	static inline CanIf&
	Inst(void) {
		return theCanIf_;
	}

	void
	Init(ConfigType const * ConfigPtr);

	inline void
	InitController(uint8 Controller, uint8 ConfigurationIndex) {
		Controller::Inst(Controller).InitController(ConfigurationIndex);
	}

	inline StatusType
	SetControllerMode(uint8 Controller, ControllerModeType ControllerMode) {
		return Controller::Inst(Controller).SetControllerMode(ControllerMode);
	}

	inline StatusType
	GetControllerMode(uint8 Controller, ControllerModeType * ControllerMode) {
		return Controller::Inst(Controller).GetControllerMode(ControllerMode);
	}

//	TODO No channel modes yet implemented
/*	inline ReturnType
	SetChannelMode(uint8 Controller, ChannelModeRequestType PduModeRequest) {
		return _ControllerDir[Controller].SetChannelMode(PduModeRequest);
	}

	inline ReturnType
	GetChannelMode(uint8 Controller, ChannelModeType * PduModePtr) {
		return _ControllerDir[Controller].GetChannelMode(PduModePtr);
	}
*/

//	void GetVersionInfo(VersionInfoType * VersionInfo);

//	SetDynamicTxId(PduIdType CanPduId, Can::IdType CanId);

//	TODO No transceiver driver yet implemented
//	SetTransceiverMode(uint8 Transceiver, TransceiverModeType TransceiverMode);
//	GetTransceiverMode(uint8 Transceiver, TransceiverModeType * TransceiverModePtr);

//	void ControllerBusOff(uint8 Controller);
private:
	void
	Init_NotNull(ConfigType const * ConfigPtr);
}; // class CanIf

}}}

#endif
