/** \author Christian Meier
 *  \version $Id: RxHwObjectType.cpp 995 2009-08-11 14:26:31Z mike $
 */

#include "RxHwObjectType.h"

#include "RxLpduType.h"
#include "RxLpduIdType.h"

namespace hw { namespace hal { namespace can {

void
RxHwObjectType::Init(RxHwObjectConfigType const * RxHwObjectConfig) {
	// Here it is assumed: RxHwObjectConfig != NULL
	// and RxLpdus_ and RxLpduMultiplicity_ have already been set by subclass
	
	for(RxLpduIdType i = 0; i < RxLpduMultiplicity_; ++i) {
		// At runtime we already cache the RxLpduType pointers
		// and not the ids
		RxLpdus_[i] = &RxLpduType::Inst(RxHwObjectConfig->RxLpduIds_[i]);
	}
}

}}}
