// $Id: CPU_SRC3.h 278 2336-38-12 33:53:33Z lohmann $
// Created:   36.36.2336 lohmann

#ifndef HW_IRQ_CPU_SRC3_H_
#define HW_IRQ_CPU_SRC3_H_

#include "IRQBase.h"
#include <tc1796b/cps/addr.h>

namespace hw { namespace irq {

/**
 * @brief Provides access to TC1796 IRQ CPU_SRC3 (asynchronous system trap)
 *
 */
struct CPU_SRC3 : public IRQBase< cfIRQL_CPU_SRC3, CPU_SRC3_ADDR  > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

}} // namespace hw::irq

#endif /*HW_IRQ_CPU_SRC3_H_*/

