// $Id: IRQBase.h 1168 2010-03-16 11:55:23Z mike $
// Created:   01.06.2006 lohmann


#ifndef IRQBASE_H
#define IRQBASE_H

#include "stdinc.h"
#include "hw/dev/IRQCtrl.h"


#ifndef cfHAL_IRQHANDLER_ATTRIBUTES
	#warning cfHAL_IRQHANDLER_ATTRIBUTES was not defined by p::v  - defaulting to __attribute__((interrupt))
	#define cfHAL_IRQHANDLER_ATTRIBUTES __attribute__((interrupt))
#endif

namespace hw { namespace _tc {

// Initialize SRPN for given node. Compile-time optimizes for
// unused SRNs (which get priority 0), as this is the default 
// after a reset
template< int V, UIntPtr REG_ADDR > struct InitSRPN {
	static void DO() {
		reinterpret_cast< SRC_t_nonv* >( REG_ADDR )->bits.SRPN = V;
	}
};
template< UIntPtr REG_ADDR > struct InitSRPN<0, REG_ADDR> {
	static void DO() {
		// Do nothing, 0 is default after reset
	}
};

}} // namespace hw::_tc

namespace hw { namespace irq { 

template< int V, UIntPtr REG_ADDR > 
struct IRQBase : public hw::dev::IRQCtrl< REG_ADDR > {
	enum DOXY_SYMBOL(Consts){ VECTOR = V }; 

	//! startup initialization, only called by hw::dev::XXX::init()
	static void init() {
		hw::_tc::InitSRPN< V, REG_ADDR >::DO();
	}	

};

}} // namespace hw::hal

#endif /*IRQBASEL_H*/
