#ifndef IRQBASE_H
#define IRQBASE_H

#include "stdinc.h"

#include "hw/dev/PIC.h"

namespace hw {
namespace irq {

// array of function ptrs to irq handler
extern Bool (*handler_table[])();

extern "C" void guardian(int num);

// advises can bind to this function
void irq_handler_not_found(int num);

class IRQBase {

public:
	//enum DOXY_SYMBOL(Consts) {VECTOR = V, REGISTER = V};

	//! startup initialization, only called by hw::dev::XXX::init()
	//static void init() {
	//}

	static void enableIRQ(int V) {
		hw::dev::PIC::Inst().enableIRQ(V);
	}

	static void disableIRQ(int V) {
		hw::dev::PIC::Inst().disableIRQ(V);
	}

};

}
} // namespace hw::hal

#endif // IRQBASE_H
