#include "TRAP6.h"
#include "hw/triboard1796.h"
#include "../cfFlags.h"
#include <machine/intrinsics.h>

void __attribute__((weak)) hw::trap::TRAP6::HWHandler(long tin) {
	/***********************************************************
	 * modify the context
	 ***********************************************************/

	// get the current pcxi
	PCXI_t_nonv pcxi;
	pcxi.reg = _mfcr( $pcxi );
	
	// get the previous context
	hw::_tc::LowerContext *ctx = (hw::_tc::LowerContext *)
									 (((pcxi.reg & PCXI_PCXS_MASK) << 12)
								   | ((pcxi.reg & PCXI_PCXO_MASK) << 6));

	// get the previous pcxi
	PCXI_t_nonv p_pcxi = ctx->pcxi_typed;

	// get the pre-previous context
	hw::_tc::UpperContext *p_ctx = (hw::_tc::UpperContext *)
									 (((p_pcxi.reg & PCXI_PCXS_MASK) << 12)
								   | ((p_pcxi.reg & PCXI_PCXO_MASK) << 6));


	/* enable supervisor mode and disable memory protection 
	 * (i.e. currently: switch to kernel's PRS) in
	 * the pre-previous context */
	p_ctx->psw_typed.bits.IO=2;
	p_ctx->psw_typed.bits.PRS=0;
	_dsync();
}
