#ifndef OS_COM_ASCOM_CFG_H
#define OS_COM_ASCOM_CFG_H

#include "ciaoConfig.h"
#include "util/types.h"
#include "util/metaprog.h"

// From old pvCfg.h
#define cfOS_COM_ASCOM_NUM_TX_GROUP_SIGNALS	2
#define cfOS_COM_ASCOM_NUM_TX_SIGNAL_GROUPS	2

#define cfOS_COM_ASCOM_NUM_RX_GROUP_SIGNALS	3
#define cfOS_COM_ASCOM_NUM_RX_SIGNAL_GROUPS 3

// Overall Filter bit lengths
#define cfOS_COM_ASCOM_RX_SIGNAL_FILTER_X_BIT_LENGTH										\
	metaprog::max<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_X_VALUE_BIT_LENGTH,						\
				  cfOS_COM_ASCOM_RX_SIGNAL_FILTER_ONE_EVERY_N_INIT_BIT_LENGTH>::RES

#define cfOS_COM_ASCOM_RX_SIGNAL_FILTER_Y_BIT_LENGTH										\
	metaprog::max<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_Y_VALUE_BIT_LENGTH,						\
	metaprog::max<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_ONE_EVERY_N_PERIOD_BIT_LENGTH,			\
				  cfOS_COM_ASCOM_RX_SIGNAL_FILTER_MASK_BIT_LENGTH>::RES >::RES

#define cfOS_COM_ASCOM_RX_SIGNAL_FILTER_ONE_EVERY_N_BIT_LENGTH								\
	metaprog::max<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_ONE_EVERY_N_PERIOD_BIT_LENGTH,			\
				  cfOS_COM_ASCOM_RX_SIGNAL_FILTER_ONE_EVERY_N_INIT_BIT_LENGTH>::RES

#define cfOS_COM_ASCOM_TX_SIGNAL_FILTER_X_BIT_LENGTH										\
	metaprog::max<cfOS_COM_ASCOM_TX_SIGNAL_FILTER_X_VALUE_BIT_LENGTH,						\
				  cfOS_COM_ASCOM_TX_SIGNAL_FILTER_ONE_EVERY_N_INIT_BIT_LENGTH>::RES

#define cfOS_COM_ASCOM_TX_SIGNAL_FILTER_Y_BIT_LENGTH										\
	metaprog::max<cfOS_COM_ASCOM_TX_SIGNAL_FILTER_Y_VALUE_BIT_LENGTH,						\
	metaprog::max<cfOS_COM_ASCOM_TX_SIGNAL_FILTER_ONE_EVERY_N_PERIOD_BIT_LENGTH,			\
				  cfOS_COM_ASCOM_TX_SIGNAL_FILTER_MASK_BIT_LENGTH>::RES >::RES

#define cfOS_COM_ASCOM_TX_SIGNAL_FILTER_ONE_EVERY_N_BIT_LENGTH								\
	metaprog::max<cfOS_COM_ASCOM_TX_SIGNAL_FILTER_ONE_EVERY_N_PERIOD_BIT_LENGTH,			\
				  cfOS_COM_ASCOM_TX_SIGNAL_FILTER_ONE_EVERY_N_INIT_BIT_LENGTH>::RES

// TX+RX
#define cfOS_COM_ASCOM_FILTER_X_VALUE_BIT_LENGTH											\
	metaprog::max<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_X_VALUE_BIT_LENGTH,						\
				  cfOS_COM_ASCOM_TX_SIGNAL_FILTER_X_VALUE_BIT_LENGTH>::RES

#define cfOS_COM_ASCOM_FILTER_Y_VALUE_BIT_LENGTH											\
	metaprog::max<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_Y_VALUE_BIT_LENGTH,						\
				  cfOS_COM_ASCOM_TX_SIGNAL_FILTER_Y_VALUE_BIT_LENGTH>::RES

#define cfOS_COM_ASCOM_FILTER_MASK_BIT_LENGTH												\
	metaprog::max<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_MASK_BIT_LENGTH,							\
				  cfOS_COM_ASCOM_TX_SIGNAL_FILTER_MASK_BIT_LENGTH>::RES

#define cfOS_COM_ASCOM_FILTER_ONE_EVERY_N_BIT_LENGTH										\
	metaprog::max<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_ONE_EVERY_N_BIT_LENGTH,					\
				  cfOS_COM_ASCOM_TX_SIGNAL_FILTER_ONE_EVERY_N_BIT_LENGTH>::RES

#define cfOS_COM_ASCOM_RX_IPDU_DM_COMBINED_TIMEOUT_FACTOR_BIT_LENGTH						\
	metaprog::max<cfOS_COM_ASCOM_RX_IPDU_DM_TIMEOUT_FACTOR_BIT_LENGTH,						\
				  cfOS_COM_ASCOM_RX_IPDU_DM_FIRST_TIMEOUT_FACTOR_BIT_LENGTH>::RES

#define cfOS_COM_ASCOM_TX_IPDU_DM_COMBINED_TIMEOUT_FACTOR_BIT_LENGTH						\
	metaprog::max<cfOS_COM_ASCOM_TX_IPDU_DM_TIMEOUT_FACTOR_BIT_LENGTH,						\
				  cfOS_COM_ASCOM_TX_IPDU_DM_FIRST_TIMEOUT_FACTOR_BIT_LENGTH>::RES

#define cfOS_COM_ASCOM_TX_IPDU_PERIODIC_TM_COMBINED_TIME_FACTOR_BIT_LENGTH					\
    metaprog::max< cfOS_COM_ASCOM_TX_IPDU_PERIODIC_TM_TIME_PERIOD_FACTOR_BIT_LENGTH,		\
				   cfOS_COM_ASCOM_TX_IPDU_PERIODIC_TM_TIME_OFFSET_FACTOR_BIT_LENGTH>::RES

#define cfOS_COM_ASCOM_TX_IPDU_MULTIPLICITY_MIN_1											\
	metaprog::max< cfOS_COM_ASCOM_TX_IPDU_MULTIPLICITY, 1 >::RES

#define cfOS_COM_ASCOM_TX_IPDU_MAX_BYTE_LENGTH_MIN_1										\
	metaprog::max< cfOS_COM_ASCOM_TX_IPDU_MAX_BYTE_LENGTH, 1 >::RES

#define cfOS_COM_ASCOM_RX_IPDU_MULTIPLICITY_MIN_1											\
	metaprog::max< cfOS_COM_ASCOM_RX_IPDU_MULTIPLICITY, 1 >::RES

#define cfOS_COM_ASCOM_RX_IPDU_MAX_BYTE_LENGTH_MIN_1										\
	metaprog::max< cfOS_COM_ASCOM_RX_IPDU_MAX_BYTE_LENGTH, 1 >::RES

#define cfOS_COM_ASCOM_TX_SIGNAL_MAX_BYTE_LENGTH_MIN_1										\
	metaprog::max< cfOS_COM_ASCOM_TX_SIGNAL_MAX_BYTE_LENGTH, 1 >::RES

#define cfOS_COM_ASCOM_RX_SIGNAL_MAX_BYTE_LENGTH_MIN_1										\
	metaprog::max< cfOS_COM_ASCOM_RX_SIGNAL_MAX_BYTE_LENGTH, 1 >::RES

#define cfOS_COM_ASCOM_TX_SIGNAL_MULTIPLICITY_MIN_1											\
	metaprog::max< cfOS_COM_ASCOM_TX_SIGNAL_MULTIPLICITY, 1 >::RES

#define cfOS_COM_ASCOM_TX_SIGNAL_GROUP_MULTIPLICITY_MIN_1									\
	metaprog::max< cfOS_COM_ASCOM_TX_SIGNAL_GROUP_MULTIPLICITY, 1 >::RES

#define cfOS_COM_ASCOM_RX_SIGNAL_MULTIPLICITY_MIN_1											\
	metaprog::max< cfOS_COM_ASCOM_RX_SIGNAL_MULTIPLICITY, 1 >::RES

#define cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY_MIN_1									\
	metaprog::max< cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY, 1 >::RES

namespace os { namespace com { namespace ascom {

template <typename T, unsigned long LENGTH>
struct is_integer : public metaprog::select< metaprog::same_types< T, UInt8[LENGTH] >::RES, metaprog::false_, is_integer<T, LENGTH-1> >::T {
};

template <typename T>
struct is_integer<T,0> {
	enum { RES = true };
};

template <typename T, int LENGTH>
struct is_signed : public metaprog::select< is_integer<T,LENGTH>::RES, integer_is_signed<T>, metaprog::false_>::T {

};

// ByteIndexType
// uint_value(_opt): passed number is exclusive so uint_t_value<5>::T can hold 0 .. 4 --> +1
// ByteIndexType can iterate until MAX_VAL+1 --> +1
// together --> +2
typedef uint_t_value_opt<metaprog::max<cfOS_COM_ASCOM_RX_IPDU_MAX_BYTE_LENGTH_MIN_1 - 1,
									   cfOS_COM_ASCOM_RX_SIGNAL_MAX_BYTE_LENGTH_MIN_1 - 1>::RES + 2 >::T RxByteIndexType;

typedef uint_t_value<metaprog::max<cfOS_COM_ASCOM_RX_IPDU_MAX_BYTE_LENGTH_MIN_1 - 1,
								   cfOS_COM_ASCOM_RX_SIGNAL_MAX_BYTE_LENGTH_MIN_1 - 1>::RES + 2 >::T RxByteIndexStorageType;

typedef uint_t_value_opt<metaprog::max<cfOS_COM_ASCOM_TX_IPDU_MAX_BYTE_LENGTH_MIN_1 - 1,
									   cfOS_COM_ASCOM_TX_SIGNAL_MAX_BYTE_LENGTH_MIN_1 - 1>::RES + 2 >::T TxByteIndexType;

typedef uint_t_value<metaprog::max<cfOS_COM_ASCOM_TX_IPDU_MAX_BYTE_LENGTH_MIN_1 - 1,
								   cfOS_COM_ASCOM_TX_SIGNAL_MAX_BYTE_LENGTH_MIN_1 - 1>::RES + 2 >::T TxByteIndexStorageType;

typedef uint_t_value_opt<__CHAR_BIT__ + 1>::T BitIndexType;
typedef uint_t_value<__CHAR_BIT__ + 1>::T BitIndexStorageType;

typedef uint_t_minbits_opt<cfOS_COM_ASCOM_FILTER_X_VALUE_BIT_LENGTH>::T			  FilterXValueType;
typedef uint_t_minbits_opt<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_X_VALUE_BIT_LENGTH>::T RxFilterXValueType;
typedef uint_t_minbits_opt<cfOS_COM_ASCOM_TX_SIGNAL_FILTER_X_VALUE_BIT_LENGTH>::T TxFilterXValueType;

typedef uint_t_minbits_opt<cfOS_COM_ASCOM_FILTER_Y_VALUE_BIT_LENGTH>::T 		  FilterYValueType;
typedef uint_t_minbits_opt<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_Y_VALUE_BIT_LENGTH>::T RxFilterYValueType;
typedef uint_t_minbits_opt<cfOS_COM_ASCOM_TX_SIGNAL_FILTER_Y_VALUE_BIT_LENGTH>::T TxFilterYValueType;

typedef uint_t_minbits_opt<cfOS_COM_ASCOM_FILTER_MASK_BIT_LENGTH>::T			  FilterMaskType;
typedef uint_t_minbits_opt<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_MASK_BIT_LENGTH>::T    RxFilterMaskType;
typedef uint_t_minbits_opt<cfOS_COM_ASCOM_TX_SIGNAL_FILTER_MASK_BIT_LENGTH>::T    TxFilterMaskType;

typedef uint_t_minbits_opt<cfOS_COM_ASCOM_FILTER_ONE_EVERY_N_BIT_LENGTH>::T			  OneEveryNCounterType;
typedef uint_t_minbits_opt<cfOS_COM_ASCOM_RX_SIGNAL_FILTER_ONE_EVERY_N_BIT_LENGTH>::T RxOneEveryNCounterType;
typedef uint_t_minbits    <cfOS_COM_ASCOM_RX_SIGNAL_FILTER_ONE_EVERY_N_BIT_LENGTH>::T RxOneEveryNCounterStorageType;
typedef uint_t_minbits_opt<cfOS_COM_ASCOM_TX_SIGNAL_FILTER_ONE_EVERY_N_BIT_LENGTH>::T TxOneEveryNCounterType;
typedef uint_t_minbits    <cfOS_COM_ASCOM_TX_SIGNAL_FILTER_ONE_EVERY_N_BIT_LENGTH>::T TxOneEveryNCounterStorageType;

typedef uint_t_minbits_opt<cfOS_COM_ASCOM_TX_IPDU_MD_TIMEOUT_FACTOR_BIT_LENGTH>::T MDCounterType;

typedef uint_t_minbits_opt<cfOS_COM_ASCOM_RX_IPDU_DM_COMBINED_TIMEOUT_FACTOR_BIT_LENGTH>::T RxDMCounterType;
typedef uint_t_minbits_opt<cfOS_COM_ASCOM_TX_IPDU_DM_COMBINED_TIMEOUT_FACTOR_BIT_LENGTH>::T TxDMCounterType;

typedef uint_t_minbits_opt<cfOS_COM_ASCOM_TX_IPDU_PERIODIC_TM_COMBINED_TIME_FACTOR_BIT_LENGTH>::T PeriodicTMTimeFactorType;
typedef uint_t_minbits<cfOS_COM_ASCOM_TX_IPDU_PERIODIC_TM_COMBINED_TIME_FACTOR_BIT_LENGTH>::T	  PeriodicTMTimeFactorStorageType;

typedef uint_t_value<cfOS_COM_ASCOM_RX_SIGNAL_MULTIPLICITY>::T		RxSignalIdStorageType;
typedef uint_t_value_opt<cfOS_COM_ASCOM_RX_SIGNAL_MULTIPLICITY>::T	RxSignalIdType;

typedef uint_t_value<cfOS_COM_ASCOM_TX_SIGNAL_MULTIPLICITY>::T		TxSignalIdStorageType;
typedef uint_t_value_opt<cfOS_COM_ASCOM_TX_SIGNAL_MULTIPLICITY>::T	TxSignalIdType;

typedef uint_t_value_opt<cfOS_COM_ASCOM_RX_IPDU_MULTIPLICITY>::T	RxIpduIdType;
typedef uint_t_value<cfOS_COM_ASCOM_RX_IPDU_MULTIPLICITY>::T		RxIpduIdStorageType;

typedef uint_t_value_opt<cfOS_COM_ASCOM_TX_IPDU_MULTIPLICITY>::T	TxIpduIdType;
typedef uint_t_value<cfOS_COM_ASCOM_TX_IPDU_MULTIPLICITY>::T		TxIpduIdStorageType;

typedef uint_t_value<cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY>::T		RxSignalGroupIdStorageType;
typedef uint_t_value_opt<cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY>::T	RxSignalGroupIdType;

typedef uint_t_value<cfOS_COM_ASCOM_TX_SIGNAL_GROUP_MULTIPLICITY>::T		TxSignalGroupIdStorageType;
typedef uint_t_value_opt<cfOS_COM_ASCOM_TX_SIGNAL_GROUP_MULTIPLICITY>::T	TxSignalGroupIdType;

typedef uint_t_value_opt<cfOS_COM_ASCOM_RX_IPDU_GROUP_MULTIPLICITY>::T	RxIpduGroupIdType;
typedef uint_t_value<cfOS_COM_ASCOM_RX_IPDU_GROUP_MULTIPLICITY>::T		RxIpduGroupIdStorageType;

typedef uint_t_value_opt<cfOS_COM_ASCOM_TX_IPDU_GROUP_MULTIPLICITY>::T	TxIpduGroupIdType;
typedef uint_t_value<cfOS_COM_ASCOM_TX_IPDU_GROUP_MULTIPLICITY>::T		TxIpduGroupIdStorageType;

// Maybe better at another place
class RxSignalType;
class TxSignalType;
typedef Bool (*RxFilterType)(RxSignalType * Sig, void const * NewValue);
typedef Bool (*TxFilterType)(TxSignalType * Sig, void const * NewValue);

}}}

#endif
