#ifndef OS_COM_ASCOM_TX_FILTER_NEW_IS_OUTSIDE_H
#define OS_COM_ASCOM_TX_FILTER_NEW_IS_OUTSIDE_H

#include "util/bitmanip.h"
#include "os/com/ComStack_Types.h"
#include "os/com/ascom/Cfg.h"
#include "os/com/ascom/FilterAlgo.h"
#include "os/com/ascom/tx/TxSignalType.h"

namespace os { namespace com { namespace ascom {

namespace txfilter {

template<typename T>
Bool
NewIsOutside(TxSignalType * TxSig, void const * NewValue) {
	// As FilterX and Y are saved inside unsigned bitfield container we must
	// extract the data manually with correct sign
	return filter::NewIsOutside< T >(*(T const *)(NewValue),
				bitmanip::static_extract_low< T,metaprog::min<cfOS_COM_ASCOM_TX_SIGNAL_FILTER_X_VALUE_BIT_LENGTH,
							sizeof(T)*__CHAR_BIT__ >::RES >((T)TxSig->FilterXValue()),
				bitmanip::static_extract_low< T,metaprog::min<cfOS_COM_ASCOM_TX_SIGNAL_FILTER_Y_VALUE_BIT_LENGTH,
							sizeof(T)*__CHAR_BIT__ >::RES >((T)TxSig->FilterYValue()));
}

}

}}}

#endif
