#include "TxSignalGroupType.h"
#include "TxIpduType.h"
#include "TxSignalType.h"

namespace os { namespace com { namespace ascom {

void
TxSignalGroupType::TxConfirmation(UInt8 const * SduPtr) {

}

void
TxSignalGroupType::Start (Bool Initialize) {
	for (TxSignalIdType ActId = SignalIdMin (); ActId <= SignalIdMax (); ++ActId) {
		TxSignalType::Inst (ActId).Start (Initialize);
	}
}

void
TxSignalGroupType::Stop () {
	for (TxSignalIdType ActId = SignalIdMin (); ActId <= SignalIdMax (); ++ActId) {
		TxSignalType::Inst (ActId).Stop ();
	}
}

StatusType
TxSignalGroupType::SendSignalGroup () {
	UInt8 * SduBuffer = TxIpduType::Inst (IpduId ()).SduBuffer ();

	// Tricky: the last group signal has been configured with signal group
	// attributes, and it will be "abused" by directly sending it.
	// All the stuff like StartedCheck, begin deadline monitoring, ...
	// will be done implicitly.
	TxSignalIdType ActId = SignalIdMin ();
	for (; ActId < SignalIdMax (); ++ActId) {
		TxSignalType::Inst (ActId).CommitGroupSignal (SduBuffer);
	}

	TxSignalType * TxSigPtr = & TxSignalType::Inst (ActId);

	// This actually triggers checks of transfer property, transmission mode, etc.
	return TxSigPtr->SendSignal (TxSigPtr->NewValue ());
}

TxSignalGroupType TxSignalGroupType::TxSignalGroups_[cfOS_COM_ASCOM_TX_SIGNAL_GROUP_MULTIPLICITY];
}}}
