#ifndef EPILOGUECONTAINER_H_
#define EPILOGUECONTAINER_H_

#include "GateBase.h"
#include "hw/hal/CPU.h"
#include "Queue.h"
#include "stdinc.h"


namespace os { namespace irq {

typedef GateBase* Gate;

class EpilogueContainer : private Queue
{
	typedef Queue Super;

public:
	void enqueue(GateBase *epilogueObject) {
		if (isEnqueued(epilogueObject)) {
			return;
		}
		
		epilogueObject->queued = true;
		Super::enqueue(epilogueObject);
	}
	
	GateBase *dequeue() {
		//TODO:WORKS ONLY WITH AST-BASED IMPLEMENTATION
		hw::hal::CPU::disable();
		GateBase *epilogueObject = (GateBase *) Super::dequeue();
		hw::hal::CPU::enable();
		epilogueObject->queued = false;		
		return epilogueObject;
	}
	
	Bool isEnqueued(GateBase *epilogueObject) {
		return epilogueObject->queued;
	}
	
	Bool isFilled() {
		return Super::isFilled();
	}
	
	void init() {
		Super::init();
	};
};

}} //os::irq

#endif /*EPILOGUECONTAINER_H_*/
