#ifndef __os_irq_GateBase_h__
#define __os_irq_GateBase_h__

#include "os/irq/ChainBase.h"

namespace os { namespace irq {

//! Baseclass used for transformation of VIRQs into epilogue objects 
class GateBase : public ChainBase {
	
friend class EpilogueContainer;
	
public:
	GateBase() : queued(false) {}
	
	void doEpilogue() {
		theEpilogue();
	}
	
	GateBase *getGate() {
		return this;
	}
	
protected:
	void (* theEpilogue)(void);
	bool queued;
};

}}

#endif // __os_irq_GateBase_h__
