// $Id$

#include "ciaoConfig.h"

#include "hw/hal/SystemTimer.h"
#include "os/krn/SchedImpl.h"
#include "os/krn/Alarm.h"

namespace os { namespace krn {
	void Alarm::trigger (Id alarmid) {
		// reconf cyclic alarm
		if(getCycleTime(alarmid) > 0) {
			setRelativeTime(alarmid, getCycleTime(alarmid));

			// disable single shot
		} else {
			setArmed(alarmid, false);
		} 

		triggerAction(alarmid);
	} 
	
	void Alarm::triggerAction (Id alarmid) {
		SchedImpl::Inst ().activate(getTask (alarmid));
	}
}} // namespace os::krn
