// $Id: OSControl.cpp 995 2009-08-11 14:26:31Z mike $
// Created: 2007-06-28 siwahofe

#include "OSControl.h"
#include "util/types.h"
#include "Task.h"
#include "ciaoConfig.h"
#include "AppMode.h"
#include "SchedImpl.h"
#include "hw/hal/CPU.h"
#include "EnterLeave.h"

namespace os { namespace krn {

OSControl OSControl::theOSControl_;

void OSControl::startOS (AppModeType appmode) {
	AppMode::TaskMask autostart = AppMode::getTaskMask (appmode);
	while (autostart != 0) {
		//Task::setState (highest1Bit (autostart), Task::READY);
		SchedImpl::Inst().setReady(highest1Bit (autostart));
		autostart = clearBit (autostart, highest1Bit (autostart));
	}
	currentApplicationMode_ = appmode;
	SchedImpl::Inst ().setTaskTable (cfOS_NUMBER_OF_TASKS);

	startScheduling ();
}

void OSControl::startScheduling () {
	enterKernel ();
	hw::hal::CPU::enable ();
	SchedImpl::Inst ().start ();
	_debug ();
}

void OSControl::shutdownOS (StatusType error) {
	_debug ();
}

AppModeType OSControl::getApplicationMode () {
	return currentApplicationMode_;
}

}} // namespace os::krn
