// $Id: Resource.h 995 2009-08-11 14:26:31Z mike $
// Created: 2007-06-15 siwahofe

#ifndef __OS_KRN_RESOURCE_H__
#define __OS_KRN_RESOURCE_H__

#include "ciaoConfig.h"
#include "util/types.h"
#include "Task.h"

namespace os { namespace krn {

struct Resource {
	
	// data type to represent number of resources plus RES_SCHEDULER
	typedef uint_t_value <(cfOS_NUMBER_OF_RESOURCES + 1)>::T Id;
	static const Id SCHEDULER = cfOS_NUMBER_OF_RESOURCES;

	Task::Pri ceilingPri_;

	static Resource& Inst (Id resourceid);

	static Task::Pri getCeilingPri (Id resourceid) {
		return Inst (resourceid).ceilingPri_;
	}
};


extern Resource theResources [];

inline Resource& Resource::Inst (Resource::Id resourceid) {
	return theResources [resourceid];
}

}} // namespace os::krn
 
#endif // __OS_KRN_RESOURCE_H__
