#ifndef OS_MP_ACLENTRY_H_
#define OS_MP_ACLENTRY_H_

#include "util/types.h"
#include "os/mp/MPU.h"

namespace os { namespace mp {

	class ACLEntry {
		Ptr lowerBound;
		Ptr upperBound;

		inline void enableACL() const {
			os::mp::MPU::setMessageRange(lowerBound, upperBound);
			os::mp::MPU::setMessagePerms(os::mp::MPU::WRITE);
		}

		inline void disableACL() const {
			os::mp::MPU::setMessageRange(0, 0); // not really needed
			os::mp::MPU::setMessagePerms(0);
		}

		inline void setRange(Ptr lb, Ptr ub) {
			lowerBound = lb;
			upperBound = ub;
		}
	};

}}

#endif
