#ifndef _OS_KRN_MESSAGEPORT_GRANTWRITERECEIVER_H_
#define _OS_KRN_MESSAGEPORT_GRANTWRITERECEIVER_H_

#include "os/krn/Messageport.h"
#include "os/mp/MPU.h"
#include "Context.h"

namespace os { namespace mp {

	template <typename MSGTYPE, int msgCount>
		class ReceiverPortWriteAccess {
			public:
				os::krn::ReceiverPort<MSGTYPE, msgCount> rp;

			inline bool peek() {
				return rp.peek();
			}

			inline MSGTYPE *receiveMessage() {
				MSGTYPE *msg = rp.receiveMessage();

				if(!os::mp::Context::isTrustedMPU()) {
					os::mp::MPU::enterTrusted();
					os::mp::Context::setACL(msg,msg+1);
					os::mp::Context::enableACL();
					os::mp::MPU::leaveTrusted_drv();
				}

				return msg;
			}

			inline void releaseMessage(MSGTYPE *msg) {

				if(!os::mp::Context::isTrustedMPU()) {
					os::mp::MPU::enterTrusted();
					os::mp::Context::disableACL();
					os::mp::MPU::leaveTrusted_drv();
				}

				rp.releaseMessage(msg);
			}
		};

}}; // namespace os::mp

#endif
