#ifndef OS_MP_POINTCUTS_H_
#define OS_MP_POINTCUTS_H_

#ifdef BUILDELF
#include "app_pointcuts.h"
#else
#include "app_pointcuts_dummy.h"
#endif

namespace os { namespace mp {
	pointcut pcNonTrustedISRs() = pcISRs() && pcNonTrusted();
	pointcut pcExecNonTrustedISRs() = execution(pcNonTrustedISRs());
	
	pointcut pcNtoT() = pcToT() && within(pcNonTrusted()) && !call(pcNoAction()) && !call(pcConstMethods()) && !call(asConstServices());
	pointcut pcTtoN() = pcToN() && within(pcTrustedApps()) && !call(pcNoAction());
	pointcut pcNtoN() = pcToN() && within(pcNonTrusted()) && !call(pcNoAction());
	pointcut pcNtoOS() = call(pcOS() && !pcNoAction()) && within(pcNonTrusted()) && !call(pcConstMethods()) && !call(asConstServices());
	pointcut pcInOS() = execution(pcOS() && !pcNoAction() && !pcConstMethods() && !asConstServices() && !asStartOS());
}}

#endif /*POINTCUTS_AH_*/
