#ifndef OS_TP_TP_COMMON_DATA_H_
#define OS_TP_TP_COMMON_DATA_H_

#include "ciaoConfig.h"
#include "TP_common_definitions.h"
#include "TP_common_deadlinecause.h"
#include "TP_common_queue.h"
#include "TP_common_queueelement.h"

namespace os { namespace tp {

class TP_Deadlines {
private:
	SortedDeadlineQueue<cfTP_QUEUELENGTH> queue_;
	static TP_Deadlines theTPDeadlines_;

public:
	static TP_Deadlines& Inst (){
		return theTPDeadlines_;
	}

	void Init();

	void dealWithDeadline(QueueElement e); //Timing protection aspects should bind here, see .cpp

	QueueElement* windupNextDeadline();

	QueueElement* addDeadline(UInt32 when, DeadlineType what, DeadlineCause who);

	void removeDeadline(QueueElement* whom);

	QueueElement* getCurrentDeadline();
};

}}


#endif /*OS_TP_TP_COMMON_DATA_H_*/
