#ifndef __DlQueue_h__
#define __DlQueue_h__

#include "util/container/Queue.h"
#include "util/container/DlChain.h"

//! A double linked queue
/*! Container with constant insertion and deletion time.
 *  Has bidirectional iterator
 *  This container can be instantiated with custom types and/or 
 *  allocators
 */
template<class T>
class DlQueue : public Queue< T, DlChain<T> >{

public:
		
		typedef Queue< T , DlChain<T> > Base;
		
		typedef typename Base::node_t node_t;
		
		//! Default constructor
		DlQueue():Base(){}
		
		//! Constructor
		/*!
		 * \param elem will be the first element in the Queue
		 */ 
		DlQueue(node_t* elem):Base(elem){}
		
		//! Copy Constructor 
		/*!
		 * \param queue is another queue object
		 */
		DlQueue(DlQueue& queue):Base(queue._front){}
}; 

#endif // __DlQueue_h__

