#ifndef __InitArray_h__
#define __InitArray_h__

//#include "mem/Allocator.h"

#include "util/container/StandardIterator.h"
#include "util/types.h"


//! A InitArray
/*! Container with random access
 */
template<class T,int S>
class InitArray{

// public typedefs and enums
public:
	//! Type definition of instatiated type
	typedef T value_t;
	//! Type definition of pointer to intantiated type
	typedef T* pointer_t;
	//! Type definition of an index type
	typedef typename index_t_value<S>::T index_t;

	//! Type definition of an iterator type
	typedef StandardIterator<T> iterator_t;
	
	//! a short (STL conforming) form of iterator type. 
	typedef iterator_t iterator;
	
	//! size of InitArray	
	enum{CAPACITY=S};
	
// protected variables	
protected:
		//! InitArray of content types
		value_t _content[CAPACITY];
		
	
//public methods
public:
		//! Constructor 
		InitArray(){}
		
		//! Copy constructor
		
		//! Desturctor
		~InitArray(){}
		
		//! Get size of InitArray
		/*! 
		 */
		index_t capacity(){
			return CAPACITY;
		}
		
		
		//! Get content of Container
		/*!
		 * \param i is the position of the stored Object
		 */
		value_t& operator[](int i) {
			return  _content[i];
		}
			
		//! Get an iterator which marks the start of the vector
		iterator_t begin(){
			return  _content;
		}
		
		//! Get an iterator which marks the end of the vector
		iterator_t end(){
			return  &(_content[CAPACITY]);
		}
};

#endif // __InitArray_h__
