#ifndef __alloc_DlList_h__
#define __alloc_DlList_h__

#include "util/container/allocating/List.h"
#include "util/container/DlChain.h"

namespace allocating{

//! A double linked list
/*! Container with constant insertion and deletion time.
 *  Has bidirectional iterator
 *  This container can be instantiated with custom types and/or 
 *  allocators
 */
template<class T,class A = DefaultAllocator >
class DlList : public List< T,A,DlChain<T> >{

public:
		
		typedef List< T ,A, DlChain<T> > Base;
		
		typedef typename Base::node_t node_t;
		
		typedef typename Base::alloc_t alloc_t;
		
		//! Default constructor
		DlList():Base(){}
		
		//! Constructor
		/*!
		 * \param elem will be the first element in the List
		 */ 
		DlList(alloc_t& alloc):Base(alloc){}
		
		//! Copy Constructor 
		/*!
		 * \param list is another list object
		 */
		DlList(DlList& list):Base(static_cast<Base>(list)){}
}; // class DlList

} // namespace allocating

#endif // __DlList_h__

