#ifndef __Allocator_h__
#define __Allocator_h__

#include "util/types.h"

template<class M,class ST>
class Allocator{

public:
	typedef Ptr pointer_t ;
	
	typedef M mempool_t;
	
	typedef ST strategy_t;
	
	typedef Allocator<M,ST> alloc_t;
	

private:
	mempool_t _mempool;
	strategy_t _strategy;

public:
	Allocator():_strategy(_mempool){}

	Allocator(mempool_t& mpool):_mempool(mpool),_strategy(mpool){}
	
	Allocator(Allocator& alloc):_mempool(alloc._mempool),_strategy(alloc._strategy){}
	
	~Allocator(){};
	
	const Ptr allocate(UIntPtr i){
		return (const Ptr) _strategy.get(i);
	}
	
	const Ptr allocate2(UIntPtr& i){
		return 	_strategy.get(i);
	}
	
	int used(){
		return 0;
	}

	void free(Ptr addr){
		_strategy.put(addr);
	}
	
};


#endif //__Allocator_h__

