#ifndef __StaticMemPool_h__
#define __StaticMemPool_h__

#include "util/types.h"
#include "mem/MemPoolBase.h"


template <int S=0,int ID=0>
class StaticMemPool: public MemPoolBase {

public:
	typedef UInt8 value_t;
	typedef Ptr pointer_t;
	
	enum{SIZE=S};
	
private:
	static value_t _addr[S];

public:
	StaticMemPool(){};
	~StaticMemPool(){};
	
	pointer_t addr() {
		return static_cast<pointer_t>(_addr);
	}
	
	size_t size() {
		return SIZE;
	}
};

template <int S,int ID>
UInt8 StaticMemPool<S,ID>::_addr[S];

#endif // __StaticMemPool_h__
