// Testcase InterruptClassic appcode.cpp
// sirupfis 14.02.2008 

#include "appcode.h"
#include "as/AS.h"
#include "objects.h"
#include "stdio.h"

#include "hw/irq/DMA_SYSSRC2.h"
#include "hw/hal/STMTimer.h"

//HAS to be overridden! (standard-main() only does StartOS)
int CIAO_WEAK main () {

	// enable SRN DMA_SYSSRC2
	hw::irq::DMA_SYSSRC2::enable ();
	
	// enable interrupts for cpu
	hw::hal::CPU::enable();
	
	// start OS
	os::krn::OSControl::Inst ().startOS (OSDEFAULTAPPMODE);
	return 0;
}

// Event Handling
Bool hw::irq::DMA_SYSSRC2::HWHandler() {
	Alpha::functionISRISRIn2();
	return true;
}

void Alpha::functionISRISRIn2(void) {

	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1000 );
	int count;
	UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	count = 0;
	
	while (count < 5)
	{
		if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
		{
			next = hw::dev::STM::TIM<0>() + ticks;
			count++;
		}
		else if (hw::dev::STM::TIM<0>() > next)
		{
			next = next + ticks;
			count++;
		}
	}

//	return true;
}

// irq handler to start the realtime task
Bool hw::hal::STMTimer0::IRQ::HWHandler() {
	Alpha::functionISRISRIn1();
	return true;
}

void Alpha::functionISRISRIn1(void) {
}

// ...
void Alpha::functionTaskTask3 (void) {

	AS::TerminateTask();
}

// dummy - not used ...
void Alpha::functionTaskTask1(void) {

	AS::TerminateTask();
}

void triggerDMA_SYSSRC2() {

	hw::irq::DMA_SYSSRC2::set();	
}

void Alpha::functionTaskTask0(void) {

	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1000 );
	int count;

	while (true)
	{
		count = 0;
		UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 5)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}

	triggerDMA_SYSSRC2();

		count = 0;
		next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 65)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}
	}
}

// dummy - not used in this test ...
void Alpha::functionTaskTask2(void) {

	// suspend task
	AS::TerminateTask();
}
