// Testcase InterruptPCP appcode.cpp 
// sirupfis 14.02.2008

#include "appcode.h"
#include "as/AS.h"
#include "objects.h"
#include "stdio.h"

#include "hw/irq/PCP.h"
#include "hw/irq/DMA_SYSSRC2.h"
#include "hw/hal/STMTimer.h"

// Register definitions - TODO: move to some header file ...
#define IGCR0	*((unsigned int volatile *) 0xF0000094)	/* Interrupt Gating Register 0 */
#define EICR0	*((unsigned int volatile *) 0xF0000080)	/* External Input Channel Register 0 */

//HAS to be overridden! (standard-main() only does StartOS)

int CIAO_WEAK main () {

	// enable SRN DMA_SYSSRC2
	hw::irq::PCP::setTaskInt((os::krn::Task::Pri) 5, (os::krn::Task::Pri) 5, os::krn::Task::Inst(Task2), Task2);
	hw::irq::DMA_SYSSRC2::setTOSPCP ();
	hw::irq::DMA_SYSSRC2::enable ();
	
	// enable SRN of STMTimer0
	hw::irq::PCP::setTaskInt((os::krn::Task::Pri) 7, (os::krn::Task::Pri) 7, os::krn::Task::Inst(Task3), Task3);
	hw::hal::STMTimer0::IRQ::setTOSPCP ();
	hw::hal::STMTimer0::IRQ::enable();

	// enable interrupts for cpu
	hw::hal::CPU::enable();
	
	// start OS
	os::krn::OSControl::Inst ().startOS (OSDEFAULTAPPMODE);
	return 0;
}

void triggerDMA_SYSSRC2() {

	hw::irq::DMA_SYSSRC2::set();	
}

void triggerSTMTimer0() {

	hw::hal::STMTimer0::IRQ::set();	
}

void Alpha::functionTaskTask0(void) {

	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1000 );
	int count;

	while (true)
	{
		count = 0;
		UInt32  next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 5)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}

	triggerDMA_SYSSRC2();
	for (int i = 0; i < 5; i++) {
		asm ( " nop " );
	}
	triggerSTMTimer0();

		count = 0;
		next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 85)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}
	}
}

// dummy - not used in this test case ...
void Alpha::functionTaskTask1 (void) {

		AS::TerminateTask();
}

void Alpha::functionTaskTask3 (void) {

	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1000 );
	int count;

		count = 0;
		UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 20)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}

		AS::TerminateTask();
}

void Alpha::functionTaskTask2 (void) {
	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1000 );
	int count;

		hw::hal::CPU::enable();
		
		count = 0;
		UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 5)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}

		AS::TerminateTask();
}
