#include "hw/hal/TCBBasic.h"

hw::hal::TCBBasic tcb1;
hw::hal::TCBBasic tcb2;

const int MAX_STACK = 256;

int start1 = 0;
int start2 = 0;
int switchto_before1 = 0;
int switchto_before2 = 0;
int switchto_after1 = 0;
int switchto_after2 = 0;

void* stack1[ MAX_STACK ];
void* stack2[ MAX_STACK ];

void cfHAL_THREADFUNC_ATTRIBUTES thread1( 
	hw::hal::TCBBasic* me 
	) 
{
	start1++;
	while( true ) {
		switchto_before1++;
		me->dispatch( &tcb2 );
		switchto_after1++;
	}
}

void cfHAL_THREADFUNC_ATTRIBUTES thread2( 
	hw::hal::TCBBasic* me 
	) 
{
	start2++;
	while( true ) {
		switchto_before2++;
		me->dispatch( &tcb1 );
		switchto_after2++;
	}
}


int main() {
	tcb1.init( &stack1[ MAX_STACK ], thread1 );
	tcb2.init( &stack2[ MAX_STACK ], thread2 );
	
	tcb1.go();

	return 0;		
}
