/** \author Christian Meier
 *  \version $Id: appcode.cpp 964 2009-03-26 21:21:25Z sichmeie $
 *
 *  This test sends a bunch of signals that have bit lengths from 1 to 8 bits
 *  and check them inside the ipdu from the TxIpduCallout.
 */

#include "appcode.h"
#include "as/AS.h"
#include "util/types.h"
#include "objects.h"
#include "stdio.h"
#include "string.h"

#include "os/com/ComStack_Types.h"

#include "AsCom_Cfg.h"

UInt8 TxSignal1 = ~0;
UInt8 TxSignal2 = ~0;
UInt8 TxSignal3 = ~0;
UInt8 TxSignal4 = ~0;
UInt8 TxSignal5 = ~0;
UInt8 TxSignal6 = ~0;
UInt8 TxSignal7 = ~0;
UInt8 TxSignal8 = ~0;

TASKDEF(Alpha,MainTask) {
	AS::Com_TxIpduGroupStart(ASCOM_TX_IPDU_GROUP_TEST, true);

	AS::Com_SendSignal(ASCOM_TX_SIGNAL_1BIT,  &TxSignal1);
	TxSignal1 = 0;
	AS::Com_SendSignal(ASCOM_TX_SIGNAL_1BIT,  &TxSignal1);

	AS::Com_SendSignal(ASCOM_TX_SIGNAL_2BIT,  &TxSignal2);
	TxSignal2 = 0;
	AS::Com_SendSignal(ASCOM_TX_SIGNAL_2BIT,  &TxSignal2);

	AS::Com_SendSignal(ASCOM_TX_SIGNAL_3BIT,  &TxSignal3);
	TxSignal3 = 0;
	AS::Com_SendSignal(ASCOM_TX_SIGNAL_3BIT,  &TxSignal3);

	AS::Com_SendSignal(ASCOM_TX_SIGNAL_4BIT,  &TxSignal4);
	TxSignal4 = 0;
	AS::Com_SendSignal(ASCOM_TX_SIGNAL_4BIT,  &TxSignal4);

	AS::Com_SendSignal(ASCOM_TX_SIGNAL_5BIT,  &TxSignal5);
	TxSignal5 = 0;
	AS::Com_SendSignal(ASCOM_TX_SIGNAL_5BIT,  &TxSignal5);

	AS::Com_SendSignal(ASCOM_TX_SIGNAL_6BIT,  &TxSignal6);
	TxSignal6 = 0;
	AS::Com_SendSignal(ASCOM_TX_SIGNAL_6BIT,  &TxSignal6);

	AS::Com_SendSignal(ASCOM_TX_SIGNAL_7BIT,  &TxSignal7);
	TxSignal7 = 0;
	AS::Com_SendSignal(ASCOM_TX_SIGNAL_7BIT,  &TxSignal7);

	AS::Com_SendSignal(ASCOM_TX_SIGNAL_8BIT,  &TxSignal8);
	TxSignal8 = 0;
	AS::Com_SendSignal(ASCOM_TX_SIGNAL_8BIT,  &TxSignal8);

	AS::TerminateTask();
}

UInt8 TxCounter = 0;

UInt8 SduComp[][5] = {
	{0x01,0x00,0x00,0x00,0x00},
	{0x00,0x00,0x00,0x00,0x00},

	{0x06,0x00,0x00,0x00,0x00},
	{0x00,0x00,0x00,0x00,0x00},

	{0x38,0x00,0x00,0x00,0x00},
	{0x00,0x00,0x00,0x00,0x00},

	{0xC0,0x03,0x00,0x00,0x00},
	{0x00,0x00,0x00,0x00,0x00},

	{0x00,0x7C,0x00,0x00,0x00},
	{0x00,0x00,0x00,0x00,0x00},

	{0x00,0x80,0x1F,0x00,0x00},
	{0x00,0x00,0x00,0x00,0x00},

	{0x00,0x00,0xE0,0x0F,0x00},
	{0x00,0x00,0x00,0x00,0x00},

	{0x00,0x00,0x00,0xF0,0x0F},
	{0x00,0x00,0x00,0x00,0x00}
};

Bool DefaultTxIpduCallout(os::com::PduIdType PduId, UInt8 const * SduPtr) {
	if (memcmp (SduPtr, SduComp[TxCounter++], 5)) {
		printf ("Check failed!\r\n");
	}
	return true;
}
