#include "ciaoConfig.h"
#include "appcode.h"
#include "objects.h"

#include "as/AS.h"
#include "stdio.h"

#include "messageport_objects.h"

#include <tc1796b/stm.h>

struct A::tt0  A::timesT0;
struct B::tt1  B::timesT1;

void A::functionTaskT0() {
	static int message_data=0;
	int o_i = message_data;
	printf("T0 start\r\n");

	while(message_data<10) {

		timesT0.all_start = STM_TIM0.reg;
		int *msg = MyMsgPort_sender.allocateMessage();
		timesT0.all_end = STM_TIM0.reg;
		timesT0.all_diff = timesT0.all_end-timesT0.all_start;
	
		if(msg) {
			printf("T0 allocated Msg 0x%x\r\n", msg);
			*msg = message_data++;
	
			timesT0.send_start = STM_TIM0.reg;
			MyMsgPort_sender.sendMessage(msg);
			timesT0.send_end = STM_TIM0.reg;
			timesT0.send_diff = timesT0.all_end-timesT0.all_start;
		} else {
			break;
		}
	}

	if(message_data != o_i) {
		printf("T0 Activate Consumer\r\n");
		AS::ActivateTask(T1);
	}

	printf("T0 term\r\n");
	AS::TerminateTask();
}

void B::functionTaskT1() {
	int *msg;
		
	printf("T1 start\r\n");

	while( 1 ) {
		timesT1.rcv_start = STM_TIM0.reg;
		msg = MyMsgPort_receiver.receiveMessage();
		timesT1.rcv_end = STM_TIM0.reg;
		timesT1.rcv_diff = timesT1.rcv_end-timesT1.rcv_start;

		if(msg == NULL) break;

		printf("Received Message 0x%x\r\n", msg); 

		timesT1.rel_start = STM_TIM0.reg;
		MyMsgPort_receiver.releaseMessage(msg);
		timesT1.rel_end = STM_TIM0.reg;
		timesT1.rel_diff = timesT1.rel_end-timesT1.rel_start;
	}

	AS::ActivateTask(T0);
	printf("T1 term\r\n");
	AS::TerminateTask();
}

