#include "appcode.h"
#include "as/AS.h"
#include "objects.h"

#define FROM(FROMID) asm volatile("FROM_" FROMID ":");
#define TO(TOID) asm volatile("TO_" TOID ":");
#define EXLINE __attribute__((noinline))

void delay()
{
	volatile int i = 0;
	while (i < 50) i++;
}

void hundredNOPs();

volatile int mode = 0;

void Alpha::functionTaskTask2()
{
	TO("2")
	TO("4")


	if (mode == 0) {
		delay();

		// CASE_1: ActivateTask() w/o dispatch
		FROM("1")
		AS::ActivateTask(Task1);
		TO("1")

		delay();
	}

	delay();

	mode = (mode == 0) ? 1 : 0;

	delay();

	AS::TerminateTask(); /* dispatches Task1 or returns, respectively */
}

void Alpha::functionTaskTask1()
{
	delay();

	// CASE_2: ActivateTask() w/ dispatch, until first instruction of dispatched task
	FROM("2")
	AS::ActivateTask(Task2);

	delay();

	// CASE_5: GetResource()
	FROM("5")
	AS::GetResource(Resource1);
	TO("5")

	delay();

	// CASE_6: ReleaseResource() w/o dispatch
	FROM("6")
	AS::ReleaseResource(Resource1);
	TO("6")

	delay();

	AS::GetResource(Resource2);

	delay();

	AS::ActivateTask(Task3);

	delay();

	// CASE_7: ReleaseResource() w/ dispatch, until first instruction of dispatched task
	FROM("7")
	AS::ReleaseResource(Resource2);
	TO("3")

	delay();

	// CASE_4: ChainTask() w/ dispatch, until first instruction of dispatched task
	FROM("4")
	AS::ChainTask(Task2);
}

void Alpha::functionTaskTask3()
{
	TO("7")

	delay();

	hundredNOPs();

	delay();

	// CASE_3: TerminateTask() w/ dispatch, until first instruction of previously running task
	FROM("3")
	AS::TerminateTask();
}

EXLINE void hundredNOPs()
{
	// CASE_8: 100 NOPs in a row
	FROM("8")
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	asm volatile("nop");
	TO("8")
}
