#include "appcode.h"
#include "as/AS.h"
#include "objects.h"
#include "stdio.h"

TASKDEF (Alpha,Task0) {
	printf ("Task0 starting...\r\n");
	printf ("Task0 activating Task1.\r\n");
	AS::ActivateTask (Task1);
	printf ("Task0 scheduling.\r\n");
	AS::Schedule ();
	printf ("Task0 ending...\r\n");
	AS::TerminateTask ();
}

TASKDEF (Beta, Task1) {
	static Bool chain = true;
	TaskType taskid;
	TaskStateType state;
	
	printf ("Task1 starting...\r\n");
	AS::GetTaskID (taskid);
	AS::GetTaskState (Task0, state);
	printf ("Task1: ID %i, state of Task0 %i.\r\n", taskid, state);
	
	if (chain) {
		chain = false;
		printf ("Task1 chaining itself...\r\n");
		AS::ChainTask (Task1);
	} else {
		printf ("Task1 ending...\r\n");
		AS::TerminateTask ();
	}
}

ISRDEF (Alpha,TimerISR) {
	AS::ActivateTask (Task1);
}
