// $Id: main.cpp 483 2007-07-27 08:18:39Z siwahofe $
// Created: 2007-08-04 siwahofe

#include "as/autosar_types.h"

#include "os/krn/Task.h"
#include "os/krn/AppMode.h"

#include "os/krn/OSControl.h"

// generated by the OIL generator {

const TaskType Task0 = 0;
const TaskType Task1 = 1;

void functionTaskTask0 (void);
void functionTaskTask1 (void);

namespace os { namespace krn {

	const unsigned int STACKSIZE = 128;
	UInt32 stack0 [STACKSIZE];
	UInt32 stack1 [STACKSIZE];
	
	Task theTasks [] = {
		// priority, state, function, stack, interrupted, current activations, max activations
		{3, Task::SUSPENDED, functionTaskTask0, & stack0 [STACKSIZE], false, 0, 2}, // Task0
		{5, Task::SUSPENDED, functionTaskTask1, & stack1 [STACKSIZE], false, 0, 2} // Task1
	};

	AppMode theAppModes [] = {
		// autostarted tasks
		{(1 << Task0)} // OSDEFAULTAPPMODE
	};
}} // os::krn

// can be overwritten by user specific main (),
// which must call StartOS () at the end
int CIAO_WEAK main () {
	os::krn::OSControl::Inst ().startOS (OSDEFAULTAPPMODE);

	return 0;
}

// user code
#include "stdio.h"
#include "as/autosar_macros.h"
#include "as/AS.h"

DeclareTask (Task0);
DeclareTask (Task1);

TASK (Task0) {
	static Bool first_time = true;
	StatusType ret;

	printf ("Task0 starting...\r\n");
	if (first_time) {
		printf ("Task0 activating itself.\r\n");
		ret = AS::ActivateTask (Task0);
		printf ("Task0 return value: %i.\r\n", ret);
		printf ("Task0 activating itself.\r\n");
		ret = AS::ActivateTask (Task0);
		printf ("Task0 return value: %i.\r\n", ret);
		first_time = false;
	}
	printf ("Task0 activating Task1.\r\n");
	ret = AS::ActivateTask (Task1);
	printf ("Task0 return value: %i.\r\n", ret);
	printf ("Task0 activating Task1.\r\n");
	ret = AS::ActivateTask (Task1);
	printf ("Task0 return value: %i.\r\n", ret);
	printf ("Task0 activating Task1.\r\n");
	ret = AS::ActivateTask (Task1);
	printf ("Task0 return value: %i.\r\n", ret);
	printf ("Task0 scheduling.\r\n");
	AS::Schedule ();
	printf ("Task0 ending...\r\n");
	AS::TerminateTask ();
}

TASK (Task1) {
	static int run = 0;
	TaskType taskid;
	TaskStateType state;

	run++;
	
	printf ("Task1 starting (run %i)...\r\n", run);
	AS::GetTaskID (taskid);
	AS::GetTaskState (Task0, state);
	printf ("Task1: ID %i, state of Task0 %i.\r\n", taskid, state);
	
	printf ("Task1 ending...\r\n");
	AS::TerminateTask ();
}
