#include "appcode.h"
#include "stdio.h"
#include "stdint.h"
#include "as/AS.h"
#include "uip.h"
#include "uip_arp.h"
#include "hw/dev/P4.h"
#include "hw/dev/LAN91.h"

#define BUF ((struct uip_eth_hdr *)&uip_buf[0])

/* Mac adress definition for enc28j60 */
#define ETHADDR0     0x00
#define ETHADDR1     0x02
#define ETHADDR2     0x3f
#define ETHADDR3     0x17
#define ETHADDR4     0xd5
#define ETHADDR5     0x60
/* Mac adress definition for uip */
#define UIP_ETHADDR0    ETHADDR0
#define UIP_ETHADDR1    ETHADDR1
#define UIP_ETHADDR2    ETHADDR2
#define UIP_ETHADDR3    ETHADDR3
#define UIP_ETHADDR4    ETHADDR4
#define UIP_ETHADDR5    ETHADDR5

void A::functionTaskT1(void) {
//	unsigned char buf[110];
	uip_ipaddr_t ipaddr;
	printf("Task A::T1: started\n");
	hw::dev::LAN91::NicInit();
	printf("Task A::T1: NicCompleted\n");

	uip_init();

	uip_ipaddr(ipaddr, 192,168,10,2);
	uip_sethostaddr(ipaddr);

	beamer_httpd_init();

	struct uip_eth_addr mac = {{UIP_ETHADDR0, UIP_ETHADDR1, UIP_ETHADDR2, UIP_ETHADDR3, UIP_ETHADDR4, UIP_ETHADDR5}};
	uip_setethaddr(mac);

	while ( 1 ) {
		while ( (uip_len = hw::dev::LAN91::network_read()) > 0 ) {
			if(uip_len > 0) {
				if(BUF->type == htons(UIP_ETHTYPE_IP)){
					uip_arp_ipin();
					uip_input();
					if(uip_len > 0) {
						uip_arp_out();
						hw::dev::LAN91::network_send();
					}
				} else if(BUF->type == htons(UIP_ETHTYPE_ARP)){
					uip_arp_arpin();
					if(uip_len > 0){
						hw::dev::LAN91::network_send();
					}
				}
			}
		}
	}

	AS::TerminateTask();
}

