#include "appcode.h"
#include "stdio.h"
#include "stdint.h"
#include "as/AS.h"
#include "hw/dev/LAN91.h"
#include "ethernet.h"
#include "message.h"
#include "arptable.h"
#include "mailbox.h"
#include "objects.h"

/* Mac adress definition for enc28j60 */
#define ETHADDR0     0x00
#define ETHADDR1     0x02
#define ETHADDR2     0x3f
#define ETHADDR3     0x17
#define ETHADDR4     0xd5
#define ETHADDR5     0x60
/* Mac adress definition for uip */
#define UIP_ETHADDR0    ETHADDR0
#define UIP_ETHADDR1    ETHADDR1
#define UIP_ETHADDR2    ETHADDR2
#define UIP_ETHADDR3    ETHADDR3
#define UIP_ETHADDR4    ETHADDR4
#define UIP_ETHADDR5    ETHADDR5

static os::net::Message msg;

struct os::msg::message A::msgPool[10];
uint8_t A::buffer[10*10];
struct os::msg::senderData A::sender = {A::msgPool, 10, 10, A::buffer, 1};

struct os::msg::receiverData B::receiver = { 0 };

os::msg::SenderPort A::senderPort = {&A::sender, &B::receiver};
os::msg::ReceiverPort B::receiverPort = {&A::sender, &B::receiver};

void A::functionTaskT1(void) {
	uint16_t len; 
	printf("Task A::T1: started\n");
	hw::dev::LAN91::NicInit();
	printf("Task A::T1: NicCompleted\n");

	os::net::Arptable::Init();

	while ( 1 ) {
		if ( (len = hw::dev::LAN91::NicGetPacket((char *)&msg)) > 0 ) {
			msg.size = len;
			printf("Start packet (%d) processing\n", len);
			os::net::Ethernet::Input(msg);
			printf("End packet processing\n");
			AS::ActivateTask(T2);
			// os::net::Ethernet::Output(0x0806, NULL, msg);
		}
	}

	AS::TerminateTask();
}


void B::functionTaskT2(void) {
	os::msg::msgId_t msgId = B::receiverPort.recvMsg();
	printf("B::getMsg() returned: %d\n", msgId);
	if ( msgId > 0 ) {
		B::receiverPort.releaseMsg(msgId);
	}
	AS::TerminateTask();
}
