#include "mailbox.h"

namespace os { namespace msg {

	uint8_t SenderPort::getMsg() {
		uint8_t pos = this->sender->nextMessageId%this->sender->msgCount; // Calc position in buffer 

		if ( this->sender->verwalt[pos].state == message::MSGFREE ||
		     ( this->sender->verwalt[pos].state == message::MSGSENT &&
		       this->sender->verwalt[pos].id <= this->receiver->readId ) ) {
			this->sender->verwalt[pos].id = this->sender->nextMessageId;
			this->sender->verwalt[pos].state = message::MSGALLOCED;

			this->sender->nextMessageId = this->sender->nextMessageId+1;
			return this->sender->verwalt[pos].id;
		}

		return 0;
	}

	uint8_t* SenderPort::getMsgData(uint8_t id) {
		return (this->sender->data+(this->sender->msgSize*(id%this->sender->msgCount)));
	}

	void SenderPort::sendMsg(uint8_t id) {
		uint8_t pos = id%this->sender->msgCount;
		if ( this->sender->verwalt[pos].state == message::MSGALLOCED ) {
			this->sender->verwalt[pos].state = message::MSGSENT;
		}
	}

	uint8_t ReceiverPort::recvMsg() {
		uint8_t pos = ((this->receiver->readId+1)%this->sender->msgCount);
		if ( this->sender->verwalt[pos].state == message::MSGSENT) {
			return this->receiver->readId+1;
		}
		return 0;
	}

	uint8_t* ReceiverPort::getMsgData(uint8_t id) {
		return (this->sender->data+(this->sender->msgSize*(id%this->sender->msgCount)));
	}

	void ReceiverPort::releaseMsg(uint8_t id) {
		this->receiver->readId++;
	}

}};
