SECTIONS {
  /*************************************
   * CiAO: App Code
   *************************************/
  .text.App0 : {
  	NTCODE_BEGIN = . ;
    App0CODE_BEGIN = . ;
    *(.text._ZN1A*)
    *(.text._ZN1C*)    
  } > ext_cram
  App0CODE_END = . ;
  App1CODE_BEGIN = . ;
  .text.App1 : {
    *(.text._ZN1B*)
  } > ext_cram
  App1CODE_END = . ;
  NTCODE_END = .;

  /*************************************
   * CiAO: Trusted Apps Code
   *************************************/
  TCODE_BEGIN = . ;
  App2CODE_BEGIN = . ;
  .text.App2 : {
    *(.text._ZN1D*)
  } > ext_cram
  App2CODE_END = . ;

  /*************************************
   * CiAO: OS Code
   *************************************/
   OSCODE_BEGIN = . ;
   .text.os : {
   	  *(.text._ZN2os*)
   } > ext_cram   
   OSCODE_END = . ;
   TCODE_END = . ;
   
  /*************************************
   * CiAO: App Data
   *************************************/
  .data.App0 : {
  	NTDATA_BEGIN = . ;
  	App0DATA_BEGIN = . ; 
    *(.data._ZN1A5inst_E)
    *(.data._ZN1C5inst_E)    
  } > ext_dram  
  .bss.App0 	(NOLOAD) : {
    *(.bss._ZN1A5inst_E)
    *(.bss._ZN1C5inst_E)    
  } > ext_dram
  App0TASKDATA_BEGIN = . ;
  .data.Task0_locals : {
    *(.data._ZZN1A17functionTaskTask0Ev*)
  } > ext_dram  
  .bss.Task0_locals 	(NOLOAD) : {
    *(.bss._ZZN1A17functionTaskTask0Ev*)
  } > ext_dram  
  Task0STACK_BEGIN = . ;
  .bss.Task0_stack 	(NOLOAD) : {
    *(.bss.task0_stack)
  } > ext_dram  
  Task2STACK_BEGIN = . ;
  .bss.Task2_stack 	(NOLOAD) : {
    *(.bss.task2_stack)
  } > ext_dram  
  App0DATA_END = . ;
  App1DATA_BEGIN = . ;
  .data.App1 : {
    *(.data._ZN1B5inst_E)
  } > ext_dram  
  .bss.App1 	(NOLOAD) : {
    *(.bss._ZN1B5inst_E)
  } > ext_dram
  App1TASKDATA_BEGIN = . ;
  Task1STACK_BEGIN = . ;
  .bss.Task1_stack 	(NOLOAD) : {
    *(.bss.task1_stack)
  } > ext_dram    
  App1DATA_END = . ;
  NTDATA_END = . ;

  /*************************************
   * CiAO: Trusted Apps Data
   *************************************/
  TDATA_BEGIN = . ;
  App2DATA_BEGIN = . ;
  .data.App2 : {
    *(.data._ZN1D5inst_E)
  } > ext_dram  
  .bss.App2 	(NOLOAD) : {
    *(.bss._ZN1D5inst_E)
  } > ext_dram
  App2TASKDATA_BEGIN = . ;
  Task3STACK_BEGIN = . ;
  .bss.Task3_stack 	(NOLOAD) : {
    *(.bss.task3_stack)
  } > ext_dram    
  App2DATA_END = . ;


  /*************************************
   * CiAO: OS Data
   *************************************/
   OSDATA_BEGIN = . ;
   .data.os : {
   	  *(.data._ZN2os*)
   } > ext_dram   
   .bss.os 		(NOLOAD) : {
   	  *(.bss._ZN2os*)
   } > ext_dram
   OSDATA_END = . ;
   TDATA_END = . ;
   
}
