#include "hw/hal/MPU.h"
#include "os/App.h"
#include "os/krn/Task.h"
#include "UCInfo.h"
#include "as/autosar_types.h"
#include "autosar.h"
#include "os/krn/AppMode.h"
#include "cfInitializers.h"

//usercode includes
#include "usercode1.h"

extern void* NTDATA_BEGIN;
extern void* NTDATA_END;
extern void* NTCODE_BEGIN;
extern void* NTCODE_END;
extern void* App0DATA_BEGIN;
extern void* App0DATA_END;
extern void* App0CODE_BEGIN;
extern void* App0CODE_END;
extern void* App1DATA_BEGIN;
extern void* App1DATA_END;
extern void* App1CODE_BEGIN;
extern void* App1CODE_END;
extern void* App2DATA_BEGIN;
extern void* App2DATA_END;
extern void* App2CODE_BEGIN;
extern void* App2CODE_END;

namespace os {

App theApps[] = {
APP_INITIALIZER(false, (hw::hal::MPU::addr) &App0DATA_BEGIN, (hw::hal::MPU::addr) &App0DATA_END,
		(hw::hal::MPU::addr) &App0CODE_BEGIN, (hw::hal::MPU::addr) &App0CODE_END),
APP_INITIALIZER(false, (hw::hal::MPU::addr) &App1DATA_BEGIN, (hw::hal::MPU::addr) &App1DATA_END,
		(hw::hal::MPU::addr) &App1CODE_BEGIN, (hw::hal::MPU::addr) &App1CODE_END),
//could all be 0, as App3 is trusted
APP_INITIALIZER(true,  (hw::hal::MPU::addr) &App2DATA_BEGIN, (hw::hal::MPU::addr) &App2DATA_END,
		(hw::hal::MPU::addr) &App2CODE_BEGIN, (hw::hal::MPU::addr) &App2CODE_END)
		};

namespace krn {
const int STACK = 64;
UInt32 task0_stack[ STACK ];
UInt32 task1_stack[ STACK ];
UInt32 task2_stack[ STACK ];
UInt32 task3_stack[ STACK ];

		
	Task theTasks[] = {
		TASK_INITIALIZER(0,SUSPENDED,A::functionTaskTask0,&os::krn::task0_stack[STACK],0,0,
						 0,(unsigned) sizeof stack0,0,1,0,0,0,os::krn::task0_stack), 
		TASK_INITIALIZER(1,SUSPENDED,B::functionTaskTask1,&os::krn::task1_stack[STACK],0,1,
						 1,(unsigned) sizeof stack1,0,1,0,0,0,os::krn::task1_stack), 
		TASK_INITIALIZER(2,SUSPENDED,A::functionTaskTask2,&os::krn::task2_stack[STACK],0,0,
						 2,(unsigned) sizeof stack2,0,1,0,0,0,os::krn::task2_stack), 
		TASK_INITIALIZER(3,SUSPENDED,D::functionTaskTask3,&os::krn::task3_stack[STACK],0,2,
						 3,(unsigned) sizeof stack3,0,1,0,0,0,os::krn::task3_stack)
	};

	AppMode theAppModes [] = {
		// autostarted tasks
		{(1 << 3)} // DefaultAppMode
	};

}}

int main() {
	StartOS (0);
	_debug();
}
