#include <tut.h>
#include "mem/StaticAllocator.h"
#include <iostream>


namespace tut
{
  // Data used by each test
  struct static_allocator_basic
  { 
  	enum{SIZE=3};
  	typedef int value_t;
	typedef StaticAllocator<value_t,SIZE> A0;
	typedef StaticAllocator<value_t,SIZE,1> A1;
	static value_t* test_memloc ;
    A0 alloc_0;
  };

  // Test group registration
  typedef test_group<static_allocator_basic> factory;
  typedef factory::object object;
}

namespace
{
  tut::factory tf("static allocator basic operations");
}

namespace tut
{
	
   /**
   * Checks used operation
   */
  template<>
  template<>
  void object::test<1>()
  {
    ensure("no used memomry locations",alloc_0.used()==0);
  }
  
  /**
   * Checks allocate and free operation
   */
  template<>
  template<>
  void object::test<2>()
  {
    value_t* a=static_cast<value_t*>(alloc_0.allocate());
    ensure("1 used memory location",alloc_0.used() == 1);
    *a=100;
    alloc_0.free(a);
    ensure("no used memory locations",alloc_0.used() == 0);
  }
  
  
  /**
   * Checks freeing in different order than allocating
   */
  template<>
  template<>
  void object::test<3>()
  {
  	value_t* ary[SIZE];
  	
  	for(int i=0;i<SIZE;i++){
  		ary[i]=static_cast<value_t*>(alloc_0.allocate());
  	}
  	ensure("allocate returns 0",alloc_0.allocate() ==0);
  	ensure("memory location are all used" ,alloc_0.used()==A0::SIZE);
  	
  	for(int i=0;i<SIZE;i++){
  		alloc_0.free(ary[i]);
  	}
  	ensure("no used memory locations",alloc_0.used() == 0);
  }

}
