<?xml version="1.0" encoding="UTF-8" ?>

<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:cm="http://www.pure-systems.com/consul/model"
  xmlns:xmlts="http://www.pure-systems.com/xmlts"
  xmlns:path="http://www.pure-systems.com/path"
  extension-element-prefixes="xmlts path"
  exclude-result-prefixes="cm">

  <!-- generate xml output -->
  <xsl:output method="text"/>

  <!-- redefine built-in template for text and attributes -->
  <!-- to avoid untreated text to be printed              -->
  <xsl:template match="text()|@*"/>

  <!-- match root node -->
  <xsl:template match="/">
    <!-- get the results of previous modules for the context node -->
    <xsl:for-each select="xmlts:results-for()//actionlist/action[@type='file.copy']">
      <!-- build and print full path to source file -->
      <xsl:value-of select="path:add-part(parameter[@name='src.path'],parameter[@name='src.file'])"/>
      <!-- print a newline -->
      <xsl:text>&#10;</xsl:text> 
      <!-- build and print full path to destination file -->
      <xsl:value-of select="path:add-part(parameter[@name='dest.path'],parameter[@name='dest.file'])"/>
      <!-- print a newline -->
      <xsl:text>&#10;</xsl:text> 
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
