<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
version="1.0">
  <xsl:output method="xml" indent="yes"/>
  <xsl:strip-space elements="*" />
  
  <xsl:key name="HwObjectDummyKey" match="//Can/Module/RxHwObject | //Can/Module/TxHwObject" use="@HwObjectDummyId" />
  <xsl:template match="//CanIf/RxLpdu | //CanIf/TxLpdu">
	<xsl:copy>
	  <xsl:apply-templates select="@*[name(.) != 'HwObjectDummyRef']"/>
	  <xsl:attribute name="HwObjectRef">
		 <xsl:value-of select="key('HwObjectDummyKey', @HwObjectDummyRef)/@ObjId" />
	  </xsl:attribute>
	  <xsl:apply-templates select="node()" />
	</xsl:copy>
  </xsl:template>
  <xsl:template match="//Can/Module/TxHwObject">
	<xsl:copy>
	  <xsl:apply-templates select="@*[name(.) != 'HwObjectDummyId'] | node()[(name()!='StandardCanId') and (name() !='ExtendedCanId')]" />
	</xsl:copy>
  </xsl:template>
  <xsl:template match="//Can/Module/RxHwObject">
	<xsl:copy>
	  <xsl:apply-templates select="@*[name(.) != 'HwObjectDummyId'] | node()" />
	</xsl:copy>
  </xsl:template>
  <xsl:template match="@*|node()">
	<xsl:copy>
	  <xsl:apply-templates select="@*|node()"/>
	</xsl:copy>
  </xsl:template>
</xsl:stylesheet>
